<?php // -*- coding:utf-8 -*-
// Parameters:

// lang=xx    : only tranlates language 'xx',
//              if not given all languages are translated

// comments   : generate all comments (equal to close&module)

// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made

// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)

// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer

// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)

// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)

// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate language 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate language 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release 


$lang=Array(
// ### Start of unused words
// ### Please remove manually!
// ### N.B. Legitimate strings may be marked// ### as unused!
// ### Please see http://tikiwiki.org/tiki-index.php?page=UnusedWords for further info
"the background color, use #rrvvbb color types.\n" => "the background colour, use #rrvvbb colour types.\n",
"color of the border\n" => "colour of the border\n",
"background color of the node\n" => "background colour of the node\n",
"color for links (called edges here)\n" => "colour for links (called edges here)\n",
"Will display using the indicated HTML color" => "Will display using the indicated HTML colour",
"\n<b>Note 1</b>: if you allow your users to configure modules then assigned\nmodules won't be reflected in the screen until you configure them\nfrom MyTiki->modules.<br />\n<b>Note 2</b>: If you assign modules to groups make sure that you\nhave turned off the option 'display modules to all groups always'\nfrom Admin->General\n" => "\n<b>Notes</b>\n<ul><li>If you allow your users to configure modules then assigned modules won't be reflected in the screen until you configure them from MyTiki->modules.</li><li>If you assign modules to groups make sure that you have turned off the option 'display modules to all groups always' from Admin->General.",
"DATE-of" => "of",
// ### end of unused words

// ### start of untranslated words
// ### uncomment value pairs as you translate
// "This feature is disabled" => "This feature is disabled",
// "Permission denied you cannot view pages" => "Permission denied you cannot view pages",
// "Cannot write to this file:" => "Cannot write to this file:",
// "Cannot upload this file maximum upload size exceeded" => "Cannot upload this file maximum upload size exceeded",
// "Your post has not been posted" => "Your post has not been posted",
// "Cookies must be allowed to vote" => "Cookies must be allowed to vote",
// "Re:" => "Re:",
// "You have mistyped the anti-bot verification code; please try again." => "You have mistyped the anti-bot verification code; please try again.",
// "This forum is flat and doesn't allow replies to other replies" => "This forum is flat and doesn't allow replies to other replies",
// "Missing title or body when trying to post a comment" => "Missing title or body when trying to post a comment",
// "A contribution is mandatory" => "A contribution is mandatory",
// "You do not have permission to use this feature" => "You do not have permission to use this feature",
// "This script cannot be called directly" => "This script cannot be called directly",
// "The copyright management feature is not enabled." => "The copyright management feature is not enabled.",
// "Copyright management" => "Copyright management",
// "No page indicated" => "No page indicated",
// "You must supply all the information, including title and year." => "You must supply all the information, including title and year.",
// "This feature is for admins only" => "This feature is for admins only",
// "ID" => "ID",
// "Type" => "Type",
// "Name" => "Name",
// "Description" => "Description",
// "Size" => "Size",
// "Created" => "Created",
// "Uploaded" => "Uploaded",
// "Last Modified" => "Last Modified",
// "Creator" => "Creator",
// "Author" => "Author",
// "Last editor" => "Last editor",
// "Comment" => "Comment",
// "Files" => "Files",
// "Hits" => "Hits",
// "Locked by" => "Locked by",
// "Explorer" => "Explorer",
// "Path" => "Path",
// "The text in RED is" => "The text in RED is",
// "character(s) too long - please edit it." => "character(s) too long - please edit it.",
// "Afghanistan" => "Afghanistan",
// "Aland Islands" => "Aland Islands",
// "Albania" => "Albania",
// "Algeria" => "Algeria",
// "American Samoa" => "American Samoa",
// "Andorra" => "Andorra",
// "Angola" => "Angola",
// "Anguilla" => "Anguilla",
// "Antarctica" => "Antarctica",
// "Antigua" => "Antigua",
// "Argentina" => "Argentina",
// "Armenia" => "Armenia",
// "Aruba" => "Aruba",
// "Australia" => "Australia",
// "Austria" => "Austria",
// "Azerbaijan" => "Azerbaijan",
// "Bahamas" => "Bahamas",
// "Bahrain" => "Bahrain",
// "Bangladesh" => "Bangladesh",
// "Barbados" => "Barbados",
// "Belarus" => "Belarus",
// "Belgium" => "Belgium",
// "Belize" => "Belize",
// "Benin" => "Benin",
// "Bermuda" => "Bermuda",
// "Bhutan" => "Bhutan",
// "Bolivia" => "Bolivia",
// "Bosnia and Herzegovina" => "Bosnia and Herzegovina",
// "Botswana" => "Botswana",
// "Bouvet Island" => "Bouvet Island",
// "Brazil" => "Brazil",
// "British Indian Ocean Territory" => "British Indian Ocean Territory",
// "British Virgin Islands" => "British Virgin Islands",
// "Brunei" => "Brunei",
// "Bulgaria" => "Bulgaria",
// "Burkina Faso" => "Burkina Faso",
// "Burundi" => "Burundi",
// "Cambodia" => "Cambodia",
// "Cameroon" => "Cameroon",
// "Canada" => "Canada",
// "Cape Verde" => "Cape Verde",
// "Catalan Countries" => "Catalan Countries",
// "Cayman Islands" => "Cayman Islands",
// "Central African Republic" => "Central African Republic",
// "Chad" => "Chad",
// "Chile" => "Chile",
// "China" => "China",
// "Christmas Island" => "Christmas Island",
// "Cocos Islands" => "Cocos Islands",
// "Colombia" => "Colombia",
// "Comoros" => "Comoros",
// "Congo" => "Congo",
// "Congo Democratic" => "Congo Democratic",
// "Cook Islands" => "Cook Islands",
// "Costa Rica" => "Costa Rica",
// "Croatia" => "Croatia",
// "Cuba" => "Cuba",
// "Cyprus" => "Cyprus",
// "Czech Republic" => "Czech Republic",
// "Denmark" => "Denmark",
// "Djibouti" => "Djibouti",
// "Dominica" => "Dominica",
// "Dominican Republic" => "Dominican Republic",
// "Ecuador" => "Ecuador",
// "Egypt" => "Egypt",
// "El Salvador" => "El Salvador",
// "Equatorial Guinea" => "Equatorial Guinea",
// "Eritrea" => "Eritrea",
// "Estonia" => "Estonia",
// "Ethiopia" => "Ethiopia",
// "Europe" => "Europe",
// "Falkland Islands" => "Falkland Islands",
// "Faroe Islands" => "Faroe Islands",
// "Federated States of Micronesia" => "Federated States of Micronesia",
// "Fiji" => "Fiji",
// "Finland" => "Finland",
// "France" => "France",
// "French Guiana" => "French Guiana",
// "French Polynesia" => "French Polynesia",
// "French Southern Territories" => "French Southern Territories",
// "Gabon" => "Gabon",
// "Gambia" => "Gambia",
// "Georgia" => "Georgia",
// "Germany" => "Germany",
// "Ghana" => "Ghana",
// "Gibraltar" => "Gibraltar",
// "Greece" => "Greece",
// "Greenland" => "Greenland",
// "Grenada" => "Grenada",
// "Guadeloupe" => "Guadeloupe",
// "Guam" => "Guam",
// "Guatemala" => "Guatemala",
// "Guernsey" => "Guernsey",
// "Guinea" => "Guinea",
// "Guinea Bissau" => "Guinea Bissau",
// "Guyana" => "Guyana",
// "Haiti" => "Haiti",
// "Heard Island and McDonald Islands" => "Heard Island and McDonald Islands",
// "Honduras" => "Honduras",
// "Hong Kong" => "Hong Kong",
// "Hungary" => "Hungary",
// "Iceland" => "Iceland",
// "India" => "India",
// "Indonesia" => "Indonesia",
// "Iran" => "Iran",
// "Iraq" => "Iraq",
// "Ireland" => "Ireland",
// "Isle of Man" => "Isle of Man",
// "Israel" => "Israel",
// "Italy" => "Italy",
// "Ivory Coast" => "Ivory Coast",
// "Jamaica" => "Jamaica",
// "Japan" => "Japan",
// "Jersey" => "Jersey",
// "Jordan" => "Jordan",
// "Kazakstan" => "Kazakstan",
// "Kenya" => "Kenya",
// "Kiribati" => "Kiribati",
// "Kuwait" => "Kuwait",
// "Kyrgyzstan" => "Kyrgyzstan",
// "Laos" => "Laos",
// "Latvia" => "Latvia",
// "Lebanon" => "Lebanon",
// "Lesotho" => "Lesotho",
// "Liberia" => "Liberia",
// "Libya" => "Libya",
// "Liechtenstein" => "Liechtenstein",
// "Lithuania" => "Lithuania",
// "Luxemburg" => "Luxemburg",
// "Macao" => "Macao",
// "Macedonia" => "Macedonia",
// "Madagascar" => "Madagascar",
// "Malawi" => "Malawi",
// "Malaysia" => "Malaysia",
// "Maldives" => "Maldives",
// "Mali" => "Mali",
// "Malta" => "Malta",
// "Marshall Islands" => "Marshall Islands",
// "Martinique" => "Martinique",
// "Mauritania" => "Mauritania",
// "Mauritius" => "Mauritius",
// "Mayotte" => "Mayotte",
// "Mexico" => "Mexico",
// "Moldova" => "Moldova",
// "Monaco" => "Monaco",
// "Mongolia" => "Mongolia",
// "Montenegro" => "Montenegro",
// "Montserrat" => "Montserrat",
// "Morocco" => "Morocco",
// "Mozambique" => "Mozambique",
// "Myanmar" => "Myanmar",
// "Namibia" => "Namibia",
// "Nauru" => "Nauru",
// "Nepal" => "Nepal",
// "Netherlands" => "Netherlands",
// "Netherlands Antilles" => "Netherlands Antilles",
// "New Caledonia" => "New Caledonia",
// "New Zealand" => "New Zealand",
// "Nicaragua" => "Nicaragua",
// "Niger" => "Niger",
// "Nigeria" => "Nigeria",
// "Niue" => "Niue",
// "None" => "None",
// "Norfolk Island" => "Norfolk Island",
// "Northern Mariana Islands" => "Northern Mariana Islands",
// "North Korea" => "North Korea",
// "Norway" => "Norway",
// "Oman" => "Oman",
// "Other" => "Other",
// "Pakistan" => "Pakistan",
// "Palau" => "Palau",
// "Palestine" => "Palestine",
// "Panama" => "Panama",
// "Papua New Guinea" => "Papua New Guinea",
// "Paraguay" => "Paraguay",
// "Peru" => "Peru",
// "Philippines" => "Philippines",
// "Pitcairn" => "Pitcairn",
// "Poland" => "Poland",
// "Portugal" => "Portugal",
// "Puerto Rico" => "Puerto Rico",
// "Quatar" => "Quatar",
// "Republic of Macedonia" => "Republic of Macedonia",
// "Reunion" => "Reunion",
// "Romania" => "Romania",
// "Russia" => "Russia",
// "Rwanda" => "Rwanda",
// "Saint Helena" => "Saint Helena",
// "Saint Kitts and Nevis" => "Saint Kitts and Nevis",
// "Saint Lucia" => "Saint Lucia",
// "Saint Pierre and Miquelon" => "Saint Pierre and Miquelon",
// "Samoa" => "Samoa",
// "San Marino" => "San Marino",
// "Sao Tome and Principe" => "Sao Tome and Principe",
// "Saudi Arabia" => "Saudi Arabia",
// "Senegal" => "Senegal",
// "Serbia" => "Serbia",
// "Seychelles" => "Seychelles",
// "Sierra Leone" => "Sierra Leone",
// "Singapore" => "Singapore",
// "Slovakia" => "Slovakia",
// "Slovenia" => "Slovenia",
// "Solomon Islands" => "Solomon Islands",
// "Somalia" => "Somalia",
// "South Africa" => "South Africa",
// "South Georgia and South Sandwich Islands" => "South Georgia and South Sandwich Islands",
// "South Korea" => "South Korea",
// "Spain" => "Spain",
// "Sri Lanka" => "Sri Lanka",
// "St Vincent Grenadines" => "St Vincent Grenadines",
// "Sudan" => "Sudan",
// "Surinam" => "Surinam",
// "Svalbard and Jan Mayen" => "Svalbard and Jan Mayen",
// "Swaziland" => "Swaziland",
// "Sweden" => "Sweden",
// "Switzerland" => "Switzerland",
// "Syria" => "Syria",
// "Taiwan" => "Taiwan",
// "Tajikistan" => "Tajikistan",
// "Tanzania" => "Tanzania",
// "Thailand" => "Thailand",
// "Timor-Leste" => "Timor-Leste",
// "Togo" => "Togo",
// "Tokelau" => "Tokelau",
// "Tonga" => "Tonga",
// "Trinidad Tobago" => "Trinidad Tobago",
// "Tunisia" => "Tunisia",
// "Turkey" => "Turkey",
// "Turkmenistan" => "Turkmenistan",
// "Turks and Caicos Islands" => "Turks and Caicos Islands",
// "Tuvalu" => "Tuvalu",
// "Uganda" => "Uganda",
// "Ukraine" => "Ukraine",
// "United Arab Emirates" => "United Arab Emirates",
// "United Kingdom" => "United Kingdom",
// "United Nations Organization" => "United Nations Organization",
// "United States" => "United States",
// "United States Minor Outlying Islands" => "United States Minor Outlying Islands",
// "Uruguay" => "Uruguay",
// "US Virgin Islands" => "US Virgin Islands",
// "Uzbekistan" => "Uzbekistan",
// "Vanuatu" => "Vanuatu",
// "Vatican" => "Vatican",
// "Venezuela" => "Venezuela",
// "Viet Nam" => "Viet Nam",
// "Wales" => "Wales",
// "Wallis and Futuna" => "Wallis and Futuna",
// "Western Sahara" => "Western Sahara",
// "World" => "World",
// "Yemen" => "Yemen",
// "Yugoslavia" => "Yugoslavia",
// "Zambia" => "Zambia",
// "Zimbabwe" => "Zimbabwe",
// "Arabic" => "Arabic",
// "Catalan" => "Catalan",
// "Simplified Chinese" => "Simplified Chinese",
// "Chinese" => "Chinese",
// "Czech" => "Czech",
// "Danish" => "Danish",
// "German" => "German",
// "English" => "English",
// "English British" => "English British",
// "Spanish" => "Spanish",
// "Greek" => "Greek",
// "Farsi" => "Farsi",
// "Finnish" => "Finnish",
// "Fijian" => "Fijian",
// "French" => "French",
// "Galician" => "Galician",
// "Hebrew" => "Hebrew",
// "Croatian" => "Croatian",
// "Italian" => "Italian",
// "Japanese" => "Japanese",
// "Korean" => "Korean",
// "Hungarian" => "Hungarian",
// "Dutch" => "Dutch",
// "Norwegian" => "Norwegian",
// "Polish" => "Polish",
// "Português" => "Português",
// "Brazilian Portuguese" => "Brazilian Portuguese",
// "Russian" => "Russian",
// "Pijin Solomon" => "Pijin Solomon",
// "Slovak" => "Slovak",
// "Serbian" => "Serbian",
// "Serbian Latin" => "Serbian Latin",
// "Swedish" => "Swedish",
// "Tuvaluan" => "Tuvaluan",
// "Traditional Chinese" => "Traditional Chinese",
// "Ukrainian" => "Ukrainian",
// "This instance of activity is already complete" => "This instance of activity is already complete",
// "Fatal error: cannot execute automatic activity \$activityId" => "Fatal error: cannot execute automatic activity \$activityId",
// "Fatal error: setting next activity to an unexisting activity" => "Fatal error: setting next activity to an unexisting activity",
// "Fatal error: nextActivity does not match any candidate in autorouting switch activity" => "Fatal error: nextActivity does not match any candidate in autorouting switch activity",
// "Fatal error: non-deterministic decision for autorouting activity" => "Fatal error: non-deterministic decision for autorouting activity",
// "Fatal error: trying to send an instance to an activity but no transition found" => "Fatal error: trying to send an instance to an activity but no transition found",
// "Cannot add transition only split activities can have more than one outbound transition" => "Cannot add transition only split activities can have more than one outbound transition",
// "Circular reference found some activity has a transition leading to itself" => "Circular reference found some activity has a transition leading to itself",
// "Process does not have a start activity" => "Process does not have a start activity",
// "Process does not have exactly one end activity" => "Process does not have exactly one end activity",
// "End activity is not reachable from start activity" => "End activity is not reachable from start activity",
// "Activity" => "Activity",
// " is interactive but has no role assigned" => " is interactive but has no role assigned",
// " is non-interactive and non-autorouted but has no role assigned" => " is non-interactive and non-autorouted but has no role assigned",
// " is standalone but has transitions" => " is standalone but has transitions",
// "Role" => "Role",
// " is not mapped" => " is not mapped",
// "Activity '.\$res['name'].' is standalone and is using the \$instance object" => "Activity '.\$res['name'].' is standalone and is using the \$instance object",
// "Activity '.\$res['name'].' is interactive so it must use the \$instance->complete() method" => "Activity '.\$res['name'].' is interactive so it must use the \$instance->complete() method",
// "Activity '.\$res['name'].' is non-interactive so it must not use the \$instance->complete() method" => "Activity '.\$res['name'].' is non-interactive so it must not use the \$instance->complete() method",
// "Activity '.\$res['name'].' is switch so it must use \$instance->setNextActivity(\$actname) method" => "Activity '.\$res['name'].' is switch so it must use \$instance->setNextActivity(\$actname) method",
// "Process %d has been activated" => "Process %d has been activated",
// "Process %d has been deactivated" => "Process %d has been deactivated",
// "Process %s %s imported" => "Process %s %s imported",
// "Process %s removed" => "Process %s removed",
// "Process %s has been updated" => "Process %s has been updated",
// "Process %s has been created" => "Process %s has been created",
// "Permission denied" => "Permission denied",
// "Template %s not registered" => "Template %s not registered",
// "The file is not a CSV file or has not a correct syntax" => "The file is not a CSV file or has not a correct syntax",
// "Error line: %d" => "Error line: %d",
// "locked" => "locked",
// "locked by" => "locked by",
// "Administration:" => "Administration:",
// "in" => "in",
// "continued" => "continued",
// "New Image Uploaded by" => "New Image Uploaded by",
// "New Subscriptions" => "New Subscriptions",
// "New Item in Tracker" => "New Item in Tracker",
// "tracker" => "tracker",
// "by" => "by",
// "Wiki" => "Wiki",
// "Image Gallery" => "Image Gallery",
// "Articles" => "Articles",
// "Blogs" => "Blogs",
// "Forums" => "Forums",
// "Directory" => "Directory",
// "File Gallery" => "File Gallery",
// "FAQs" => "FAQs",
// "Quizzes" => "Quizzes",
// "Trackers" => "Trackers",
// "Survey" => "Survey",
// "Newsletter" => "Newsletter",
// "Charts" => "Charts",
// "article" => "article",
// "blog" => "blog",
// "directory" => "directory",
// "faq" => "faq",
// "file gallery" => "file gallery",
// "forum" => "forum",
// "image gallery" => "image gallery",
// "newsletter" => "newsletter",
// "poll" => "poll",
// "quiz" => "quiz",
// "survey" => "survey",
// "wiki page" => "wiki page",
// "image" => "image",
// "calendar" => "calendar",
// "Cannot write to this file: " => "Cannot write to this file: ",
// "(not registered)" => "(not registered)",
// "Anonymous" => "Anonymous",
// "Use this thread to discuss the %s page." => "Use this thread to discuss the %s page.",
// "WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: line count mismatch: %s != %s",
// "WikiDiff::_check: failed" => "WikiDiff::_check: failed",
// "WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: edit sequence is non-optimal",
// "WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
// "Line:" => "Line:",
// "Lines:" => "Lines:",
// "Newsletter subscription information at " => "Newsletter subscription information at ",
// "Tiki Link - Insert internal link" => "Tiki Link - Insert internal link",
// "Select a Wiki page to link to:" => "Select a Wiki page to link to:",
// "Find" => "Find",
// "find" => "find",
// "prev" => "prev",
// "Page" => "Page",
// "next" => "next",
// "Link" => "Link",
// "Page name" => "Page name",
// "Cannot open this file:" => "Cannot open this file:",
// "Wiki Home" => "Wiki Home",
// "Home" => "Home",
// "Blog" => "Blog",
// "previous page" => "previous page",
// "next page" => "next page",
// "posted on" => "posted on",
// "Continue" => "Continue",
// "By:" => "By:",
// "Read" => "Read",
// "List articles" => "List articles",
// "Last post" => "Last post",
// "Invalid imagename (using filters for filenames)" => "Invalid imagename (using filters for filenames)",
// "Errors detected" => "Errors detected",
// "Upload was not successful" => "Upload was not successful",
// "No image yet, sorry." => "No image yet, sorry.",
// "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
// "unlink failed" => "unlink failed",
// "Contributions" => "Contributions",
// "Query point:" => "Query point:",
// "layer:" => "layer:",
// "Record:" => "Record:",
// "No valid ogr2ogr executable" => "No valid ogr2ogr executable",
// "Could not create \$tdo.mif in data directory" => "Could not create \$tdo.mif in data directory",
// "Could not create \$tdo.mid in data directory" => "Could not create \$tdo.mid in data directory",
// "unknown" => "unknown",
// "User Map Generated in:" => "User Map Generated in:",
// "Image Map Generated in:" => "Image Map Generated in:",
// "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it." => "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it.",
// "menu" => "menu",
// "NONE" => "NONE",
// "File %s not found" => "File %s not found",
// "File %s is not a valid archive" => "File %s is not a valid archive",
// "Impossible to open %s : %s" => "Impossible to open %s : %s",
// "The content retrieved at %s is not a list of mods" => "The content retrieved at %s is not a list of mods",
// "Can't chdir to '%s'" => "Can't chdir to '%s'",
// "%s impossible to remove" => "%s impossible to remove",
// "section edit" => "section edit",
// "This poll is closed." => "This poll is closed.",
// "Wiki top pages" => "Wiki top pages",
// "Most relevant pages" => "Most relevant pages",
// "Relevance" => "Relevance",
// "Wiki last pages" => "Wiki last pages",
// "Modified" => "Modified",
// "Forums last topics" => "Forums last topics",
// "Topic date" => "Topic date",
// "Forums last posts" => "Forums last posts",
// "Forums most read topics" => "Forums most read topics",
// "Reads" => "Reads",
// "Forums best topics" => "Forums best topics",
// "Score" => "Score",
// "Forums most visited forums" => "Forums most visited forums",
// "Visits" => "Visits",
// "Forums with most posts" => "Forums with most posts",
// "Posts" => "Posts",
// "Wiki top galleries" => "Wiki top galleries",
// "Wiki top file galleries" => "Wiki top file galleries",
// "Wiki top images" => "Wiki top images",
// "Wiki top files" => "Wiki top files",
// "Downloads" => "Downloads",
// "Wiki last images" => "Wiki last images",
// "Upload date" => "Upload date",
// "Wiki last files" => "Wiki last files",
// "Wiki top articles" => "Wiki top articles",
// "Most visited blogs" => "Most visited blogs",
// "Most active blogs" => "Most active blogs",
// "Blogs last posts" => "Blogs last posts",
// "Post date" => "Post date",
// "Wiki top authors" => "Wiki top authors",
// "Pages" => "Pages",
// "Top article authors" => "Top article authors",
// "The passwords do not match" => "The passwords do not match",
// "User already exists" => "User already exists",
// "Wrong registration code" => "Wrong registration code",
// "Invalid username" => "Invalid username",
// "Username is too long" => "Username is too long",
// "Username cannot contain whitespace" => "Username cannot contain whitespace",
// "Wrong passcode you need to know the passcode to register in this site" => "Wrong passcode you need to know the passcode to register in this site",
// "Invalid email address. You must enter a valid email address" => "Invalid email address. You must enter a valid email address",
// "The registration mail can't be sent. Contact the administrator" => "The registration mail can't be sent. Contact the administrator",
// "Feed provided by %s. Click to visit." => "Feed provided by %s. Click to visit.",
// "Login" => "Login",
// "See other user's profile" => "See other user's profile",
// "Have your profile seen" => "Have your profile seen",
// "Make friends" => "Make friends",
// "Receive message" => "Receive message",
// "Send message" => "Send message",
// "Read an article" => "Read an article",
// "Publish an article" => "Publish an article",
// "Have your article read" => "Have your article read",
// "Create new file gallery" => "Create new file gallery",
// "Upload new file to gallery" => "Upload new file to gallery",
// "Download other user's file" => "Download other user's file",
// "Have your file downloaded" => "Have your file downloaded",
// "Create a new image gallery" => "Create a new image gallery",
// "Upload new image to gallery" => "Upload new image to gallery",
// "See other user's gallery" => "See other user's gallery",
// "See other user's image" => "See other user's image",
// "Have your gallery seen by other user" => "Have your gallery seen by other user",
// "Have your image seen" => "Have your image seen",
// "Create new blog" => "Create new blog",
// "Post in a blog" => "Post in a blog",
// "Read other user's blog" => "Read other user's blog",
// "Have your blog read" => "Have your blog read",
// "Create a new wiki page" => "Create a new wiki page",
// "Edit an existing page" => "Edit an existing page",
// "Attach file" => "Attach file",
// "Tracker" => "Tracker",
// "Unknown" => "Unknown",
// "Trackeritem" => "Trackeritem",
// "Image" => "Image",
// "Article" => "Article",
// "Directory category" => "Directory category",
// "FAQ" => "FAQ",
// "Forum" => "Forum",
// "Gallery" => "Gallery",
// "File" => "File",
// "Blog post" => "Blog post",
// "Tracker item" => "Tracker item",
// "Simple" => "Simple",
// "Advanced" => "Advanced",
// "Fast Next" => "Fast Next",
// "Fast Prev" => "Fast Prev",
// "Prev" => "Prev",
// "Next" => "Next",
// "First {\$params['itemname']}" => "First {\$params['itemname']}",
// "Last {\$params['itemname']}" => "Last {\$params['itemname']}",
// "Next {\$params['itemname']}" => "Next {\$params['itemname']}",
// "Prev {\$params['itemname']}" => "Prev {\$params['itemname']}",
// "Help page:" => "Help page:",
// "View tpl:" => "View tpl:",
// "Edit Template" => "Edit Template",
// "Admin Feature" => "Admin Feature",
// "help" => "help",
// "All" => "All",
// "The text is" => "The text is",
// "Date Selector" => "Date Selector",
// "phplayers are not available on this site" => "phplayers are not available on this site",
// "Invert Sort" => "Invert Sort",
// "days" => "days",
// "day" => "day",
// "hours" => "hours",
// "hour" => "hour",
// "mins" => "mins",
// "min" => "min",
// "secs" => "secs",
// "sec" => "sec",
// "done" => "done",
// "Text cut here" => "Text cut here",
// "Task" => "Task",
// "from" => "from",
// "for" => "for",
// "Priority" => "Priority",
// "Start date:" => "Start date:",
// "End date:" => "End date:",
// "Friend" => "Friend",
// "km" => "km",
// "Last seen on " => "Last seen on ",
// "(idle for %s seconds)" => "(idle for %s seconds)",
// "User information - Click for more info" => "User information - Click for more info",
// "More info about \$other_user" => "More info about \$other_user",
// "(idle for \$idletime seconds)" => "(idle for \$idletime seconds)",
// "Use this tree to copy the structure" => "Use this tree to copy the structure",
// "created from structure" => "created from structure",
// "Table of contents" => "Table of contents",
// "unknown error" => "unknown error",
// "You are not logged in" => "You are not logged in",
// "Page cannot be found" => "Page cannot be found",
// "cannot be found" => "cannot be found",
// "An error occured in a database query!" => "An error occured in a database query!",
// "Help" => "Help",
// "You are banned from" => "You are banned from",
// "wiki" => "wiki",
// "img-g" => "img-g",
// "file-g" => "file-g",
// "faqs" => "faqs",
// "quizzes" => "quizzes",
// "arts" => "arts",
// "blogs" => "blogs",
// "forums" => "forums",
// "games" => "games",
// "picture not found" => "picture not found",
// "drawing not found" => "drawing not found",
// "Click to edit dynamic variable" => "Click to edit dynamic variable",
// "Update variables" => "Update variables",
// "Edit Section" => "Edit Section",
// "index" => "index",
// "Show" => "Show",
// "Hide" => "Hide",
// "You are not allowed to upload this type of file." => "You are not allowed to upload this type of file.",
// "The file you are trying upload was only partially uploaded." => "The file you are trying upload was only partially uploaded.",
// "You must select a file." => "You must select a file.",
// "Altering database table failed" => "Altering database table failed",
// "%d points" => "%d points",
// "Removed" => "Removed",
// "__WARNING__: No such module \$plugin! " => "__WARNING__: No such module \$plugin! ",
// "at" => "at",
// "new" => "new",
// "Create page:" => "Create page:",
// "Unknown language" => "Unknown language",
// "Click here to confirm your action" => "Click here to confirm your action",
// "Sea Surfing (CSRF) detected. Operation blocked." => "Sea Surfing (CSRF) detected. Operation blocked.",
// "Status:" => "Status:",
// "Upload was not successful. Duplicate file content ?" => "Upload was not successful. Duplicate file content ?",
// "(unchanged)" => "(unchanged)",
// "Item Modification" => "Item Modification",
// "Item" => "Item",
// "Item creation" => "Item creation",
// "Tracker was modified at " => "Tracker was modified at ",
// "Field is not numeric" => "Field is not numeric",
// "Field is not a link to mp3 in the gallery" => "Field is not a link to mp3 in the gallery",
// "Field is not a link to FLV in the gallery" => "Field is not a link to FLV in the gallery",
// "Field is not a link to FLV or MP3 in the gallery" => "Field is not a link to FLV or MP3 in the gallery",
// "text field" => "text field",
// "half column" => "half column",
// "size" => "size",
// "prepend" => "prepend",
// "append" => "append",
// "max" => "max",
// "Text options: 1,size,prepend,append,max with size in chars, prepend will be displayed before the field append will be displayed just after, max is the maximum number of characters that can be saved, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Text options: 1,size,prepend,append,max with size in chars, prepend will be displayed before the field append will be displayed just after, max is the maximum number of characters that can be saved, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too.",
// "textarea" => "textarea",
// "Textarea options: quicktags,width,height,max,listmax,wordmax - Use Quicktags is 1 or 0, width is indicated in chars, height is indicated in lines, max is the maximum number of characters that can be saved, listmax is the maximum number of characters that are displayed in list mode, wordmax>0 alert if word count exceeded, wordmax<0 display word count." => "Textarea options: quicktags,width,height,max,listmax,wordmax - Use Quicktags is 1 or 0, width is indicated in chars, height is indicated in lines, max is the maximum number of characters that can be saved, listmax is the maximum number of characters that are displayed in list mode, wordmax>0 alert if word count exceeded, wordmax<0 display word count.",
// "checkbox" => "checkbox",
// "Checkbox options: put 1 if you need that next field is on the same row." => "Checkbox options: put 1 if you need that next field is on the same row.",
// "numeric field" => "numeric field",
// "Numeric options: 1,size,prepend,append with size in chars, prepend will be displayed before the field append will be displayed just after, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Numeric options: 1,size,prepend,append with size in chars, prepend will be displayed before the field append will be displayed just after, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too.",
// "drop down" => "drop down",
// "Dropdown options: list of items separated with commas." => "Dropdown options: list of items separated with commas.",
// "Default value is specified by having the value indicated twice consecutively" => "Default value is specified by having the value indicated twice consecutively",
// "drop down with other textfield" => "drop down with other textfield",
// "radio buttons" => "radio buttons",
// "Radio buttons options: list of items separated with commas." => "Radio buttons options: list of items separated with commas.",
// "user selector" => "user selector",
// "User Selector options: automatic field feeding,email - feeding=1 for author login or feeding=2 for modificator login - email=1 to send an email to the user if the tracker is modified" => "User Selector options: automatic field feeding,email - feeding=1 for author login or feeding=2 for modificator login - email=1 to send an email to the user if the tracker is modified",
// "group selector" => "group selector",
// "Group Selector: use options for automatic field feeding : you can use 1 for group of creation and 2 for group where modification come from. The default group has to be set, or the first group that come is chosen for a user, or the default group is Registered." => "Group Selector: use options for automatic field feeding : you can use 1 for group of creation and 2 for group where modification come from. The default group has to be set, or the first group that come is chosen for a user, or the default group is Registered.",
// "IP selector" => "IP selector",
// "IP Selector: use options for automatic field feeding : you can use 1 for author IP or 2 for modificator IP." => "IP Selector: use options for automatic field feeding : you can use 1 for author IP or 2 for modificator IP.",
// "country selector" => "country selector",
// "Country Selector options: name/flag, sortorder - name/flag is 0,1 or 2 where 1 shows only country name, 2 shows only country flag, 0 shows both (default). sortorder is 0 or 1 where 0 sorts according to translated text (default) and 1 sorts according to english country names even if country names are translated" => "Country Selector options: name/flag, sortorder - name/flag is 0,1 or 2 where 1 shows only country name, 2 shows only country flag, 0 shows both (default). sortorder is 0 or 1 where 0 sorts according to translated text (default) and 1 sorts according to english country names even if country names are translated",
// "date and time" => "date and time",
// "Date Time options: date_time,year0,year1 where date_time=d|dt(default), d displays only date, year0 is the first year, year1 the last" => "Date Time options: date_time,year0,year1 where date_time=d|dt(default), d displays only date, year0 is the first year, year1 the last",
// "jscalendar" => "jscalendar",
// "Jscalendar options: date_time where date_time=d|dt(default), d displays only date" => "Jscalendar options: date_time where date_time=d|dt(default), d displays only date",
// "Image options: xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale indicated in pixels." => "Image options: xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale indicated in pixels.",
// "action" => "action",
// "Action options: Label,post,tiki-index.php,page:fieldname,highlight=test" => "Action options: Label,post,tiki-index.php,page:fieldname,highlight=test",
// "header" => "header",
// "static text" => "static text",
// "Static text options: Wikisyntax,listmax - Use Wikisyntax is 1 or 0, listmax is the maximum number of characters that are displayed in list mode." => "Static text options: Wikisyntax,listmax - Use Wikisyntax is 1 or 0, listmax is the maximum number of characters that are displayed in list mode.",
// "category" => "category",
// "Category options: parentId,d|m|radio|checkbox(default),1|0(default) to have a select all button, d for dropdown, m for multiple drop down" => "Category options: parentId,d|m|radio|checkbox(default),1|0(default) to have a select all button, d for dropdown, m for multiple drop down",
// "item link" => "item link",
// "Item Link options: trackerId,fieldId,linkToItem,displayedfieldslist links to item from trackerId which fieldId matches the content of that field. linkToItem 1|0 to create a link to the item in view mode and listing.  Display displayedfieldslist(separate with |) instead of the target item" => "Item Link options: trackerId,fieldId,linkToItem,displayedfieldslist links to item from trackerId which fieldId matches the content of that field. linkToItem 1|0 to create a link to the item in view mode and listing.  Display displayedfieldslist(separate with |) instead of the target item",
// "items list" => "items list",
// "Items list options: trackerId,fieldIdThere, fieldIdHere, displayFieldIdThere, linkToItems displays the list of displayFieldIdThere from item in tracker trackerId where fieldIdThere matches fieldIdHere. linkToItems 1|0 to create a link to items in view mode and listing" => "Items list options: trackerId,fieldIdThere, fieldIdHere, displayFieldIdThere, linkToItems displays the list of displayFieldIdThere from item in tracker trackerId where fieldIdThere matches fieldIdHere. linkToItems 1|0 to create a link to items in view mode and listing",
// "dynamic items list" => "dynamic items list",
// "dynamic items list options: trackerId, filterFieldIdThere, filterFieldIdHere, listFieldIdThere, statusThere insert the list of listFieldIdThere from item in tracker trackerId where filterFieldIdThere matches filterFieldIdHere where status is statusThere." => "dynamic items list options: trackerId, filterFieldIdThere, filterFieldIdHere, listFieldIdThere, statusThere insert the list of listFieldIdThere from item in tracker trackerId where filterFieldIdThere matches filterFieldIdHere where status is statusThere.",
// "email" => "email",
// "Email address options: 0|1|2 where 0 puts the address as plain text, 1 does a hex encoded mailto link (more difficult for web spiders to pick it up and spam) and 2 does the normal href mailto." => "Email address options: 0|1|2 where 0 puts the address as plain text, 1 does a hex encoded mailto link (more difficult for web spiders to pick it up and spam) and 2 does the normal href mailto.",
// "multimedia" => "multimedia",
// " 0|1|2|3|4|5 0,xsize,ysize. First record :0 for URL in file gal of MP3 only, 1 for URL of FLV in file gal video only , 2 for URL of MP3 or Video in file gal, 3 donwload MP3 only, 4 donwload FLV video only, 5 download FLV or MP3 (default is 0). Second record : X size of flash applet(default is 200) , Y size of flash applet (default is 100) " => " 0|1|2|3|4|5 0,xsize,ysize. First record :0 for URL in file gal of MP3 only, 1 for URL of FLV in file gal video only , 2 for URL of MP3 or Video in file gal, 3 donwload MP3 only, 4 donwload FLV video only, 5 download FLV or MP3 (default is 0). Second record : X size of flash applet(default is 200) , Y size of flash applet (default is 100) ",
// "auto-increment" => "auto-increment",
// "Sequential auto-increment number:initial_value,prepend,append,itemId: initial_value default is 1, prepend will be displayed before the field, append will be displayed just after, itemId will use the item Id" => "Sequential auto-increment number:initial_value,prepend,append,itemId: initial_value default is 1, prepend will be displayed before the field, append will be displayed just after, itemId will use the item Id",
// "user subscription" => "user subscription",
// "Allow registered user to subscribe to an item. They can add a number of friends." => "Allow registered user to subscribe to an item. They can add a number of friends.",
// "Google Maps" => "Google Maps",
// "Use Google Maps." => "Use Google Maps.",
// "system" => "system",
// "computed field" => "computed field",
// "Formula for computation, using # for indicating fields and +,*,/,- and parenthesis for operations." => "Formula for computation, using # for indicating fields and +,*,/,- and parenthesis for operations.",
// "user preference" => "user preference",
// "attachment" => "attachment",
// "listview=nst, n to see name/t to see type/s to see type/u to see user in list mode" => "listview=nst, n to see name/t to see type/s to see type/u to see user in list mode",
// "open" => "open",
// "pending" => "pending",
// "closed" => "closed",
// "Added:" => "Added:",
// "Removed:" => "Removed:",
// "Remaining:" => "Remaining:",
// "Old:" => "Old:",
// "New:" => "New:",
// "Message" => "Message",
// "No extra information for that attached file. " => "No extra information for that attached file. ",
// "child categories" => "child categories",
// "objects in category" => "objects in category",
// "(AT)" => "(AT)",
// "(DOT)" => "(DOT)",
// "The administrator has not yet validated your account. Please wait." => "The administrator has not yet validated your account. Please wait.",
// "You must validate your account first. An email has been sent to you" => "You must validate your account first. An email has been sent to you",
// "Password should be at least" => "Password should be at least",
// "characters long" => "characters long",
// "Password must contain both letters and numbers" => "Password must contain both letters and numbers",
// "The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "The registration mail can't be sent because there is no server email address set, and this feature is disabled",
// "The user email confirmation can't be sent. Contact the administrator" => "The user email confirmation can't be sent. Contact the administrator",
// "Personal Phone" => "Personal Phone",
// "Personal Mobile" => "Personal Mobile",
// "Personal Fax" => "Personal Fax",
// "Work Phone" => "Work Phone",
// "Work Mobile" => "Work Mobile",
// "Work Fax" => "Work Fax",
// "Company" => "Company",
// "Organization" => "Organization",
// "Department" => "Department",
// "Division" => "Division",
// "Job Title" => "Job Title",
// "Street Address" => "Street Address",
// "City" => "City",
// "State" => "State",
// "Zip Code" => "Zip Code",
// "Country" => "Country",
// "Use BLOGLIST to include posts from a blog. Syntax is" => "Use BLOGLIST to include posts from a blog. Syntax is",
// " where Id is the blog Id and Items is the max number of posts to display" => " where Id is the blog Id and Items is the max number of posts to display",
// "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~" => "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~",
// "Date" => "Date",
// "Title" => "Title",
// "Lists files in a directory" => "Lists files in a directory",
// "could not be opened because it doesn't exist or permission was denied" => "could not be opened because it doesn't exist or permission was denied",
// "Takes regex expressions and parses the content between the REGEX tags and replaces the text." => "Takes regex expressions and parses the content between the REGEX tags and replaces the text.",
// "data" => "data",
// "one data per line" => "one data per line",
// "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace." => "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace.",
// "This data is put in a CODE caption." => "This data is put in a CODE caption.",
// "Missing url parameter for SNARF plugin." => "Missing url parameter for SNARF plugin.",
// "users" => "users",
// "Displays a list of registered users" => "Displays a list of registered users",
// "Displays browser client info" => "Displays browser client info",
// "Puts a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which sets the location and name of the anchor" => "Puts a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which sets the location and name of the anchor",
// "linktext" => "linktext",
// "Puts an anchor into a wiki page. Use in conjunction with the ALINK plugin, which makes links to the anchor" => "Puts an anchor into a wiki page. Use in conjunction with the ALINK plugin, which makes links to the anchor",
// "Save changes to annotations" => "Save changes to annotations",
// "Creates an annotation block for an image." => "Creates an annotation block for an image.",
// "Includes an article" => "Includes an article",
// "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~" => "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~",
// "Id is optional. If not given, last article is used. Default field is heading." => "Id is optional. If not given, last article is used. Default field is heading.",
// "Includes articles listing into a wiki page" => "Includes articles listing into a wiki page",
// "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc)}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc)}{ARTICLES}~/np~",
// "No such attachment on this page" => "No such attachment on this page",
// "Displays an attachment or a list of them" => "Displays an attachment or a list of them",
// "Gives the name of the attached file to link to" => "Gives the name of the attached file to link to",
// "Same as name" => "Same as name",
// "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages" => "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages",
// "Shows the description as the link text instead of the file name" => "Shows the description as the link text instead of the file name",
// "Makes the list of attachments a bulleted list" => "Makes the list of attachments a bulleted list",
// "Says that this file is an image, and should be displayed inline using the img tag" => "Says that this file is an image, and should be displayed inline using the img tag",
// "Puts the stuff between {ATTACH} tags as the link text instead of the file name or description" => "Puts the stuff between {ATTACH} tags as the link text instead of the file name or description",
// "Shows all attachments from the whole wiki" => "Shows all attachments from the whole wiki",
// "Gives the number, in the list of attachments, of the attachment to link to" => "Gives the number, in the list of attachments, of the attachment to link to",
// "Gives the actual id of the attachment to link in. You probably should never use this" => "Gives the actual id of the attachment to link in. You probably should never use this",
// "Puts the number of downloads in the alt comment" => "Puts the number of downloads in the alt comment",
// "Shows a file icon" => "Shows a file icon",
// "Displays the user Avatar" => "Displays the user Avatar",
// "username" => "username",
// "List all pages which link to specific pages" => "List all pages which link to specific pages",
// "No pages links to" => "No pages links to",
// "One page links to" => "One page links to",
// "pages link to" => "pages link to",
// "Insert theme styled box on wiki page" => "Insert theme styled box on wiki page",
// "text" => "text",
// "Calendar" => "Calendar",
// "Insert list of items for the current/given category into wiki page" => "Insert list of items for the current/given category into wiki page",
// "Categories are disabled" => "Categories are disabled",
// "Insert the full category path for each category that this wiki page belongs to" => "Insert the full category path for each category that this wiki page belongs to",
// "Centers the plugin content in the wiki page" => "Centers the plugin content in the wiki page",
// "Chart" => "Chart",
// "title" => "title",
// "Chart as PDF" => "Chart as PDF",
// "Chart as PostScript" => "Chart as PostScript",
// "Displays a snippet of code" => "Displays a snippet of code",
// "code" => "code",
// "note: colors and ln are exclusive" => "note: colors and ln are exclusive",
// "Insert copyright notices" => "Insert copyright notices",
// "Example" => "Example",
// "minutes" => "minutes",
// "and" => "and",
// "seconds" => "seconds",
// "Insert a division block on wiki page" => "Insert a division block on wiki page",
// "Creates a definition list" => "Creates a definition list",
// "term" => "term",
// "definition" => "definition",
// "one definition per line" => "one definition per line",
// "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size" => "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size",
// "equation" => "equation",
// "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage",
// "Upcoming events" => "Upcoming events",
// "Displays the data using the Tikiwiki odd/even table style" => "Displays the data using the Tikiwiki odd/even table style",
// "cells" => "cells",
// "heads and cells separated by ~|~" => "heads and cells separated by ~|~",
// "Missing parameter movie to the plugin flash" => "Missing parameter movie to the plugin flash",
// "Displays a SWF on the wiki page" => "Displays a SWF on the wiki page",
// "Formula" => "Formula",
// "No formula specified." => "No formula specified.",
// "Impossible to render the graphic." => "Impossible to render the graphic.",
// "View graphic" => "View graphic",
// "Displays a graphical GAUGE" => "Displays a graphical GAUGE",
// "description" => "description",
// "Display wiki text if user is in one of listed groups" => "Display wiki text if user is in one of listed groups",
// "Include a page" => "Include a page",
// "Runs a Java applet to access a local Jabber service" => "Runs a Java applet to access a local Jabber service",
// "Displays the text only if the language matchs" => "Displays the text only if the language matchs",
// "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given" => "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given",
// "List wiki pages." => "List wiki pages.",
// "Displays a map" => "Displays a map",
// "Feature disabled" => "Feature disabled",
// "Displays an miniquiz" => "Displays an miniquiz",
// "Please choose a module" => "Please choose a module",
// "to be used as argument" => "to be used as argument",
// "Displays a module inlined in page" => "Displays a module inlined in page",
// "Sorry no such module" => "Sorry no such module",
// "Displays the data using a monospace font" => "Displays the data using a monospace font",
// "Displays a SWF myspace mp3 playlist on the wiki page" => "Displays a SWF myspace mp3 playlist on the wiki page",
// "Displays object hit info by object and days" => "Displays object hit info by object and days",
// "Provides a list of plugins on this wiki." => "Provides a list of plugins on this wiki.",
// "No version indicated" => "No version indicated",
// "No arguments indicated" => "No arguments indicated",
// "Displays the output of a poll, fields are indicated with numeric ids." => "Displays the output of a poll, fields are indicated with numeric ids.",
// "missing poll ID for plugin POLL" => "missing poll ID for plugin POLL",
// "blogId is mandatory" => "blogId is mandatory",
// "Includes blog posts listing into a wiki page" => "Includes blog posts listing into a wiki page",
// "~np~{POSTS(max=>5, blogId=>id)}{POSTS}~/np~" => "~np~{POSTS(max=>5, blogId=>id)}{POSTS}~/np~",
// " wrote:" => " wrote:",
// "Quote:" => "Quote:",
// "Quote text by surrounding the text with a box, like the [QUOTE] BBCode" => "Quote text by surrounding the text with a box, like the [QUOTE] BBCode",
// "Displays a comment, tip, note or warning box" => "Displays a comment, tip, note or warning box",
// "remarks text" => "remarks text",
// "You need to specify a RSS Id" => "You need to specify a RSS Id",
// "RSS Id incorrect:" => "RSS Id incorrect:",
// "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage",
// "Automatically creates a link to the appropriate SourceForge object" => "Automatically creates a link to the appropriate SourceForge object",
// "TikiSheet" => "TikiSheet",
// "Sheet Heading" => "Sheet Heading",
// "Edit Sheet" => "Edit Sheet",
// "List wiki pages" => "List wiki pages",
// "Last modified by" => "Last modified by",
// "Clickable Skype link" => "Clickable Skype link",
// "Sorts the plugin content in the wiki page" => "Sorts the plugin content in the wiki page",
// "Edit" => "Edit",
// "Split a page into rows and columns" => "Split a page into rows and columns",
// "row1col1" => "row1col1",
// "row1col2" => "row1col2",
// "row2col1" => "row2col1",
// "row2col2" => "row2col2",
// "Missing db param" => "Missing db param",
// "Run a sql query" => "Run a sql query",
// "sql query" => "sql query",
// "Displays text in subscript." => "Displays text in subscript.",
// "Subscribe or unsubscribe to a group" => "Subscribe or unsubscribe to a group",
// "Missing parameter" => "Missing parameter",
// "Incorrect param" => "Incorrect param",
// "Displays text in superscript." => "Displays text in superscript.",
// "Displays text between an html tag" => "Displays text between an html tag",
// "Displays the thumbnail for an image" => "Displays the thumbnail for an image",
// "Search the titles of all pages in this wiki" => "Search the titles of all pages in this wiki",
// "No pages found for title search" => "No pages found for title search",
// "One page found for title search" => "One page found for title search",
// " pages found for title search" => " pages found for title search",
// "List top scoring users" => "List top scoring users",
// "Translate a string" => "Translate a string",
// "Incorrect fieldId:" => "Incorrect fieldId:",
// "Error" => "Error",
// "Following mandatory fields are missing" => "Following mandatory fields are missing",
// "Following fields are incorrect" => "Following fields are incorrect",
// "Rating" => "Rating",
// "Other:" => "Other:",
// "Select All" => "Select All",
// "Displays an input form for tracker submit" => "Displays an input form for tracker submit",
// "You do not have permission to insert an item" => "You do not have permission to insert an item",
// "You do not have permission to modify an item" => "You do not have permission to modify an item",
// "Fields marked with a * are mandatory." => "Fields marked with a * are mandatory.",
// "Filter" => "Filter",
// "Filters the items of a tracker, fields are indicated with numeric ids." => "Filters the items of a tracker, fields are indicated with numeric ids.",
// "missing parameters" => "missing parameters",
// "tracker field type not processed yet" => "tracker field type not processed yet",
// "Wiki text" => "Wiki text",
// "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)." => "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker).",
// "incorrect filterfield" => "incorrect filterfield",
// "Displays the output of a tracker content, fields are indicated with numeric ids." => "Displays the output of a tracker content, fields are indicated with numeric ids.",
// "Error in tracker ID" => "Error in tracker ID",
// "No field indicated" => "No field indicated",
// "Displays a button to link to a page with a tracker plugin with prefilled tracker fields." => "Displays a button to link to a page with a tracker plugin with prefilled tracker fields.",
// "Displays some stat of a tracker content, fields are indicated with numeric ids." => "Displays some stat of a tracker content, fields are indicated with numeric ids.",
// "incorrect fieldId" => "incorrect fieldId",
// "Links to a translated content" => "Links to a translated content",
// "Displays the number of registered users" => "Displays the number of registered users",
// "Split the text in parts visible only under some conditions" => "Split the text in parts visible only under some conditions",
// "This is the default text" => "This is the default text",
// "(version 3)" => "(version 3)",
// "This is version 3 info" => "This is version 3 info",
// "(version 2)" => "(version 2)",
// "This is version 2 info" => "This is version 2 info",
// "(version 1)" => "(version 1)",
// "This is version 1 info" => "This is version 1 info",
// "Lists ''wanted'' Wiki pages: " => "Lists ''wanted'' Wiki pages: ",
// "Page-Pattern" => "Page-Pattern",
// "Custom-Level-Regex" => "Custom-Level-Regex",
// "^Parameters: key=>value,...\n" => "^Parameters: key=>value,...\n",
// "__key__ | __default__ | __comments__\n" => "__key__ | __default__ | __comments__\n",
// "empty string" => "empty string",
// "A wildcard pattern of originating pages to be ignored." => "A wildcard pattern of originating pages to be ignored.",
// "(refer to PHP function fnmatch() for details)\n" => "(refer to PHP function fnmatch() for details)\n",
// "The character, by which ignored patterns are separated." => "The character, by which ignored patterns are separated.",
// "possible values: characters\n" => "possible values: characters\n",
// "Whether to include external wikis in the list." => "Whether to include external wikis in the list.",
// "possible values: " => "possible values: ",
// "Collect either originating or wanted pages in a cell and display them in the second column." => "Collect either originating or wanted pages in a cell and display them in the second column.",
// "Switch-on debug output with details about the items." => "Switch-on debug output with details about the items.",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell." => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell.",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex." => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex.",
// "A custom filter for wanted pages to be listed (only used when level=>custom)." => "A custom filter for wanted pages to be listed (only used when level=>custom).",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "non-valid custom regex" => "non-valid custom regex",
// ", " => ", ",
// "ignored" => "ignored",
// "External Wiki" => "External Wiki",
// "dash-WikiWord" => "dash-WikiWord",
// "WikiWord" => "WikiWord",
// "not in level" => "not in level",
// "valid" => "valid",
// "End of debug output." => "End of debug output.",
// "Wanted Page" => "Wanted Page",
// "Referenced By Page" => "Referenced By Page",
// "Missing parameter movie to the youtube plugin" => "Missing parameter movie to the youtube plugin",
// "Display youtube video in a wiki page" => "Display youtube video in a wiki page",
// "Removed version \$version" => "Removed version \$version",
// "rollback version " => "rollback version ",
// "Changed actual version to \$version" => "Changed actual version to \$version",
// "Plugin " => "Plugin ",
// "failed" => "failed",
// "Page locked" => "Page locked",
// "Page unlocked" => "Page unlocked",
// "Removed last version" => "Removed last version",
// "ERROR: Either the subject or body must be non-empty" => "ERROR: Either the subject or body must be non-empty",
// "ERROR: No valid users to send the message" => "ERROR: No valid users to send the message",
// "Invalid user" => "Invalid user",
// "Message sent to" => "Message sent to",
// "Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "Sent box is full. Archive or delete some sent messages first if you want to send more messages.",
// "You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'",
// "User %s can not receive messages, mailbox is full" => "User %s can not receive messages, mailbox is full",
// "User %s can not receive messages" => "User %s can not receive messages",
// "Invalid user: %s" => "Invalid user: %s",
// "Message will be sent to: " => "Message will be sent to: ",
// "Archive is full. Delete some messages from archive first." => "Archive is full. Delete some messages from archive first.",
// "No more messages" => "No more messages",
// "Tiki Calendar" => "Tiki Calendar",
// "list topics with links to the articles" => "list topics with links to the articles",
// "Article Topics" => "Article Topics",
// "Categorize %s in %s" => "Categorize %s in %s",
// "Please provide an Id" => "Please provide an Id",
// "no object here yet" => "no object here yet",
// "This module requires parameters trackerId and name set" => "This module requires parameters trackerId and name set",
// "Create/Edit" => "Create/Edit",
// "Quick Edit a Wiki Page" => "Quick Edit a Wiki Page",
// "new users" => "new users",
// "Since your last visit" => "Since your last visit",
// "Changes" => "Changes",
// "since" => "since",
// "Changes since" => "Changes since",
// "new comments" => "new comments",
// "new posts" => "new posts",
// "wiki pages changed" => "wiki pages changed",
// "new articles" => "new articles",
// "new submissions" => "new submissions",
// "new FAQs" => "new FAQs",
// "new sites" => "new sites",
// "new blogs" => "new blogs",
// "new blog posts" => "new blog posts",
// "new image galleries" => "new image galleries",
// "new images" => "new images",
// "new file galleries" => "new file galleries",
// "new files" => "new files",
// "new polls" => "new polls",
// "new tracker items" => "new tracker items",
// "new calendar events" => "new calendar events",
// "The task title must have at least 3 characters" => "The task title must have at least 3 characters",
// "Invalid server key" => "Invalid server key",
// "Invalid username or password" => "Invalid username or password",
// "Cookie not found" => "Cookie not found",
// "Admin live support system" => "Admin live support system",
// "Administrator, can admin banners" => "Administrator, can admin banners",
// "Administrator, can create channels remove channels etc" => "Administrator, can create channels remove channels etc",
// "Administrator, can manage users groups and permissions, Hotwords and all the weblog features" => "Administrator, can manage users groups and permissions, Hotwords and all the weblog features",
// "Auto approve forum posts" => "Auto approve forum posts",
// "Autovalidate suggestions" => "Autovalidate suggestions",
// "Can  receive tasks from other users" => "Can  receive tasks from other users",
// "Can abort a process instance" => "Can abort a process instance",
// "Can access site when closed" => "Can access site when closed",
// "Can add and change ratings on wiki pages" => "Can add and change ratings on wiki pages",
// "Can add events in the calendar" => "Can add events in the calendar",
// "Can admin any mypage" => "Can admin any mypage",
// "Can admin attachments to wiki pages" => "Can admin attachments to wiki pages",
// "Can admin blogs" => "Can admin blogs",
// "Can admin categories" => "Can admin categories",
// "Can admin charts" => "Can admin charts",
// "Can admin contributions" => "Can admin contributions",
// "Can admin cookies" => "Can admin cookies",
// "Can admin directory categories" => "Can admin directory categories",
// "Can admin directory sites" => "Can admin directory sites",
// "Can admin drawings" => "Can admin drawings",
// "Can admin faqs" => "Can admin faqs",
// "Can admin file galleries" => "Can admin file galleries",
// "Can admin forums" => "Can admin forums",
// "Can admin freetags" => "Can admin freetags",
// "Can admin games" => "Can admin games",
// "Can admin Image Galleries" => "Can admin Image Galleries",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
// "Can admin mail-in accounts" => "Can admin mail-in accounts",
// "Can admin newsletters" => "Can admin newsletters",
// "Can admin polls" => "Can admin polls",
// "Can admin public tasks" => "Can admin public tasks",
// "Can admin quicktags" => "Can admin quicktags",
// "Can admin quizzes" => "Can admin quizzes",
// "Can admin received articles" => "Can admin received articles",
// "Can admin received pages" => "Can admin received pages",
// "Can admin rss modules" => "Can admin rss modules",
// "Can admin sheet" => "Can admin sheet",
// "Can admin shoutbox (Edit/remove msgs)" => "Can admin shoutbox (Edit/remove msgs)",
// "Can admin surveys" => "Can admin surveys",
// "Can admin the cms" => "Can admin the cms",
// "Can admin the directory" => "Can admin the directory",
// "Can admin the dynamic content system" => "Can admin the dynamic content system",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can admin the wiki" => "Can admin the wiki",
// "Can admin trackers" => "Can admin trackers",
// "Can admin users" => "Can admin users",
// "Can admin workflow processes" => "Can admin workflow processes",
// "Can approve submissions" => "Can approve submissions",
// "Can assign perms to blog" => "Can assign perms to blog",
// "Can assign perms to file gallery" => "Can assign perms to file gallery",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
// "Can assign perms to mypage" => "Can assign perms to mypage",
// "Can assign perms to wiki pages" => "Can assign perms to wiki pages",
// "Can attach files to tracker items" => "Can attach files to tracker items",
// "Can attach files to wiki pages" => "Can attach files to wiki pages",
// "Can attach to forum posts" => "Can attach to forum posts",
// "Can ban users or ips" => "Can ban users or ips",
// "Can broadcast messages to all user" => "Can broadcast messages to all user",
// "Can broadcast messages to groups" => "Can broadcast messages to groups",
// "Can browse freetags" => "Can browse freetags",
// "Can browse the calendar" => "Can browse the calendar",
// "Can cache user bookmarks" => "Can cache user bookmarks",
// "Can change events in the calendar" => "Can change events in the calendar",
// "Can change tracker items" => "Can change tracker items",
// "Can clean cache" => "Can clean cache",
// "Can configure modules" => "Can configure modules",
// "Can create a blog" => "Can create a blog",
// "Can create and edit sheets" => "Can create and edit sheets",
// "Can create and edit structures" => "Can create and edit structures",
// "Can create file galleries" => "Can create file galleries",
// "Can create image galleries" => "Can create image galleries",
// "Can create items in personal menu" => "Can create items in personal menu",
// "Can create new css suffixed with -user" => "Can create new css suffixed with -user",
// "Can create new items for trackers" => "Can create new items for trackers",
// "Can create new mapfile" => "Can create new mapfile",
// "Can create user bookmarks" => "Can create user bookmarks",
// "Can create/admin calendars" => "Can create/admin calendars",
// "Can declare an instance as exception" => "Can declare an instance as exception",
// "Can delete comments" => "Can delete comments",
// "Can delete mapfiles" => "Can delete mapfiles",
// "Can download files" => "Can download files",
// "Can edit a gallery file" => "Can edit a gallery file",
// "Can edit all comments" => "Can edit all comments",
// "Can edit any mypage" => "Can edit any mypage",
// "Can edit articles" => "Can edit articles",
// "Can edit content templates" => "Can edit content templates",
// "Can edit copyright notices" => "Can edit copyright notices",
// "Can edit drawings" => "Can edit drawings",
// "Can edit dynamic variables" => "Can edit dynamic variables",
// "Can edit HTML pages" => "Can edit HTML pages",
// "Can edit items in categories" => "Can edit items in categories",
// "Can edit mapfiles" => "Can edit mapfiles",
// "Can edit menu" => "Can edit menu",
// "Can edit menu option" => "Can edit menu option",
// "Can edit object permissions" => "Can edit object permissions",
// "Can edit own forum posts" => "Can edit own forum posts",
// "Can edit pages" => "Can edit pages",
// "Can edit site templates" => "Can edit site templates",
// "Can edit submissions" => "Can edit submissions",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can edit translations and create new languages" => "Can edit translations and create new languages",
// "Can execute workflow activities" => "Can execute workflow activities",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can insert comments for tracker items" => "Can insert comments for tracker items",
// "Can list file galleries" => "Can list file galleries",
// "Can list image galleries" => "Can list image galleries",
// "Can list mypages" => "Can list mypages",
// "Can list registered users" => "Can list registered users",
// "Can list trackers" => "Can list trackers",
// "Can lock pages" => "Can lock pages",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can play games" => "Can play games",
// "Can post in forums" => "Can post in forums",
// "Can post messages in shoutbox" => "Can post messages in shoutbox",
// "Can post new comments" => "Can post new comments",
// "Can post to a blog" => "Can post to a blog",
// "Can read a topic (Applies only to individual topic perms)" => "Can read a topic (Applies only to individual topic perms)",
// "Can read article headings" => "Can read article headings",
// "Can read articles" => "Can read articles",
// "Can read blogs" => "Can read blogs",
// "Can read comments" => "Can read comments",
// "Can read forums" => "Can read forums",
// "Can remove" => "Can remove",
// "Can remove articles" => "Can remove articles",
// "Can remove association between two pages in a translation set" => "Can remove association between two pages in a translation set",
// "Can remove submissions" => "Can remove submissions",
// "Can rename pages" => "Can rename pages",
// "Can replay the TikiTests" => "Can replay the TikiTests",
// "Can report a link to the webmaster" => "Can report a link to the webmaster",
// "Can report msgs to moderator" => "Can report msgs to moderator",
// "Can rollback pages" => "Can rollback pages",
// "Can save as minor edit" => "Can save as minor edit",
// "Can search" => "Can search",
// "Can send a link to a friend" => "Can send a link to a friend",
// "Can send articles to other sites" => "Can send articles to other sites",
// "Can send articles to this site" => "Can send articles to this site",
// "Can send instances after completion" => "Can send instances after completion",
// "Can send newsletters" => "Can send newsletters",
// "Can send pages to other sites" => "Can send pages to other sites",
// "Can send pages to this site" => "Can send pages to this site",
// "Can send tasks to other users" => "Can send tasks to other users",
// "Can start threads in forums" => "Can start threads in forums",
// "Can submit articles" => "Can submit articles",
// "Can submit sites to the directory" => "Can submit sites to the directory",
// "Can subscribe any email to newsletters" => "Can subscribe any email to newsletters",
// "Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Can subscribe many e-mails at once (requires tiki_p_subscribe email)",
// "Can subscribe to groups" => "Can subscribe to groups",
// "Can subscribe to newsletters" => "Can subscribe to newsletters",
// "Can suggest faq questions" => "Can suggest faq questions",
// "Can suggest items" => "Can suggest items",
// "Can tag objects" => "Can tag objects",
// "Can take quizzes" => "Can take quizzes",
// "Can take surveys" => "Can take surveys",
// "Can unassign tags from an object" => "Can unassign tags from an object",
// "Can upload files" => "Can upload files",
// "Can upload images" => "Can upload images",
// "Can upload personal files" => "Can upload personal files",
// "Can upload pictures to wiki pages" => "Can upload pictures to wiki pages",
// "Can upload zip files with files" => "Can upload zip files with files",
// "Can upload zip files with images" => "Can upload zip files with images",
// "Can use content templates" => "Can use content templates",
// "Can use Directory Batch Load" => "Can use Directory Batch Load",
// "Can use Directoy Batch Load" => "Can use Directoy Batch Load",
// "Can use HTML in pages" => "Can use HTML in pages",
// "Can use live support system" => "Can use live support system",
// "Can use tasks" => "Can use tasks",
// "Can use the chat system" => "Can use the chat system",
// "Can use the directory" => "Can use the directory",
// "Can use the messaging system" => "Can use the messaging system",
// "Can use the mini event calendar" => "Can use the mini event calendar",
// "Can use the newsreader" => "Can use the newsreader",
// "Can use the notepad" => "Can use the notepad",
// "Can use the page as a tracker template" => "Can use the page as a tracker template",
// "Can use webmail" => "Can use webmail",
// "Can validate submited links" => "Can validate submited links",
// "Can view action log" => "Can view action log",
// "Can view action log for users of his own groups" => "Can view action log for users of his own groups",
// "Can view any mypage" => "Can view any mypage",
// "Can view categories" => "Can view categories",
// "Can view categorized items" => "Can view categorized items",
// "Can view charts" => "Can view charts",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
// "Can view events details" => "Can view events details",
// "Can view faqs" => "Can view faqs",
// "Can view file galleries" => "Can view file galleries",
// "Can view file galleries explorer" => "Can view file galleries explorer",
// "Can view file galleries path" => "Can view file galleries path",
// "Can view HTML pages" => "Can view HTML pages",
// "Can view image galleries" => "Can view image galleries",
// "Can view integrated repositories" => "Can view integrated repositories",
// "Can view mapfiles" => "Can view mapfiles",
// "Can view page/pages" => "Can view page/pages",
// "Can view poll results" => "Can view poll results",
// "Can view quiz stats" => "Can view quiz stats",
// "Can view rating of wiki pages" => "Can view rating of wiki pages",
// "Can view rating result for tracker items" => "Can view rating result for tracker items",
// "Can view referer stats" => "Can view referer stats",
// "Can view sheet" => "Can view sheet",
// "Can view sheet history" => "Can view sheet history",
// "Can view shoutbox" => "Can view shoutbox",
// "Can view site stats" => "Can view site stats",
// "Can view site templates" => "Can view site templates",
// "Can view source of wiki pages" => "Can view source of wiki pages",
// "Can view survey stats" => "Can view survey stats",
// "Can view Tikiwiki tools calendar" => "Can view Tikiwiki tools calendar",
// "Can view trackers" => "Can view trackers",
// "Can view trackers closed items" => "Can view trackers closed items",
// "Can view trackers pending items" => "Can view trackers pending items",
// "Can view user quiz results" => "Can view user quiz results",
// "Can view wiki attachments and download" => "Can view wiki attachments and download",
// "Can view wiki comments" => "Can view wiki comments",
// "Can view wiki history" => "Can view wiki history",
// "Can view/edit only one's own mypages" => "Can view/edit only one's own mypages",
// "Can vote" => "Can vote",
// "Can vote a rating for tracker items" => "Can vote a rating for tracker items",
// "Can vote comments" => "Can vote comments",
// "Can vote comments in forums" => "Can vote comments in forums",
// "Can vote polls" => "Can vote polls",
// "Can watch structure" => "Can watch structure",
// "Can watch tracker" => "Can watch tracker",
// "Submited articles automatically approved" => "Submited articles automatically approved",
// "Submited links are valid" => "Submited links are valid",
// "Anti-Bot verification code" => "Anti-Bot verification code",
// "Random Image" => "Random Image",
// "Enter the code you see above" => "Enter the code you see above",
// "List of attached files" => "List of attached files",
// "id" => "id",
// "desc" => "desc",
// "uploaded" => "uploaded",
// "View" => "View",
// "Download" => "Download",
// "Delete" => "Delete",
// "Remove" => "Remove",
// "Upload file" => "Upload file",
// "Attach" => "Attach",
// "Attach a file to this item" => "Attach a file to this item",
// "Version" => "Version",
// "Attachments" => "Attachments",
// "more info" => "more info",
// "No attachments for this item" => "No attachments for this item",
// "debug" => "debug",
// "Fatal error" => "Fatal error",
// "Description:" => "Description:",
// "Created by" => "Created by",
// " on " => " on ",
// "Post" => "Post",
// "RSS feed" => "RSS feed",
// "Edit blog" => "Edit blog",
// "Monitor this Blog" => "Monitor this Blog",
// "Stop Monitoring this Blog" => "Stop Monitoring this Blog",
// "Activity=" => "Activity=",
// "Watched by categories" => "Watched by categories",
// "Actions" => "Actions",
// "Properties" => "Properties",
// "No records found" => "No records found",
// "Category" => "Category",
// "Show Categories" => "Show Categories",
// "Hide Categories" => "Hide Categories",
// "Tip" => "Tip",
// "Hold down CTRL to select multiple categories" => "Hold down CTRL to select multiple categories",
// "Uncheck the above checkbox to uncategorize this page/object" => "Uncheck the above checkbox to uncategorize this page/object",
// "No categories defined" => "No categories defined",
// "Admin Categories" => "Admin Categories",
// "Browse Category" => "Browse Category",
// "on" => "on",
// "posts:" => "posts:",
// "stars" => "stars",
// "User Level" => "User Level",
// "private message" => "private message",
// "Send eMail to User" => "Send eMail to User",
// "user online" => "user online",
// "user offline" => "user offline",
// "Attachment" => "Attachment",
// "Vote" => "Vote",
// "top of page" => "top of page",
// "Reply" => "Reply",
// "Report this post" => "Report this post",
// "Save to notepad" => "Save to notepad",
// "Monitor this Topic" => "Monitor this Topic",
// "Stop Monitoring this Topic" => "Stop Monitoring this Topic",
// "Moderator actions" => "Moderator actions",
// "reported:" => "reported:",
// "queued:" => "queued:",
// "Move to topic:" => "Move to topic:",
// "Move" => "Move",
// "Delete Selected" => "Delete Selected",
// "Messages" => "Messages",
// "Style" => "Style",
// "Plain" => "Plain",
// "Threaded" => "Threaded",
// "Headers Only" => "Headers Only",
// "Sort" => "Sort",
// "Newest first" => "Newest first",
// "Oldest first" => "Oldest first",
// "Title (desc)" => "Title (desc)",
// "Title (asc)" => "Title (asc)",
// "Threshold" => "Threshold",
// "Search" => "Search",
// "Set" => "Set",
// "Replies" => "Replies",
// "below your current threshold" => "below your current threshold",
// "New Reply" => "New Reply",
// "Editing reply" => "Editing reply",
// "Preview" => "Preview",
// "Reply to the selected post" => "Reply to the selected post",
// "Post new message" => "Post new message",
// "Editing comment" => "Editing comment",
// "Comment on the selected post" => "Comment on the selected post",
// "Post new comment" => "Post new comment",
// "Required" => "Required",
// "Smileys" => "Smileys",
// "Quicktags" => "Quicktags",
// "Reply to parent post" => "Reply to parent post",
// "Post new reply" => "Post new reply",
// "Enter your name" => "Enter your name",
// "Post as Anonymous" => "Post as Anonymous",
// "Cancel" => "Cancel",
// "Posting replies" => "Posting replies",
// "Posting comments" => "Posting comments",
// "Use" => "Use",
// "or" => "or",
// "for links" => "for links",
// "HTML tags are not allowed inside posts" => "HTML tags are not allowed inside posts",
// "Go back" => "Go back",
// "Return to home page" => "Return to home page",
// "Type of contribution:" => "Type of contribution:",
// "Contributors" => "Contributors",
// "Copyrights" => "Copyrights",
// "Year" => "Year",
// "Authors" => "Authors",
// "Add" => "Add",
// "Syntax" => "Syntax",
// "Page generation debugging log" => "Page generation debugging log",
// "Features state" => "Features state",
// "Total" => "Total",
// "features matched" => "features matched",
// "Watchlist" => "Watchlist",
// "Duplicate File Gallery" => "Duplicate File Gallery",
// "Duplicate categories" => "Duplicate categories",
// "Duplicate perms" => "Duplicate perms",
// "duplicate" => "duplicate",
// "There are individual permissions set for this file gallery" => "There are individual permissions set for this file gallery",
// "Save" => "Save",
// "View inserted gallery" => "View inserted gallery",
// "Display Properties" => "Display Properties",
// "required field for podcasts" => "required field for podcasts",
// "any file" => "any file",
// "podcast (audio)" => "podcast (audio)",
// "podcast (video)" => "podcast (video)",
// "Gallery is visible to non-admin users?" => "Gallery is visible to non-admin users?",
// "This Gallery is Public" => "This Gallery is Public",
// "The files can be locked at download:" => "The files can be locked at download:",
// "Maximum number of archives for each file" => "Maximum number of archives for each file",
// "unlimited" => "unlimited",
// "none" => "none",
// "Parent gallery" => "Parent gallery",
// "Owner of the gallery" => "Owner of the gallery",
// "Default sort order" => "Default sort order",
// "descending" => "descending",
// "ascending" => "ascending",
// "Max description display size" => "Max description display size",
// "Max Rows per page" => "Max Rows per page",
// "Listing configuration" => "Listing configuration",
// "Perhaps you were looking for:" => "Perhaps you were looking for:",
// "There are no wiki pages similar to '{\$page}'" => "There are no wiki pages similar to '{\$page}'",
// "You are not logged in." => "You are not logged in.",
// "Go to Login Page" => "Go to Login Page",
// "Create this page" => "Create this page",
// "(page will be orphaned)" => "(page will be orphaned)",
// "Close Window" => "Close Window",
// "Go to" => "Go to",
// "Private Gallery" => "Private Gallery",
// "Active Perms" => "Active Perms",
// "Perms" => "Perms",
// "Display" => "Display",
// "Archives" => "Archives",
// "Upload New Version" => "Upload New Version",
// "Unlock" => "Unlock",
// "Download and lock" => "Download and lock",
// "Lock" => "Lock",
// "Name-filename" => "Name-filename",
// "Filename only" => "Filename only",
// "Show as a column" => "Show as a column",
// "Show in popup box" => "Show in popup box",
// "Both" => "Both",
// "Show an icon in a column" => "Show an icon in a column",
// "Exact&nbsp;match" => "Exact&nbsp;match",
// "any type" => "any type",
// "all topic" => "all topic",
// "any language" => "any language",
// "any category" => "any category",
// "Number of displayed rows" => "Number of displayed rows",
// "Show php error messages" => "Show php error messages",
// "Last update from SVN" => "Last update from SVN",
// "Folksonomy Tags" => "Folksonomy Tags",
// "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together." => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together.",
// "Tags" => "Tags",
// "Translate tags" => "Translate tags",
// "Images Galleries" => "Images Galleries",
// "Edit this page!" => "Edit this page!",
// "RSS Wiki" => "RSS Wiki",
// "RSS Blogs" => "RSS Blogs",
// "RSS Articles" => "RSS Articles",
// "RSS Image Galleries" => "RSS Image Galleries",
// "RSS File Galleries" => "RSS File Galleries",
// "RSS Forums" => "RSS Forums",
// "RSS Maps" => "RSS Maps",
// "RSS Directories" => "RSS Directories",
// "RSS Calendars" => "RSS Calendars",
// "Loading" => "Loading",
// "\\074span class=\"shortcut\"\\076C\\074/span\\076lose" => "\\074span class=\"shortcut\"\\076C\\074/span\\076lose",
// "\\074span class=\"shortcut\"\\076N\\074/span\\076ext" => "\\074span class=\"shortcut\"\\076N\\074/span\\076ext",
// "\\074span class=\"shortcut\"\\076P\\074/span\\076revious" => "\\074span class=\"shortcut\"\\076P\\074/span\\076revious",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Fullscreen" => "Fullscreen",
// "Information" => "Information",
// "Show Tree" => "Show Tree",
// "Hide Tree" => "Hide Tree",
// "Perform action with checked:" => "Perform action with checked:",
// "Move Selected Files" => "Move Selected Files",
// "Are you sure you want to delete the selected files?" => "Are you sure you want to delete the selected files?",
// "Move to" => "Move to",
// "Filename" => "Filename",
// "Other Sorts" => "Other Sorts",
// "No Additionnal Sort" => "No Additionnal Sort",
// "No information" => "No information",
// "Hi {\$mail_user} has sent you this link:" => "Hi {\$mail_user} has sent you this link:",
// "Blog post:" => "Blog post:",
// "at:" => "at:",
// "Somebody or you tried to subscribe this email address at our site:" => "Somebody or you tried to subscribe this email address at our site:",
// "To the newsletter:" => "To the newsletter:",
// "In order to confirm your subscription you must access the following URL:" => "In order to confirm your subscription you must access the following URL:",
// "To validate your account and login to the site, please click on the following link:" => "To validate your account and login to the site, please click on the following link:",
// "The administrator approved your account." => "The administrator approved your account.",
// "Confirm your email at %s" => "Confirm your email at %s",
// "Author:" => "Author:",
// "A new message was posted to forum" => "A new message was posted to forum",
// "New topic:" => "New topic:",
// "Topic:" => "Topic:",
// "Contribution" => "Contribution",
// "You sent a request with the subject:" => "You sent a request with the subject:",
// "Use the subject to indicate the operation to apply:" => "Use the subject to indicate the operation to apply:",
// "GET:WikiName to get a wiki page" => "GET:WikiName to get a wiki page",
// "PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName to update/create a wiki page (use the body for the page data)",
// "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)",
// "PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName to append the data at the top",
// "Tiki mail-in instructions" => "Tiki mail-in instructions",
// "Tiki mail-in auto-reply." => "Tiki mail-in auto-reply.",
// "Page not found:" => "Page not found:",
// "Hi," => "Hi,",
// "A new message was posted to you at {\$mail_machine}" => "A new message was posted to you at {\$mail_machine}",
// "From" => "From",
// "Subject" => "Subject",
// "New message arrived from %s" => "New message arrived from %s",
// "Hi" => "Hi",
// "Your Tiki account registration request for {\$mail_site} was validated by the site admin and your account is active now." => "Your Tiki account registration request for {\$mail_site} was validated by the site admin and your account is active now.",
// "To login with your username and password, please follow this link:" => "To login with your username and password, please follow this link:",
// "Enjoy the site!" => "Enjoy the site!",
// "Tiki User Account Activated" => "Tiki User Account Activated",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first",
// "has requested an account on" => "has requested an account on",
// "To validate that account, please follow the link:" => "To validate that account, please follow the link:",
// "best regards" => "best regards",
// "your Tikiwiki" => "your Tikiwiki",
// "Tiki User Registration Request" => "Tiki User Registration Request",
// "Go to your friendship network to accept or refuse this request" => "Go to your friendship network to accept or refuse this request",
// "You're invited to join my network of friends!" => "You're invited to join my network of friends!",
// "The user" => "The user",
// "registered at your site" => "registered at your site",
// "New user registration" => "New user registration",
// "Bye bye!" => "Bye bye!",
// "This email address has been removed to the list of subscriptors of:" => "This email address has been removed to the list of subscriptors of:",
// "Newsletter:" => "Newsletter:",
// "Bye bye from %s at %s" => "Bye bye from %s at %s",
// "You can unsubscribe from this newsletter following this link" => "You can unsubscribe from this newsletter following this link",
// "Welcome to our newsletter!" => "Welcome to our newsletter!",
// "This email address has been added to the list of subscriptors of:" => "This email address has been added to the list of subscriptors of:",
// "You can always cancel your subscription using:" => "You can always cancel your subscription using:",
// "Welcome to %s at %s" => "Welcome to %s at %s",
// "Tiki email notification" => "Tiki email notification",
// "Someone coming from IP Address" => "Someone coming from IP Address",
// "requested a reminder of the password for your account" => "requested a reminder of the password for your account",
// "requested password reset for your account" => "requested password reset for your account",
// "Since this is your registered email address we inform that the password for this account is" => "Since this is your registered email address we inform that the password for this account is",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else.\n{\$mail_machine}/tiki-change_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nDone! You should be logged in." => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else.\n{\$mail_machine}/tiki-change_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nDone! You should be logged in.",
// "Important: Username & password are CaSe SenSitiVe" => "Important: Username & password are CaSe SenSitiVe",
// "Important: The old password remains active if you don't click the link above." => "Important: The old password remains active if you don't click the link above.",
// "Your Tiki account information for %s" => "Your Tiki account information for %s",
// "A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}",
// "You can edit the submission following this link:" => "You can edit the submission following this link:",
// "Title:" => "Title:",
// "Heading:" => "Heading:",
// "Body:" => "Body:",
// "New article submitted at %s" => "New article submitted at %s",
// "Look at this link:" => "Look at this link:",
// "A friend sends you a link from: " => "A friend sends you a link from: ",
// "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}",
// "View the tracker item at:" => "View the tracker item at:",
// "Download the file at:" => "Download the file at:",
// "Tracker was modified at" => "Tracker was modified at",
// "Please visit this link before login again:" => "Please visit this link before login again:",
// "Confirm your account at %s" => "Confirm your account at %s",
// "you or someone registered this email address at" => "you or someone registered this email address at",
// "If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "If you want to be a registered user in this site you will have to use the following link to login for the first time:",
// "Your Tiki information registration" => "Your Tiki information registration",
// "You will receive an email with information to login for the first time into this site" => "You will receive an email with information to login for the first time into this site",
// "You'll receive email notification once your account is activated." => "You'll receive email notification once your account is activated.",
// "Please do not attempt to login until you receive the email notification." => "Please do not attempt to login until you receive the email notification.",
// "New article post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "New article post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "View the article at:" => "View the article at:",
// "If you don't want to receive these notifications follow this link:" => "If you don't want to receive these notifications follow this link:",
// "New article post at %s" => "New article post at %s",
// "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "View the blog at:" => "View the blog at:",
// "New blog post at %s" => "New blog post at %s",
// "View item calendar at:" => "View item calendar at:",
// "Modified calendar item" => "Modified calendar item",
// "New calendar item" => "New calendar item",
// "changed" => "changed",
// "A new category was created in" => "A new category was created in",
// "created" => "created",
// "A category was removed in" => "A category was removed in",
// "Removed by" => "Removed by",
// "removed" => "removed",
// "A category was updated" => "A category was updated",
// "Updated by" => "Updated by",
// "Old" => "Old",
// "New" => "New",
// "updated" => "updated",
// "File Gallery %s changed" => "File Gallery %s changed",
// "A file was removed from the file gallery" => "A file was removed from the file gallery",
// "File Name" => "File Name",
// "A new file was posted to file gallery" => "A new file was posted to file gallery",
// "Posted by" => "Posted by",
// "File Description" => "File Description",
// "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}:" => "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}:",
// "Image Gallery {\$galleryName} changed" => "Image Gallery {\$galleryName} changed",
// "A new file was posted to image gallery" => "A new file was posted to image gallery",
// "The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "You can view the updated map following this link:" => "You can view the updated map following this link:",
// "You can edit the map following this link:" => "You can edit the map following this link:",
// "An object was added to category" => "An object was added to category",
// "Added by" => "Added by",
// "Object" => "Object",
// "Object type" => "Object type",
// "An object was removed from category" => "An object was removed from category",
// "A page has been added to your watched sub-structure:" => "A page has been added to your watched sub-structure:",
// "A page has been removed from your watched sub-structure:" => "A page has been removed from your watched sub-structure:",
// "A page has been promoted out your watched sub-structure:" => "A page has been promoted out your watched sub-structure:",
// "A page has been demoted to your watched structure:" => "A page has been demoted to your watched structure:",
// "Structure modified" => "Structure modified",
// "A new file have been attached to page" => "A new file have been attached to page",
// "File name" => "File name",
// "New attachment on %s, page" => "New attachment on %s, page",
// "The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "Comment:" => "Comment:",
// "You can view the page by following this link:" => "You can view the page by following this link:",
// "You can view a diff back to the previous version by following this link:" => "You can view a diff back to the previous version by following this link:",
// "The changes in this version follow below, followed after by the current full page text." => "The changes in this version follow below, followed after by the current full page text.",
// "-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Lines: {\$oldd} changed to +Lines: {\$newd}",
// "The new page content follows below." => "The new page content follows below.",
// "Wiki page %s changed" => "Wiki page %s changed",
// "The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "Wiki page %s was commented on by" => "Wiki page %s was commented on by",
// "an anonymous user" => "an anonymous user",
// "Wiki page renamed" => "Wiki page renamed",
// "Old name" => "Old name",
// "New name" => "New name",
// "Thank you for your registration. You may log in now." => "Thank you for your registration. You may log in now.",
// "click on the map to zoom or pan, do not drag" => "click on the map to zoom or pan, do not drag",
// "Query Results" => "Query Results",
// "Querying" => "Querying",
// "Scroll Up" => "Scroll Up",
// "Scroll Down" => "Scroll Down",
// "Scale" => "Scale",
// "Zoom out" => "Zoom out",
// "Query" => "Query",
// "Pan" => "Pan",
// "Zoom in" => "Zoom in",
// "Redraw" => "Redraw",
// "select zoom/pan/query and image size" => "select zoom/pan/query and image size",
// "Go" => "Go",
// "View the Map Only" => "View the Map Only",
// "Reset Map" => "Reset Map",
// "Click on the map or click redraw" => "Click on the map or click redraw",
// "Comments" => "Comments",
// "Last modification date" => "Last modification date",
// "Overview" => "Overview",
// "Legend" => "Legend",
// "Layer Manager" => "Layer Manager",
// "Layer" => "Layer",
// "On" => "On",
// "Label" => "Label",
// "Download Layer" => "Download Layer",
// "This layer has been set by the maps administrator to not be downloadable" => "This layer has been set by the maps administrator to not be downloadable",
// "you have requested to download the layer:" => "you have requested to download the layer:",
// "from the mapfile:" => "from the mapfile:",
// "Here are the files to download, do not forget to rename them:" => "Here are the files to download, do not forget to rename them:",
// "Mapfiles" => "Mapfiles",
// "Mapfile" => "Mapfile",
// "Available mapfiles" => "Available mapfiles",
// "hits last 7 days" => "hits last 7 days",
// "monitor this map" => "monitor this map",
// "Stop Monitoring this Map" => "Stop Monitoring this Map",
// "Create a new mapfile" => "Create a new mapfile",
// "Create" => "Create",
// "Mapfile listing" => "Mapfile listing",
// "Reload" => "Reload",
// "History" => "History",
// "You can view this map in your browser using" => "You can view this map in your browser using",
// "Zoom out x2" => "Zoom out x2",
// "Zoom in x2" => "Zoom in x2",
// "Mapfile History" => "Mapfile History",
// "of" => "of",
// "Compare" => "Compare",
// "Comparing version {\$old.version} with version {\$new.version}" => "Comparing version {\$old.version} with version {\$new.version}",
// "Version:" => "Version:",
// "Current" => "Current",
// "Versions are identical" => "Versions are identical",
// "Legend:" => "Legend:",
// "v=view" => "v=view",
// "c=compare" => "c=compare",
// "d=diff" => "d=diff",
// "Full side-by-side diff" => "Full side-by-side diff",
// "Unified diff" => "Unified diff",
// "Side-by-side view" => "Side-by-side view",
// "User" => "User",
// "Ip" => "Ip",
// "Action" => "Action",
// "Diff" => "Diff",
// "Older Version" => "Older Version",
// "Directories" => "Directories",
// "back to" => "back to",
// "Upload From Disk:" => "Upload From Disk:",
// "Upload Files" => "Upload Files",
// "Bytes maximum" => "Bytes maximum",
// "Create Directory:" => "Create Directory:",
// "index file (.shp):" => "index file (.shp):",
// "files to index (regexp):" => "files to index (regexp):",
// "Message Archive" => "Message Archive",
// "Edit template" => "Edit template",
// "messages" => "messages",
// "Archive is full!" => "Archive is full!",
// "Unread" => "Unread",
// "Flagged" => "Flagged",
// "Unflagged" => "Unflagged",
// "1" => "1",
// "2" => "2",
// "3" => "3",
// "4" => "4",
// "5" => "5",
// "Containing" => "Containing",
// "Sender" => "Sender",
// "No messages to display" => "No messages to display",
// "Broadcast message" => "Broadcast message",
// "Message Broadcast" => "Message Broadcast",
// "OK" => "OK",
// "Group" => "Group",
// "All users" => "All users",
// "Lowest" => "Lowest",
// "Low" => "Low",
// "Normal" => "Normal",
// "High" => "High",
// "Very High" => "Very High",
// "Send" => "Send",
// "Compose message" => "Compose message",
// "Compose Message" => "Compose Message",
// "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences." => "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences.",
// "ERROR" => "ERROR",
// "Invalid" => "Invalid",
// "Separate multiple usernames with a comma (&nbsp;,&nbsp;)." => "Separate multiple usernames with a comma (&nbsp;,&nbsp;).",
// "To" => "To",
// "CC" => "CC",
// "BCC" => "BCC",
// "No messages to download" => "No messages to download",
// "Mailbox is full! Delete or archive some messages if you want to receive more messages." => "Mailbox is full! Delete or archive some messages if you want to receive more messages.",
// "is reply to" => "is reply to",
// "Find replied message" => "Find replied message",
// "Archive" => "Archive",
// "Mark as read" => "Mark as read",
// "Mark as unread" => "Mark as unread",
// "Mark as flagged" => "Mark as flagged",
// "Mark as unflagged" => "Mark as unflagged",
// "Mark" => "Mark",
// "Mailbox" => "Mailbox",
// "Compose" => "Compose",
// "Broadcast" => "Broadcast",
// "Sent" => "Sent",
// "Auto-archive age for read messages:" => "Auto-archive age for read messages:",
// "Read message" => "Read message",
// "Return to mailbox" => "Return to mailbox",
// "replyall" => "replyall",
// "Unflag" => "Unflag",
// "Flag this message" => "Flag this message",
// "Cc" => "Cc",
// "Return to archive" => "Return to archive",
// "Return to outbox" => "Return to outbox",
// "Sent Messages" => "Sent Messages",
// "Replied" => "Replied",
// "Not replied" => "Not replied",
// "move to archive" => "move to archive",
// "receiver" => "receiver",
// "No" => "No",
// "'name' parameter for tikimodule missed" => "'name' parameter for tikimodule missed",
// "Move module up" => "Move module up",
// "Up" => "Up",
// "Move module down" => "Move module down",
// "Down" => "Down",
// "Move module to opposite side" => "Move module to opposite side",
// "opp side" => "opp side",
// "Unassign this module" => "Unassign this module",
// "Are you sure you want to unassign this module?" => "Are you sure you want to unassign this module?",
// "Toggle module contents" => "Toggle module contents",
// "toggle" => "toggle",
// "Admin Menu" => "Admin Menu",
// "\$tpl_module_title" => "\$tpl_module_title",
// "Live support" => "Live support",
// "Banning" => "Banning",
// "Users" => "Users",
// "Groups" => "Groups",
// "Cache" => "Cache",
// "Modules" => "Modules",
// "Links" => "Links",
// "Hotwords" => "Hotwords",
// "RSS modules" => "RSS modules",
// "Menus" => "Menus",
// "Polls" => "Polls",
// "Mail notifications" => "Mail notifications",
// "Search stats" => "Search stats",
// "QuickTags" => "QuickTags",
// "Chat" => "Chat",
// "Categories" => "Categories",
// "Banners" => "Banners",
// "Edit templates" => "Edit templates",
// "Admin drawings" => "Admin drawings",
// "Dynamic content" => "Dynamic content",
// "Cookies" => "Cookies",
// "Mail-in" => "Mail-in",
// "Content templates" => "Content templates",
// "HTML pages" => "HTML pages",
// "Shoutbox" => "Shoutbox",
// "Shoutbox Words" => "Shoutbox Words",
// "Referer stats" => "Referer stats",
// "Import PHPWiki Dump" => "Import PHPWiki Dump",
// "phpinfo" => "phpinfo",
// "Admin dsn" => "Admin dsn",
// "External wikis" => "External wikis",
// "System Admin" => "System Admin",
// "Security Admin" => "Security Admin",
// "Syntax highlighting" => "Syntax highlighting",
// "Display type unknown, you have to enter the banner type" => "Display type unknown, you have to enter the banner type",
// "You forgot your Google ad_client number !" => "You forgot your Google ad_client number !",
// "Menu" => "Menu",
// "Contact us" => "Contact us",
// "Stats" => "Stats",
// "Games" => "Games",
// "MyMenu" => "MyMenu",
// "MyTiki" => "MyTiki",
// "MyTiki home" => "MyTiki home",
// "Preferences" => "Preferences",
// "Tasks" => "Tasks",
// "Bookmarks" => "Bookmarks",
// "Newsreader" => "Newsreader",
// "Webmail" => "Webmail",
// "Notepad" => "Notepad",
// "My files" => "My files",
// "User menu" => "User menu",
// "Mini calendar" => "Mini calendar",
// "My watches" => "My watches",
// "WfMenu" => "WfMenu",
// "Workflow" => "Workflow",
// "Admin processes" => "Admin processes",
// "Monitor processes" => "Monitor processes",
// "Monitor activities" => "Monitor activities",
// "Monitor instances" => "Monitor instances",
// "User processes" => "User processes",
// "User activities" => "User activities",
// "User instances" => "User instances",
// "FriendsMenu" => "FriendsMenu",
// "Community" => "Community",
// "User list" => "User list",
// "Friendship Network" => "Friendship Network",
// "WikiMenu" => "WikiMenu",
// "Last changes" => "Last changes",
// "Dump" => "Dump",
// "Rankings" => "Rankings",
// "List pages" => "List pages",
// "Orphan pages" => "Orphan pages",
// "Sandbox" => "Sandbox",
// "Print" => "Print",
// "Send pages" => "Send pages",
// "Received pages" => "Received pages",
// "Structures" => "Structures",
// "GalMenu" => "GalMenu",
// "Image Galleries" => "Image Galleries",
// "Galleries" => "Galleries",
// "Upload image" => "Upload image",
// "System gallery" => "System gallery",
// "Articles home" => "Articles home",
// "Submit article" => "Submit article",
// "View submissions" => "View submissions",
// "New article" => "New article",
// "Send articles" => "Send articles",
// "Received articles" => "Received articles",
// "Admin topics" => "Admin topics",
// "Admin types" => "Admin types",
// "List blogs" => "List blogs",
// "Create/Edit blog" => "Create/Edit blog",
// "Admin posts" => "Admin posts",
// "ForMenu" => "ForMenu",
// "List forums" => "List forums",
// "Admin forums" => "Admin forums",
// "DirMenu" => "DirMenu",
// "Submit a new link" => "Submit a new link",
// "Browse directory" => "Browse directory",
// "Admin directory" => "Admin directory",
// "FileGalMenu" => "FileGalMenu",
// "File Galleries" => "File Galleries",
// "List galleries" => "List galleries",
// "List FAQs" => "List FAQs",
// "Admin FAQs" => "Admin FAQs",
// "Maps" => "Maps",
// "Layer management" => "Layer management",
// "QuizMenu" => "QuizMenu",
// "List quizzes" => "List quizzes",
// "Quiz stats" => "Quiz stats",
// "Admin quiz" => "Admin quiz",
// "ShtMenu" => "ShtMenu",
// "TrkMenu" => "TrkMenu",
// "List trackers" => "List trackers",
// "Admin trackers" => "Admin trackers",
// "SrvMenu" => "SrvMenu",
// "Surveys" => "Surveys",
// "List surveys" => "List surveys",
// "Admin surveys" => "Admin surveys",
// "Newsletters" => "Newsletters",
// "Send newsletters" => "Send newsletters",
// "Admin newsletters" => "Admin newsletters",
// "Events" => "Events",
// "Send events" => "Send events",
// "Admin events" => "Admin events",
// "EphMenu" => "EphMenu",
// "Ephemerides" => "Ephemerides",
// "Ephemerides Admin" => "Ephemerides Admin",
// "ChartMenu" => "ChartMenu",
// "Charts Admin" => "Charts Admin",
// "AdmMenu" => "AdmMenu",
// "Admin" => "Admin",
// "Admin home" => "Admin home",
// "Debugger console" => "Debugger console",
// "Theme control" => "Theme control",
// "Drawings" => "Drawings",
// "Edit languages" => "Edit languages",
// "Integrator" => "Integrator",
// "DSN" => "DSN",
// "Mods Admin" => "Mods Admin",
// "UsrMenu" => "UsrMenu",
// "Click here to manage your personal menu" => "Click here to manage your personal menu",
// "User Menu" => "User Menu",
// "\$module_title" => "\$module_title",
// "More..." => "More...",
// "Tikiwiki Assistant" => "Tikiwiki Assistant",
// "Thank you for installing Tikiwiki" => "Thank you for installing Tikiwiki",
// "To configure your Tiki" => "To configure your Tiki",
// "Select" => "Select",
// "Admin Home" => "Admin Home",
// "from the menu" => "from the menu",
// "Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>",
// "Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies",
// "To remove this module" => "To remove this module",
// "Admin Modules" => "Admin Modules",
// "and remove the assistant module" => "and remove the assistant module",
// "You can also add other modules" => "You can also add other modules",
// "To customize the menu" => "To customize the menu",
// "Admin Menus" => "Admin Menus",
// "and edit menu ID 42" => "and edit menu ID 42",
// "Or, create your own menu and add it to a module" => "Or, create your own menu and add it to a module",
// "To begin configuring Tiki, please" => "To begin configuring Tiki, please",
// "login" => "login",
// "as the Admin" => "as the Admin",
// "The Tikiwiki Community" => "The Tikiwiki Community",
// "To learn more, visit: <a href=\"http://www.tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://www.tikiwiki.org</a>" => "To learn more, visit: <a href=\"http://www.tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://www.tikiwiki.org</a>",
// "Tikiwiki Documentation" => "Tikiwiki Documentation",
// "For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>" => "For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>",
// "Last `\$module_rows` blog comments" => "Last `\$module_rows` blog comments",
// "Last blog comments" => "Last blog comments",
// " on blogpost " => " on blogpost ",
// "Recently visited pages" => "Recently visited pages",
// "January" => "January",
// "February" => "February",
// "March" => "March",
// "April" => "April",
// "May" => "May",
// "June" => "June",
// "July" => "July",
// "August" => "August",
// "September" => "September",
// "October" => "October",
// "November" => "November",
// "December" => "December",
// "Monday" => "Monday",
// "Tuesday" => "Tuesday",
// "Wednesday" => "Wednesday",
// "Thursday" => "Thursday",
// "Friday" => "Friday",
// "Saturday" => "Saturday",
// "Sunday" => "Sunday",
// "Today" => "Today",
// "\$modcattitle" => "\$modcattitle",
// "Received objects" => "Received objects",
// "Pages:" => "Pages:",
// "Last `\$module_rows` Sites" => "Last `\$module_rows` Sites",
// "Last Sites" => "Last Sites",
// "Directory Stats" => "Directory Stats",
// "Sites" => "Sites",
// "Sites to validate" => "Sites to validate",
// "Searches" => "Searches",
// "Visited links" => "Visited links",
// "Top \$module_rows Sites" => "Top \$module_rows Sites",
// "Top Sites" => "Top Sites",
// "Current events" => "Current events",
// "Featured links" => "Featured links",
// "Top `\$module_rows` topics" => "Top `\$module_rows` topics",
// "Top topics" => "Top topics",
// "Last `\$module_rows` forum posts" => "Last `\$module_rows` forum posts",
// "Last forum posts" => "Last forum posts",
// "Last `\$module_rows` forum topics" => "Last `\$module_rows` forum topics",
// "Last forum topics" => "Last forum topics",
// "Most commented forums" => "Most commented forums",
// "Most read topics" => "Most read topics",
// "Most visited forums" => "Most visited forums",
// "Folksonomy" => "Folksonomy",
// "Tags This Page Has" => "Tags This Page Has",
// "Add tags" => "Add tags",
// "More Like This" => "More Like This",
// "Most popular tags" => "Most popular tags",
// "List everything tagged" => "List everything tagged",
// "My prefered tags" => "My prefered tags",
// "Google Search" => "Google Search",
// "Last `\$module_rows` actions" => "Last `\$module_rows` actions",
// "Last actions" => "Last actions",
// "Last `\$module_rows` articles" => "Last `\$module_rows` articles",
// "Last articles" => "Last articles",
// "Last `\$module_rows` blog posts" => "Last `\$module_rows` blog posts",
// "Last blog posts" => "Last blog posts",
// "Last" => "Last",
// "\$type" => "\$type",
// "Last `\$module_rows` Created blogs" => "Last `\$module_rows` Created blogs",
// "Last Created blogs" => "Last Created blogs",
// "Last `\$module_rows` Created FAQs" => "Last `\$module_rows` Created FAQs",
// "Last Created FAQs" => "Last Created FAQs",
// "Last `\$module_rows` Created Quizzes" => "Last `\$module_rows` Created Quizzes",
// "Last Created Quizzes" => "Last Created Quizzes",
// "Last `\$module_rows` modified file galleries" => "Last `\$module_rows` modified file galleries",
// "Last modified file galleries" => "Last modified file galleries",
// "Last `\$module_rows` Files" => "Last `\$module_rows` Files",
// "Last Files" => "Last Files",
// "Last `\$module_rows` galleries" => "Last `\$module_rows` galleries",
// "Last galleries" => "Last galleries",
// "Last `\$module_rows` Images" => "Last `\$module_rows` Images",
// "Last Images" => "Last Images",
// "insert original" => "insert original",
// "insert thumbnail" => "insert thumbnail",
// "Last `\$module_rows` modified events" => "Last `\$module_rows` modified events",
// "Last modifed events" => "Last modifed events",
// "Last `\$module_rows` changes" => "Last `\$module_rows` changes",
// "more" => "more",
// "Last `\$module_rows` Modified Items" => "Last `\$module_rows` Modified Items",
// "Last Modified Items" => "Last Modified Items",
// "Last `\$module_rows` Modified blogs" => "Last `\$module_rows` Modified blogs",
// "Last Modified blogs" => "Last Modified blogs",
// "Last `\$module_rows` submissions" => "Last `\$module_rows` submissions",
// "Last submissions" => "Last submissions",
// "Last `\$module_rows` Modified Comments" => "Last `\$module_rows` Modified Comments",
// "Last Modified Comments" => "Last Modified Comments",
// "Last `\$module_rows` Items" => "Last `\$module_rows` Items",
// "Last Items" => "Last Items",
// "Last `\$module_rows` visitors" => "Last `\$module_rows` visitors",
// "Last Visitors" => "Last Visitors",
// "No avatar." => "No avatar.",
// "Register" => "Register",
// "You" => "You",
// "Open operator console" => "Open operator console",
// "Online users" => "Online users",
// "We have" => "We have",
// "online users" => "online users",
// "Logged in as" => "Logged in as",
// "Logout" => "Logout",
// "Switch User" => "Switch User",
// "Paramaters" => "Paramaters",
// "applicable for this item" => "applicable for this item",
// "Switch" => "Switch",
// "Switch user" => "Switch user",
// "Login through CAS" => "Login through CAS",
// "Login as admin" => "Login as admin",
// "Login through Shibboleth" => "Login through Shibboleth",
// "Login as" => "Login as",
// "Email" => "Email",
// "eMail" => "eMail",
// "Password" => "Password",
// "Remember me" => "Remember me",
// "Click here to register" => "Click here to register",
// "Click here if you've forgotten your password" => "Click here if you've forgotten your password",
// "I forgot my pass" => "I forgot my pass",
// "I forgot my password" => "I forgot my password",
// "Click here to login using the default security protocol" => "Click here to login using the default security protocol",
// "Standard" => "Standard",
// "Click here to login using a secure protocol" => "Click here to login using a secure protocol",
// "Secure" => "Secure",
// "Stay in ssl Mode" => "Stay in ssl Mode",
// "local account" => "local account",
// "OpenID Login" => "OpenID Login",
// "What is OpenID?" => "What is OpenID?",
// "Tiki Logo" => "Tiki Logo",
// "You have" => "You have",
// "New Messages" => "New Messages",
// "New Message" => "New Message",
// "You have 0 new messages" => "You have 0 new messages",
// "Waiting Submissions" => "Waiting Submissions",
// "submissions waiting to be examined" => "submissions waiting to be examined",
// "Old articles" => "Old articles",
// "Send a message to" => "Send a message to",
// "Send a message" => "Send a message",
// "Random Images" => "Random Images",
// "Random Pages" => "Random Pages",
// "Register as a new user" => "Register as a new user",
// "Your email could not be validated; make sure you email is correct and click register below." => "Your email could not be validated; make sure you email is correct and click register below.",
// "Your registration code:" => "Your registration code:",
// "Username" => "Username",
// "Passcode to register (not your user password)" => "Passcode to register (not your user password)",
// "Registration code" => "Registration code",
// "Repeat password" => "Repeat password",
// "Generate a password" => "Generate a password",
// "RSS Feeds" => "RSS Feeds",
// "Wiki RSS" => "Wiki RSS",
// "Blogs RSS" => "Blogs RSS",
// "Articles RSS" => "Articles RSS",
// "Image Galleries RSS" => "Image Galleries RSS",
// "File Galleries RSS" => "File Galleries RSS",
// "Forums RSS" => "Forums RSS",
// "Maps RSS" => "Maps RSS",
// "Calendars" => "Calendars",
// "in:" => "in:",
// "Entire Site" => "Entire Site",
// "Wiki Pages" => "Wiki Pages",
// "Image Gals" => "Image Gals",
// "Images" => "Images",
// "Blog Posts" => "Blog Posts",
// "Search Wiki PageName" => "Search Wiki PageName",
// "Read More" => "Read More",
// "Since your last visit on" => "Since your last visit on",
// "New Images" => "New Images",
// "Wiki Pages Changed" => "Wiki Pages Changed",
// "New Files" => "New Files",
// "New Comments" => "New Comments",
// "New Tracker Items" => "New Tracker Items",
// "New Calendar Events" => "New Calendar Events",
// "New Users" => "New Users",
// "`\$slvn_info.label`" => "`\$slvn_info.label`",
// "click to edit" => "click to edit",
// "Nothing has changed" => "Nothing has changed",
// "click to show/hide" => "click to show/hide",
// "Site Language:" => "Site Language:",
// "Site default" => "Site default",
// "TikiTests Menu" => "TikiTests Menu",
// "List Tests" => "List Tests",
// "Create Test" => "Create Test",
// "Most Active blogs" => "Most Active blogs",
// "Top `\$module_rows` articles" => "Top `\$module_rows` articles",
// "Top articles" => "Top articles",
// "Top `\$module_rows` File Galleries" => "Top `\$module_rows` File Galleries",
// "Top File Galleries" => "Top File Galleries",
// "Top `\$module_rows` files" => "Top `\$module_rows` files",
// "Top files" => "Top files",
// "Top `\$module_rows` Forum Posters" => "Top `\$module_rows` Forum Posters",
// "Top Forum Posters" => "Top Forum Posters",
// "Top `\$module_rows` games" => "Top `\$module_rows` games",
// "Top games" => "Top games",
// "Top `\$module_rows` galleries" => "Top `\$module_rows` galleries",
// "Top galleries" => "Top galleries",
// "Top `\$module_rows` Images" => "Top `\$module_rows` Images",
// "Top Images" => "Top Images",
// "Top `\$module_rows` Objects" => "Top `\$module_rows` Objects",
// "Top Objects" => "Top Objects",
// "Top `\$module_rows` Pages" => "Top `\$module_rows` Pages",
// "Top Pages" => "Top Pages",
// "Top `\$module_rows` Quizzes" => "Top `\$module_rows` Quizzes",
// "Top Quizzes" => "Top Quizzes",
// "Most `\$module_rows` visited blogs" => "Most `\$module_rows` visited blogs",
// "Top `\$module_rows` Visited FAQs" => "Top `\$module_rows` Visited FAQs",
// "Top Visited FAQs" => "Top Visited FAQs",
// "Page translation" => "Page translation",
// "There are no translations of this page." => "There are no translations of this page.",
// "Up-to-date-ness" => "Up-to-date-ness",
// "Better translations" => "Better translations",
// "update from it" => "update from it",
// "view" => "view",
// "None match your" => "None match your",
// "Set your preferred languages." => "Set your preferred languages.",
// "preferred languages" => "preferred languages",
// "Equivalent translations" => "Equivalent translations",
// "Translations that need improvement" => "Translations that need improvement",
// "update it" => "update it",
// "Upcoming `\$module_rows` events" => "Upcoming `\$module_rows` events",
// "The Next Event" => "The Next Event",
// "No Upcoming Events" => "No Upcoming Events",
// "click to view" => "click to view",
// "My blogs" => "My blogs",
// "My galleries" => "My galleries",
// "My Pages" => "My Pages",
// "User tasks" => "User tasks",
// "Done" => "Done",
// "Del" => "Del",
// "Public tasks" => "Public tasks",
// "select" => "select",
// "User informations" => "User informations",
// "Group informations" => "Group informations",
// "You need to activate user and/or group trackers" => "You need to activate user and/or group trackers",
// "Top users" => "Top users",
// "More" => "More",
// "Whats related" => "Whats related",
// "online user" => "online user",
// "on host" => "on host",
// "Last `\$module_rows` wiki comments" => "Last `\$module_rows` wiki comments",
// "Last wiki comments" => "Last wiki comments",
// " on page " => " on page ",
// "Changes that need to be reproduced are highlighted below." => "Changes that need to be reproduced are highlighted below.",
// "Real Name" => "Real Name",
// "Click to see the ratings" => "Click to see the ratings",
// "[-]" => "[-]",
// "vote" => "vote",
// "Errors" => "Errors",
// "Insert/Edit an internal wiki link" => "Insert/Edit an internal wiki link",
// "Wiki Link insert" => "Wiki Link insert",
// "Please make a selection of text in order to create a link" => "Please make a selection of text in order to create a link",
// "Insert an image" => "Insert an image",
// "Tiki Image - Insert an image" => "Tiki Image - Insert an image",
// "Structures:" => "Structures:",
// "show structures" => "show structures",
// "hide structures" => "hide structures",
// "Manage structures" => "Manage structures",
// "Are you sure you want to remove this module?" => "Are you sure you want to remove this module?",
// "Powered by" => "Powered by",
// "Execution time" => "Execution time",
// "Memory usage" => "Memory usage",
// "database queries used" => "database queries used",
// "Server load" => "Server load",
// "Locked" => "Locked",
// "page id" => "page id",
// "Cached" => "Cached",
// "3d browser" => "3d browser",
// "Refresh" => "Refresh",
// "Monitor this Page" => "Monitor this Page",
// "Stop Monitoring this Page" => "Stop Monitoring this Page",
// "Backlinks" => "Backlinks",
// "Previous page" => "Previous page",
// "Parent page" => "Parent page",
// "Next page" => "Next page",
// "Child" => "Child",
// "Add Page" => "Add Page",
// "First page" => "First page",
// "page" => "page",
// "Last page" => "Last page",
// "Last edited by" => "Last edited by",
// "based on work by" => "based on work by",
// "Page last modified on" => "Page last modified on",
// "Contributors to this page" => "Contributors to this page",
// "Created by:" => "Created by:",
// "Last Modification:" => "Last Modification:",
// "To edit the copyright notices" => "To edit the copyright notices",
// "Click Here" => "Click Here",
// "The content on this page is licensed under the terms of the" => "The content on this page is licensed under the terms of the",
// "The original document is available at" => "The original document is available at",
// "For" => "For",
// "Jump to Content" => "Jump to Content",
// "Report to Webmaster" => "Report to Webmaster",
// "Made with" => "Made with",
// "powered by" => "powered by",
// "database queries used in " => "database queries used in ",
// "on:" => "on:",
// "star" => "star",
// "half star" => "half star",
// "Send a link" => "Send a link",
// "Translation" => "Translation",
// "Article image" => "Article image",
// "Topic image" => "Topic image",
// "Source" => "Source",
// "Add Comment" => "Add Comment",
// "1 comment" => "1 comment",
// "comments" => "comments",
// "close" => "close",
// "Location : " => "Location : ",
// "Show/Hide Left Menus" => "Show/Hide Left Menus",
// "Show/Hide Right Menus" => "Show/Hide Right Menus",
// "Email this page" => "Email this page",
// "Rename" => "Rename",
// "Similar" => "Similar",
// "Undo" => "Undo",
// "Slides" => "Slides",
// "Export" => "Export",
// "Discuss" => "Discuss",
// "Attach File" => "Attach File",
// "1 File Attached" => "1 File Attached",
// "{\$atts_cnt} files attached" => "{\$atts_cnt} files attached",
// "Last Modification" => "Last Modification",
// "logged as" => "logged as",
// "pass" => "pass",
// "Page generated in" => "Page generated in",
// "The newsletter was sent to {\$sent} email addresses" => "The newsletter was sent to {\$sent} email addresses",
// "This newsletter will be sent to {\$subscribers} email addresses." => "This newsletter will be sent to {\$subscribers} email addresses.",
// "Prepare a newsletter to be sent" => "Prepare a newsletter to be sent",
// "Apply template" => "Apply template",
// "Data" => "Data",
// "Send Newsletters" => "Send Newsletters",
// "Sent editions" => "Sent editions",
// "sent" => "sent",
// "User List" => "User List",
// "Homework" => "Homework",
// "Assignments" => "Assignments",
// "Last Changes" => "Last Changes",
// "Edit article" => "Edit article",
// "Backups" => "Backups",
// "{|} Files Attached" => "{|} Files Attached",
// "User files" => "User files",
// "Favorites" => "Favorites",
// "Watches" => "Watches",
// "home" => "home",
// "chat" => "chat",
// "contact us" => "contact us",
// "Member list" => "Member list",
// "dump" => "dump",
// "rankings" => "rankings",
// "List Pages" => "List Pages",
// "orphan pages" => "orphan pages",
// "sandbox" => "sandbox",
// "received pages" => "received pages",
// "structures" => "structures",
// "Articles Home" => "Articles Home",
// "Create/Edit Blog" => "Create/Edit Blog",
// "Browse Directory" => "Browse Directory",
// "List Quizzes" => "List Quizzes",
// "List Trackers" => "List Trackers",
// "List Surveys" => "List Surveys",
// "Back to Homepage" => "Back to Homepage",
// "This page is being edited by" => "This page is being edited by",
// "Proceed at your own peril" => "Proceed at your own peril",
// "The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page.",
// "My Footnotes" => "My Footnotes",
// "Edit Summary" => "Edit Summary",
// "Copyright" => "Copyright",
// "Year:" => "Year:",
// "Authors:" => "Authors:",
// "Allow HTML" => "Allow HTML",
// "Spellcheck" => "Spellcheck",
// "Import page" => "Import page",
// "export all versions" => "export all versions",
// "Upload picture" => "Upload picture",
// "no cache" => "no cache",
// "minute" => "minute",
// "License" => "License",
// "Important" => "Important",
// "Minor" => "Minor",
// "Cancel Edit" => "Cancel Edit",
// "RSS Trackers" => "RSS Trackers",
// "left/right" => "left/right",
// "Unassign module" => "Unassign module",
// "debugger console" => "debugger console",
// "Mini Calendar" => "Mini Calendar",
// "Edit mapfiles" => "Edit mapfiles",
// "Quick edit a Wiki page" => "Quick edit a Wiki page",
// "Language: " => "Language: ",
// "Language" => "Language",
// "Edit Post" => "Edit Post",
// "Use wysiwyg editor" => "Use wysiwyg editor",
// "Use normal editor" => "Use normal editor",
// "View Blog" => "View Blog",
// "List Blogs" => "List Blogs",
// "Note: if you want to use images please save the post first and you\n\twill be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor\n\tor use the image URL to include images using the WYSIWYG editor. " => "Note: if you want to use images please save the post first and you\n\twill be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor\n\tor use the image URL to include images using the WYSIWYG editor. ",
// "Use ...page... to separate pages in a multi-page post" => "Use ...page... to separate pages in a multi-page post",
// "Upload image for this post" => "Upload image for this post",
// "Trash" => "Trash",
// "Mark entry as private:" => "Mark entry as private:",
// "Send trackback pings to:" => "Send trackback pings to:",
// "(comma separated list of URIs)" => "(comma separated list of URIs)",
// "Save and Exit" => "Save and Exit",
// "This is" => "This is",
// "by the" => "by the",
// "Tiki community" => "Tiki community",
// "Find:" => "Find:",
// "Sort posts by:" => "Sort posts by:",
// "read more" => "read more",
// "pages" => "pages",
// "Permalink" => "Permalink",
// "View Comments" => "View Comments",
// "Email This Post" => "Email This Post",
// "Viewing blog post" => "Viewing blog post",
// "Return to blog" => "Return to blog",
// "Trackback pings" => "Trackback pings",
// "URI" => "URI",
// "Blog name" => "Blog name",
// "Show/Hide Left Modules" => "Show/Hide Left Modules",
// "Show/Hide Right Modules" => "Show/Hide Right Modules",
// "Last update from CVS" => "Last update from CVS",
// "Translate in" => "Translate in",
// "babelfish it" => "babelfish it",
// "Welcome to" => "Welcome to",
// "Design by" => "Design by",
// "Enlarge area height" => "Enlarge area height",
// "Reduce area height" => "Reduce area height",
// "Do not group by item" => "Do not group by item",
// "Group by item" => "Group by item",
// "Calendar View" => "Calendar View",
// "List View" => "List View",
// "Tiki Action Calendar" => "Tiki Action Calendar",
// "Tools Calendars" => "Tools Calendars",
// "Check / Uncheck All" => "Check / Uncheck All",
// "Apply" => "Apply",
// "Reset" => "Reset",
// "Site Ads and Banners" => "Site Ads and Banners",
// "Activate" => "Activate",
// "Content" => "Content",
// "Test" => "Test",
// "Publish" => "Publish",
// "General" => "General",
// "Features" => "Features",
// "RSS" => "RSS",
// "Meta Tags" => "Meta Tags",
// "Intertiki" => "Intertiki",
// "InterTiki" => "InterTiki",
// "Freetags" => "Freetags",
// "i18n" => "i18n",
// "Wysiwyg editor" => "Wysiwyg editor",
// "Module" => "Module",
// "Customize look and feel of your Tiki" => "Customize look and feel of your Tiki",
// "Look &amp; Feel" => "Look &amp; Feel",
// "Text area" => "Text area",
// "Multimedia" => "Multimedia",
// "To add/remove blogs, go to \"Create/Edit blog\" under \"Blogs\" on the application menu, or" => "To add/remove blogs, go to \"Create/Edit blog\" under \"Blogs\" on the application menu, or",
// "Home Blog" => "Home Blog",
// "Home Blog (main blog)" => "Home Blog (main blog)",
// "Blog features" => "Blog features",
// "Blog level comments" => "Blog level comments",
// "Post level comments" => "Post level comments",
// "Trackbacks Pings" => "Trackbacks Pings",
// "Post level trackback pings" => "Post level trackback pings",
// "Spellchecking" => "Spellchecking",
// "Not Installed" => "Not Installed",
// "Blogs have a custom heading" => "Blogs have a custom heading",
// "Default ordering for blog listing" => "Default ordering for blog listing",
// "Creation date (desc)" => "Creation date (desc)",
// "Last modification date (desc)" => "Last modification date (desc)",
// "Blog title (asc)" => "Blog title (asc)",
// "Number of posts (desc)" => "Number of posts (desc)",
// "Visits (desc)" => "Visits (desc)",
// "Activity (desc)" => "Activity (desc)",
// "Force and limit categorization to within subtree of" => "Force and limit categorization to within subtree of",
// "Change preferences" => "Change preferences",
// "Blog listing configuration (when listing available blogs)" => "Blog listing configuration (when listing available blogs)",
// "Title length" => "Title length",
// "Creation date" => "Creation date",
// "Last modification time" => "Last modification time",
// "Disabled" => "Disabled",
// "Plain text" => "Plain text",
// "Link to user information" => "Link to user information",
// "User avatar" => "User avatar",
// "Blog comments settings" => "Blog comments settings",
// "Default number of comments per page" => "Default number of comments per page",
// "Comments default ordering" => "Comments default ordering",
// "Points" => "Points",
// "To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or",
// "Group calendar sticky popup" => "Group calendar sticky popup",
// "Group calendar item view tab" => "Group calendar item view tab",
// "Default view mode" => "Default view mode",
// "Day" => "Day",
// "Week" => "Week",
// "Month" => "Month",
// "Quarter" => "Quarter",
// "Semester" => "Semester",
// "Calendar manual selection of time/date" => "Calendar manual selection of time/date",
// "JsCalendar" => "JsCalendar",
// "First day of the week" => "First day of the week",
// "Depends user language" => "Depends user language",
// "Split hours in periods of" => "Split hours in periods of",
// "1 minute" => "1 minute",
// "5 minutes" => "5 minutes",
// "10 minutes" => "10 minutes",
// "15 minutes" => "15 minutes",
// "30 minutes" => "30 minutes",
// "First year in the dropdown, either year number, or relative to current year (+/- N)" => "First year in the dropdown, either year number, or relative to current year (+/- N)",
// "if no jscalendar" => "if no jscalendar",
// "Last year in the dropdown, either year number, or relative to current year (+/- N)" => "Last year in the dropdown, either year number, or relative to current year (+/- N)",
// "Change settings" => "Change settings",
// "Use categories to regroup various Tiki objects" => "Use categories to regroup various Tiki objects",
// "Link to" => "Link to",
// "Browse categories" => "Browse categories",
// "Administer categories" => "Administer categories",
// "Show Category Path" => "Show Category Path",
// "Exclude These Category IDs from Path (comma delimited)" => "Exclude These Category IDs from Path (comma delimited)",
// "Show Category Objects" => "Show Category Objects",
// "Search may show forbidden results. Much better performance though." => "Search may show forbidden results. Much better performance though.",
// "Ignore category viewing restrictions" => "Ignore category viewing restrictions",
// "Permission to all (not just any) of an object's categories is required for access" => "Permission to all (not just any) of an object's categories is required for access",
// "Categories browse uses PhpLayers" => "Categories browse uses PhpLayers",
// "The feature must be activated" => "The feature must be activated",
// "Look under \"Articles\" on the application menu for links to" => "Look under \"Articles\" on the application menu for links to",
// "CMS features" => "CMS features",
// "Submissions" => "Submissions",
// "Use templates" => "Use templates",
// "Print article" => "Print article",
// "Can specify notification emails when creating an article" => "Can specify notification emails when creating an article",
// "Settings for page articles home" => "Settings for page articles home",
// "Maximum number of articles in home" => "Maximum number of articles in home",
// "Topic" => "Topic",
// "Article comments settings" => "Article comments settings",
// "Fields to display on page" => "Fields to display on page",
// "Publish Date" => "Publish Date",
// "Expire Date" => "Expire Date",
// "Visible" => "Visible",
// "Img" => "Img",
// "Import CSV file" => "Import CSV file",
// "Batch upload (CSV file):" => "Batch upload (CSV file):",
// "Import" => "Import",
// "User identity features" => "User identity features",
// "Show user's info on mouseover" => "Show user's info on mouseover",
// "Picture" => "Picture",
// "Number of friends" => "Number of friends",
// "E-mail" => "E-mail",
// "Last login" => "Last login",
// "Distance" => "Distance",
// "Set features" => "Set features",
// "Users sort order" => "Users sort order",
// "Score ascending" => "Score ascending",
// "Score descending" => "Score descending",
// "Name ascending" => "Name ascending",
// "Name descending" => "Name descending",
// "Login ascending" => "Login ascending",
// "Login descending" => "Login descending",
// "Copyright allows to determine a copyright for all the objects of tikiwiki" => "Copyright allows to determine a copyright for all the objects of tikiwiki",
// "Copyright Management" => "Copyright Management",
// "License Page" => "License Page",
// "Submit Notice" => "Submit Notice",
// "Enable Feature for Wiki" => "Enable Feature for Wiki",
// "Enable Feature for Articles" => "Enable Feature for Articles",
// "Enable Feature for Blogues" => "Enable Feature for Blogues",
// "Enable Feature for Faqs" => "Enable Feature for Faqs",
// "To configure your directory, find \"Admin directory\" under \"Directory\" on the application menu, or" => "To configure your directory, find \"Admin directory\" under \"Directory\" on the application menu, or",
// "Number of columns per page when listing categories" => "Number of columns per page when listing categories",
// "Links per page" => "Links per page",
// "Validate URLs" => "Validate URLs",
// "enable cool sites" => "enable cool sites",
// "Show Country Flag" => "Show Country Flag",
// "Method to open directory links" => "Method to open directory links",
// "replace current window" => "replace current window",
// "New Window" => "New Window",
// "inline frame" => "inline frame",
// "To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or",
// "Question and Answer prefix on Answers" => "Question and Answer prefix on Answers",
// "Q and A" => "Q and A",
// "Question ID" => "Question ID",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>evaluation of each feature</a> on Tiki's developer site." => "Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>evaluation of each feature</a> on Tiki's developer site.",
// "No tabs" => "No tabs",
// "Main" => "Main",
// "Global Features" => "Global Features",
// "More Functionality" => "More Functionality",
// "Technology" => "Technology",
// "UI Enhancements" => "UI Enhancements",
// "Extra Stuff &amp; Fun" => "Extra Stuff &amp; Fun",
// "Content Related" => "Content Related",
// "Main Features" => "Main Features",
// "Site Global Features" => "Site Global Features",
// "Action Log" => "Action Log",
// "Action log setting" => "Action log setting",
// "Feature documentation links" => "Feature documentation links",
// "Help System (Feature documentation links)" => "Help System (Feature documentation links)",
// "Additional Features" => "Additional Features",
// "Featured Help" => "Featured Help",
// "Spreadsheet" => "Spreadsheet",
// "Tiki Sheet" => "Tiki Sheet",
// "Copyright System" => "Copyright System",
// "Copyright system" => "Copyright system",
// "Live Support" => "Live Support",
// "Live support system" => "Live support system",
// "Tell a Friend" => "Tell a Friend",
// "Allow to post comments as Anonymous" => "Allow to post comments as Anonymous",
// "Technical Features" => "Technical Features",
// "Search engine friendly url" => "Search engine friendly url",
// "Swffix" => "Swffix",
// "Ajax" => "Ajax",
// "XMLRPC API" => "XMLRPC API",
// "HTML Purifier" => "HTML Purifier",
// "HTML Purifier (Content is cleaned to XHTML 1.1 Strict on each save)" => "HTML Purifier (Content is cleaned to XHTML 1.1 Strict on each save)",
// "User interface enhancement features" => "User interface enhancement features",
// "JavaScript popup date selector" => "JavaScript popup date selector",
// "PHPLayers" => "PHPLayers",
// "PhpLayers Dynamic menus" => "PhpLayers Dynamic menus",
// "Allow users to activate fullscreen mode" => "Allow users to activate fullscreen mode",
// "Css Menus (suckerfish)" => "Css Menus (suckerfish)",
// "Shadowbox" => "Shadowbox",
// "required" => "required",
// "Mootools" => "Mootools",
// "Experimental Features" => "Experimental Features",
// "Workflow engine" => "Workflow engine",
// "Friendship" => "Friendship",
// "Mobile" => "Mobile",
// "Morcego 3D browser" => "Morcego 3D browser",
// "Content Features" => "Content Features",
// "Edit Templates" => "Edit Templates",
// "Hotwords in New Windows" => "Hotwords in New Windows",
// "Use File Galleries for images inclusion" => "Use File Galleries for images inclusion",
// "Custom Home" => "Custom Home",
// "HTML Pages" => "HTML Pages",
// "Dynamic Content System" => "Dynamic Content System",
// "Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting" => "Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting",
// "Administration Features" => "Administration Features",
// "Banning System" => "Banning System",
// "Banning system" => "Banning system",
// "Debugger Console" => "Debugger Console",
// "Action Calendar" => "Action Calendar",
// "Tiki action calendar" => "Tiki action calendar",
// "Referer Stats" => "Referer Stats",
// "Contact Us" => "Contact Us",
// "Contact Us (Anonymous)" => "Contact Us (Anonymous)",
// "Redirect On Error" => "Redirect On Error",
// "Communications (send/receive objects)" => "Communications (send/receive objects)",
// "TikiTests" => "TikiTests",
// "User Features" => "User Features",
// "Display 'MyTiki' in the application menu" => "Display 'MyTiki' in the application menu",
// "User Preferences Screen" => "User Preferences Screen",
// "User Notepad" => "User Notepad",
// "User Bookmarks" => "User Bookmarks",
// "User Contacts" => "User Contacts",
// "User Watches" => "User Watches",
// "User Watches Translations" => "User Watches Translations",
// "User Tasks" => "User Tasks",
// "User Messages" => "User Messages",
// "User Files" => "User Files",
// "User Levels" => "User Levels",
// "To add/remove file galleries, go to \"File Galleries\" on the application menu, or" => "To add/remove file galleries, go to \"File Galleries\" on the application menu, or",
// "If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "If you decide to store files in a directory you must ensure that the user cannot access directly to the directory.",
// "You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>",
// "To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/",
// "Home Gallery" => "Home Gallery",
// "Home Gallery (main gallery)" => "Home Gallery (main gallery)",
// "Galleries features" => "Galleries features",
// "Allow download limit per file" => "Allow download limit per file",
// "Prevent download if score becomes negative" => "Prevent download if score becomes negative",
// "File author" => "File author",
// "For not registered author" => "For not registered author",
// "Allow same file to be uploaded more than once" => "Allow same file to be uploaded more than once",
// "Never" => "Never",
// "Yes, even in the same gallery" => "Yes, even in the same gallery",
// "Only in different galleries" => "Only in different galleries",
// "Use database to store files" => "Use database to store files",
// "Use a directory to store files" => "Use a directory to store files",
// "Directory path" => "Directory path",
// "The server must be able to read/write the directory." => "The server must be able to read/write the directory.",
// "The directory can be outside the web space." => "The directory can be outside the web space.",
// "PodCast directory (must be web accessible):" => "PodCast directory (must be web accessible):",
// "Directory Batch Loading" => "Directory Batch Loading",
// "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols",
// "Enable directory batch loading" => "Enable directory batch loading",
// "Batch loading directory" => "Batch loading directory",
// "The server must be able to read the directory." => "The server must be able to read the directory.",
// "Uploaded filenames must match regex" => "Uploaded filenames must match regex",
// "Uploaded filenames cannot match regex" => "Uploaded filenames cannot match regex",
// "Gallery listing configuration" => "Gallery listing configuration",
// "Change configuration" => "Change configuration",
// "File galleries comments settings" => "File galleries comments settings",
// "File galleries search indexing" => "File galleries search indexing",
// "Leave command blank to delete handler" => "Leave command blank to delete handler",
// "Use %1 for where internal file name should be substituted (example: \"strings %1\" to convert the document to text using the unix strings command)" => "Use %1 for where internal file name should be substituted (example: \"strings %1\" to convert the document to text using the unix strings command)",
// "Enable auto indexing on file upload or change" => "Enable auto indexing on file upload or change",
// "MIME Type" => "MIME Type",
// "System command" => "System command",
// "Reindex all files for search" => "Reindex all files for search",
// "To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or",
// "Home Forum" => "Home Forum",
// "Home Forum (main forum)" => "Home Forum (main forum)",
// "Forums features" => "Forums features",
// "Accept wiki syntax" => "Accept wiki syntax",
// "Enable topics archiving" => "Enable topics archiving",
// "Allow first posts of a thread to have an empty body (will be a thread title)" => "Allow first posts of a thread to have an empty body (will be a thread title)",
// "Reply posts are empty" => "Reply posts are empty",
// "Forum quick jumps" => "Forum quick jumps",
// "Ordering for forums in the forum listing" => "Ordering for forums in the forum listing",
// "Creation Date (asc)" => "Creation Date (asc)",
// "Creation Date (desc)" => "Creation Date (desc)",
// "Topics (desc)" => "Topics (desc)",
// "Threads (desc)" => "Threads (desc)",
// "Last post (desc)" => "Last post (desc)",
// "Name (desc)" => "Name (desc)",
// "Name (asc)" => "Name (asc)",
// "Search some forums by name (on \"forum list\")" => "Search some forums by name (on \"forum list\")",
// "Search some forums by content on \"forum list\" (needs feature_search activated)" => "Search some forums by content on \"forum list\" (needs feature_search activated)",
// "Search in topics content on forum page (needs feature_search activated)" => "Search in topics content on forum page (needs feature_search activated)",
// "Search method when searching in content: Tiki search local to a forum" => "Search method when searching in content: Tiki search local to a forum",
// "Search method when searching in content: Non-Tiki search local to a forum" => "Search method when searching in content: Non-Tiki search local to a forum",
// "Do not prefix messages titles by 'Re: '" => "Do not prefix messages titles by 'Re: '",
// "Forum listing configuration" => "Forum listing configuration",
// "Topics" => "Topics",
// "Posts per day" => "Posts per day",
// "Threads default preferences" => "Threads default preferences",
// "Allow to manage thread defaults in each forum configuration" => "Allow to manage thread defaults in each forum configuration",
// "Display thread configuration bar to override defaults" => "Display thread configuration bar to override defaults",
// "Configuration bar settings are kept for all forums during the user session:" => "Configuration bar settings are kept for all forums during the user session:",
// "Default thread style" => "Default thread style",
// "Default thread sort mode" => "Default thread sort mode",
// "Freetags rock!" => "Freetags rock!",
// "Freetag Browsing" => "Freetag Browsing",
// "Show Tag Cloud" => "Show Tag Cloud",
// "Random tag cloud colors (separated by comma)" => "Random tag cloud colors (separated by comma)",
// "Preload freetag random search when arriving on <a href=\"tiki-browse_freetags.php\">freetag search grid</a>" => "Preload freetag random search when arriving on <a href=\"tiki-browse_freetags.php\">freetag search grid</a>",
// "Number of Tags to show in Cloud" => "Number of Tags to show in Cloud",
// "Number of Tags to show in Tag Suggestions" => "Number of Tags to show in Tag Suggestions",
// "Valid characters pattern" => "Valid characters pattern",
// "Only accept alphanumeric ASCII freetags (no accents or special chars)" => "Only accept alphanumeric ASCII freetags (no accents or special chars)",
// "Accept all" => "Accept all",
// "Only accept lowercase freetags" => "Only accept lowercase freetags",
// "Handle multilingual freetags" => "Handle multilingual freetags",
// "Tag Management" => "Tag Management",
// "Cleanup unused tags" => "Cleanup unused tags",
// "cleanup" => "cleanup",
// "More Like This/Get Similar Module" => "More Like This/Get Similar Module",
// "More Like This algorithm" => "More Like This algorithm",
// "basic" => "basic",
// "weighted" => "weighted",
// "Basic algorithm - Minimum amount of tags in common" => "Basic algorithm - Minimum amount of tags in common",
// "6" => "6",
// "7" => "7",
// "8" => "8",
// "9" => "9",
// "Freetag 3D Browser Configuration" => "Freetag 3D Browser Configuration",
// "Enable freetags 3D browser" => "Enable freetags 3D browser",
// "Browser width" => "Browser width",
// "Browser height" => "Browser height",
// "Graph appearance" => "Graph appearance",
// "Navigation depth" => "Navigation depth",
// "Node size" => "Node size",
// "Text size" => "Text size",
// "Spring (connection) size" => "Spring (connection) size",
// "Node color" => "Node color",
// "Camera settings" => "Camera settings",
// "Camera distance adjusted relative to nearest node" => "Camera distance adjusted relative to nearest node",
// "Camera distance" => "Camera distance",
// "Field of view" => "Field of view",
// "Feed animation interval (milisecs)" => "Feed animation interval (milisecs)",
// "Physics engine" => "Physics engine",
// "Friction constant" => "Friction constant",
// "Elastic constant" => "Elastic constant",
// "Eletrostatic constant" => "Eletrostatic constant",
// "Node mass" => "Node mass",
// "Node charge" => "Node charge",
// "To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "To add/remove image galleries, go to \"Image Galleries\" on the application menu, or",
// "You can upload images of a size of " => "You can upload images of a size of ",
// "Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value",
// "Uses Slideshow" => "Uses Slideshow",
// "Use database to store images" => "Use database to store images",
// "Use a directory to store images" => "Use a directory to store images",
// "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below." => "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below.",
// "Library to use for processing images" => "Library to use for processing images",
// "Uploaded image names must match regex" => "Uploaded image names must match regex",
// "Uploaded image names cannot match regex" => "Uploaded image names cannot match regex",
// "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols",
// "Display image informations in a mouseover box" => "Display image informations in a mouseover box",
// "Yes" => "Yes",
// "yes, and don't display those informations under the image" => "yes, and don't display those informations under the image",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
// "Images per row" => "Images per row",
// "Thumbnails size X" => "Thumbnails size X",
// "Thumbnails size Y" => "Thumbnails size Y",
// "Default scale size" => "Default scale size",
// "pixels" => "pixels",
// "Exterminator" => "Exterminator",
// "Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Remove images in the system gallery not being used in Wiki pages, articles or blog posts",
// "Mover" => "Mover",
// "Move images from database storage to filesystem storage" => "Move images from database storage to filesystem storage",
// "Move images from filesystem storage to database storage" => "Move images from filesystem storage to database storage",
// "All galleries" => "All galleries",
// "Move images from old filesystem store to new directory" => "Move images from old filesystem store to new directory",
// "Moved" => "Moved",
// "Parent" => "Parent",
// "Last modified" => "Last modified",
// "Image galleries comments settings" => "Image galleries comments settings",
// "General Preferences" => "General Preferences",
// "Tikiwiki version" => "Tikiwiki version",
// "Use group homepages" => "Use group homepages",
// "Go to group homepage only if login from default homepage" => "Go to group homepage only if login from default homepage",
// "Use URI as Home Page" => "Use URI as Home Page",
// "Home page" => "Home page",
// "Custom home" => "Custom home",
// "OS" => "OS",
// "Unix" => "Unix",
// "Windows" => "Windows",
// "Unknown/Other" => "Unknown/Other",
// "PHP error reporting level:" => "PHP error reporting level:",
// "No error reporting" => "No error reporting",
// "Report all PHP errors" => "Report all PHP errors",
// "Report all errors except notices" => "Report all errors except notices",
// "visible to admin only" => "visible to admin only",
// "smarty notice reporting" => "smarty notice reporting",
// "Log Mail in Tiki Logs:" => "Log Mail in Tiki Logs:",
// "Log SQL:" => "Log SQL:",
// "Default charset for sending mail:" => "Default charset for sending mail:",
// "Mail end of line:" => "Mail end of line:",
// "(standard)" => "(standard)",
// "(some Unix MTA)" => "(some Unix MTA)",
// "General Settings" => "General Settings",
// "Disallow access to the site (except for those with permission)" => "Disallow access to the site (except for those with permission)",
// "Message to display when site is closed" => "Message to display when site is closed",
// "Disallow access when load is above the threshold (except for those with permission)" => "Disallow access when load is above the threshold (except for those with permission)",
// "Max average server load threshold in the last minute" => "Max average server load threshold in the last minute",
// "Message to display when server is too busy" => "Message to display when server is too busy",
// "Use cache for external pages" => "Use cache for external pages",
// "Use cache for external images" => "Use cache for external images",
// "Tikiwiki.org help" => "Tikiwiki.org help",
// "Use gzipped output" => "Use gzipped output",
// "output compression is active." => "output compression is active.",
// "compression is handled by" => "compression is handled by",
// "Count admin pageviews" => "Count admin pageviews",
// "Browser title" => "Browser title",
// "Temporary directory" => "Temporary directory",
// "Sender Email" => "Sender Email",
// "Contact user" => "Contact user",
// "Allow anonymous users to \"Contact Us\"" => "Allow anonymous users to \"Contact Us\"",
// "contact feature disabled" => "contact feature disabled",
// "Store session data in database" => "Store session data in database",
// "Session lifetime in minutes" => "Session lifetime in minutes",
// "Use proxy" => "Use proxy",
// "Proxy Host" => "Proxy Host",
// "Proxy port" => "Proxy port",
// "Maximum number of records in listings" => "Maximum number of records in listings",
// "Help System" => "Help System",
// "Help URL" => "Help URL",
// "Please expect not found help-pages with the default-URL." => "Please expect not found help-pages with the default-URL.",
// "Any help with the documentation is welcome." => "Any help with the documentation is welcome.",
// "Release check" => "Release check",
// "Check frequency" => "Check frequency",
// "Each day" => "Each day",
// "Each week" => "Each week",
// "Each month" => "Each month",
// "Release checks are made when you browse admin main page only" => "Release checks are made when you browse admin main page only",
// "Force immediate check" => "Force immediate check",
// "Date and Time Formats" => "Date and Time Formats",
// "Default timezone" => "Default timezone",
// "Long date format" => "Long date format",
// "Short date format" => "Short date format",
// "Long time format" => "Long time format",
// "Short time format" => "Short time format",
// "Fields display order" => "Fields display order",
// "Date and Time Format Help" => "Date and Time Format Help",
// "When possible, show the real user name instead of login:" => "When possible, show the real user name instead of login:",
// "Locations separator" => "Locations separator",
// "Examples" => "Examples",
// "Choices separator" => "Choices separator",
// "Preference syntax" => "Preference syntax",
// "Change admin password" => "Change admin password",
// "New password" => "New password",
// "Change password" => "Change password",
// "Google Map setup" => "Google Map setup",
// "You need to request a Google Maps Key for this web site. You can easily generate a key for your domain at :" => "You need to request a Google Maps Key for this web site. You can easily generate a key for your domain at :",
// "Google Map Key" => "Google Map Key",
// "Default x for map center" => "Default x for map center",
// "Default y from map center" => "Default y from map center",
// "Default zoom level" => "Default zoom level",
// "whole earth" => "whole earth",
// "country size" => "country size",
// "city size" => "city size",
// "max zoom" => "max zoom",
// "Internationalization" => "Internationalization",
// "I18n setup" => "I18n setup",
// "Default Language" => "Default Language",
// "Multilingual" => "Multilingual",
// "Multilingual structures" => "Multilingual structures",
// "Show pages in user's preferred language" => "Show pages in user's preferred language",
// "Detect browser language" => "Detect browser language",
// "Restrict supported languages" => "Restrict supported languages",
// "Available languages (Ctrl+Click to select multiple languages):" => "Available languages (Ctrl+Click to select multiple languages):",
// "Quantify change size" => "Quantify change size",
// "Use database for translation" => "Use database for translation",
// "Edit or ex/import Languages" => "Edit or ex/import Languages",
// "Record untranslated" => "Record untranslated",
// "Show Babelfish Translation URLs" => "Show Babelfish Translation URLs",
// "Show Babelfish Translation Logo" => "Show Babelfish Translation Logo",
// "Intertiki exchange feature" => "Intertiki exchange feature",
// "Intertiki client" => "Intertiki client",
// "Tiki Unique key" => "Tiki Unique key",
// "InterTiki Slave mode" => "InterTiki Slave mode",
// "Warning: overrides manually registered local users" => "Warning: overrides manually registered local users",
// " as master" => " as master",
// "Import user preferences" => "Import user preferences",
// "Import user groups" => "Import user groups",
// "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "InterTiki Server" => "InterTiki Server",
// "host" => "host",
// "port" => "port",
// "Add new server" => "Add new server",
// "Intertiki server" => "Intertiki server",
// "Intertiki Server enabled" => "Intertiki Server enabled",
// "Access Log file" => "Access Log file",
// "Errors Log file" => "Errors Log file",
// "Known hosts" => "Known hosts",
// "Key" => "Key",
// "IP" => "IP",
// "Contact" => "Contact",
// "Enable/disable Tiki features in " => "Enable/disable Tiki features in ",
// ", but configure them elsewhere" => ", but configure them elsewhere",
// "Wysiwyg" => "Wysiwyg",
// "Text Area" => "Text Area",
// "Admin Groups" => "Admin Groups",
// "Admin Users" => "Admin Users",
// "User registration and login" => "User registration and login",
// "Authentication method" => "Authentication method",
// "Just Tiki" => "Just Tiki",
// "Web Server" => "Web Server",
// "Tiki and PEAR::Auth" => "Tiki and PEAR::Auth",
// "Tiki and PAM" => "Tiki and PAM",
// "CAS (Central Authentication Service)" => "CAS (Central Authentication Service)",
// "Shibboleth" => "Shibboleth",
// "OpenID and Tiki" => "OpenID and Tiki",
// "Tiki and HTTP Auth" => "Tiki and HTTP Auth",
// "Use WebServer authentication for Tiki" => "Use WebServer authentication for Tiki",
// "Users can register" => "Users can register",
// "... but need admin validation" => "... but need admin validation",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>",
// "Create a group for each user <br />(with the same name as the user)" => "Create a group for each user <br />(with the same name as the user)",
// "Use tracker for more user information" => "Use tracker for more user information",
// "Use tracker for more group information" => "Use tracker for more group information",
// "Request passcode to register" => "Request passcode to register",
// "Prevent automatic/robot registration" => "Prevent automatic/robot registration",
// " - Php GD library required" => " - Php GD library required",
// "Use login as email" => "Use login as email",
// "Validate users by email" => "Validate users by email",
// "Validate user email server" => "Validate user email server",
// "Remind passwords by email (if \"Store plaintext passwords\" is activated.) Else, Reset passwords by email" => "Remind passwords by email (if \"Store plaintext passwords\" is activated.) Else, Reset passwords by email",
// "Store plaintext passwords" => "Store plaintext passwords",
// "Crypt passwords method" => "Crypt passwords method",
// "tikihash (old)" => "tikihash (old)",
// "Reg users can change password" => "Reg users can change password",
// "Reg users can change theme" => "Reg users can change theme",
// "Restrict available themes" => "Restrict available themes",
// "Available styles:" => "Available styles:",
// "Reg users can change language" => "Reg users can change language",
// "Restrict available languages" => "Restrict available languages",
// "Available languages:" => "Available languages:",
// "Minimum username length" => "Minimum username length",
// "Maximum username length" => "Maximum username length",
// "Force lowercase username" => "Force lowercase username",
// "Use challenge/response authentication" => "Use challenge/response authentication",
// "Force to use chars and nums in passwords" => "Force to use chars and nums in passwords",
// "Minimum password length" => "Minimum password length",
// "Password invalid after days" => "Password invalid after days",
// "-1 for never" => "-1 for never",
// "Re-validate user by email after days" => "Re-validate user by email after days",
// "Re-validate user by email after unsuccessful logins" => "Re-validate user by email after unsuccessful logins",
// "Generate a password option" => "Generate a password option",
// "HTTPS login" => "HTTPS login",
// "Allow secure (https) login" => "Allow secure (https) login",
// "Encourage secure (https) login" => "Encourage secure (https) login",
// "Consider we are in always in HTTPS, but do not check" => "Consider we are in always in HTTPS, but do not check",
// "Require secure (https) login" => "Require secure (https) login",
// "Users can choose to stay in SSL mode after an HTTPS login" => "Users can choose to stay in SSL mode after an HTTPS login",
// "Users can switch between secured or standard mode at login" => "Users can switch between secured or standard mode at login",
// "HTTP port" => "HTTP port",
// "HTTPS port" => "HTTPS port",
// "Remember me feature" => "Remember me feature",
// "User's choice" => "User's choice",
// "Always" => "Always",
// "Duration:" => "Duration:",
// "week" => "week",
// "month" => "month",
// "year" => "year",
// "Remember me name" => "Remember me name",
// "Remember me domain" => "Remember me domain",
// "Remember me path" => "Remember me path",
// "Protect against CSRF with a confirmation step" => "Protect against CSRF with a confirmation step",
// "Protect against CSRF with a ticket" => "Protect against CSRF with a ticket",
// "Highlight Group" => "Highlight Group",
// "choose a group ..." => "choose a group ...",
// "User can choose beyond these groups at registration time" => "User can choose beyond these groups at registration time",
// "Specify the fields that will be asked in admin->groups" => "Specify the fields that will be asked in admin->groups",
// "Displays user's contribution in the user information page" => "Displays user's contribution in the user information page",
// "Displays UserTracker information in user information page. Format: trackerId, fieldId1, fieldId2, …" => "Displays UserTracker information in user information page. Format: trackerId, fieldId1, fieldId2, …",
// "Deactivate login autocomplete (do not remember login and password)" => "Deactivate login autocomplete (do not remember login and password)",
// "On permission denied, display login box for anonymous:" => "On permission denied, display login box for anonymous:",
// "On permission denied, send to this url:" => "On permission denied, send to this url:",
// "PEAR::Auth" => "PEAR::Auth",
// "LDAP" => "LDAP",
// "Create user if not in Tiki?" => "Create user if not in Tiki?",
// "Create user if not in Auth?" => "Create user if not in Auth?",
// "Just use Tiki auth for admin?" => "Just use Tiki auth for admin?",
// "LDAP URL<br />(if set, this will override the Host and Port below)" => "LDAP URL<br />(if set, this will override the Host and Port below)",
// "LDAP Host" => "LDAP Host",
// "LDAP Port" => "LDAP Port",
// "LDAP Scope" => "LDAP Scope",
// "LDAP Base DN" => "LDAP Base DN",
// "LDAP User DN" => "LDAP User DN",
// "LDAP User Attribute" => "LDAP User Attribute",
// "LDAP User OC" => "LDAP User OC",
// "LDAP Group DN" => "LDAP Group DN",
// "LDAP Group Attribute" => "LDAP Group Attribute",
// "LDAP Group OC" => "LDAP Group OC",
// "LDAP Member Attribute" => "LDAP Member Attribute",
// "LDAP Member Is DN" => "LDAP Member Is DN",
// "LDAP Admin User" => "LDAP Admin User",
// "LDAP Admin Pwd" => "LDAP Admin Pwd",
// "LDAP Version" => "LDAP Version",
// "LDAP Realname Attribute" => "LDAP Realname Attribute",
// "PAM" => "PAM",
// "PAM service" => "PAM service",
// "Currently unused" => "Currently unused",
// "You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/." => "You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/.",
// "CAS server version" => "CAS server version",
// "Version 1.0" => "Version 1.0",
// "Version 2.0" => "Version 2.0",
// "CAS server hostname" => "CAS server hostname",
// "CAS server port" => "CAS server port",
// "CAS server path" => "CAS server path",
// "Change CAS preferences" => "Change CAS preferences",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "Valid Affiliations (separated by commas)" => "Valid Affiliations (separated by commas)",
// "Create with default group?" => "Create with default group?",
// "Default group: " => "Default group: ",
// "Change Shibboleth preferences" => "Change Shibboleth preferences",
// "Users Defaults" => "Users Defaults",
// "Users Default Preferences" => "Users Default Preferences",
// "Does your mail reader need a special charset" => "Does your mail reader need a special charset",
// "default" => "default",
// "Theme" => "Theme",
// "Number of visited pages to remember" => "Number of visited pages to remember",
// "Displayed time zone" => "Displayed time zone",
// "Detect user timezone if browser allows, otherwise site default" => "Detect user timezone if browser allows, otherwise site default",
// "User information" => "User information",
// "Private" => "Private",
// "public" => "public",
// "Use double-click to edit pages" => "Use double-click to edit pages",
// "Messages per page" => "Messages per page",
// "Allow messages from other users" => "Allow messages from other users",
// "Note author when reading his mail" => "Note author when reading his mail",
// "Send me an email for messages with priority equal or greater than" => "Send me an email for messages with priority equal or greater than",
// "Auto-archive read messages after x days" => "Auto-archive read messages after x days",
// "never" => "never",
// "Tasks per page" => "Tasks per page",
// "My Tiki" => "My Tiki",
// "My pages" => "My pages",
// "My messages" => "My messages",
// "My tasks" => "My tasks",
// "My forum topics" => "My forum topics",
// "My forum replies" => "My forum replies",
// "My items" => "My items",
// "My workflow" => "My workflow",
// "Change users defaults" => "Change users defaults",
// "General Layout" => "General Layout",
// "Slideshows theme" => "Slideshows theme",
// "Use transition style sheet from version" => "Use transition style sheet from version",
// "Never use transition css" => "Never use transition css",
// "Use @version:x.x specified in theme css or none if not specified" => "Use @version:x.x specified in theme css or none if not specified",
// "Use @version:x.x specified in theme css or 1.8 if not specified" => "Use @version:x.x specified in theme css or 1.8 if not specified",
// "Use @version:x.x specified in theme css or 1.9 if not specified" => "Use @version:x.x specified in theme css or 1.9 if not specified",
// "Edit CSS" => "Edit CSS",
// "Theme Control" => "Theme Control",
// "Template Viewing" => "Template Viewing",
// "Tiki Template Viewing" => "Tiki Template Viewing",
// "Site Identity" => "Site Identity",
// "Required for all the following features" => "Required for all the following features",
// "General Layout options" => "General Layout options",
// "Custom Site Header" => "Custom Site Header",
// "Site Logo" => "Site Logo",
// "Site logo source (image path)" => "Site logo source (image path)",
// "Site logo background color" => "Site logo background color",
// "Site logo background style" => "Site logo background style",
// "Site logo alignment" => "Site logo alignment",
// "on left side" => "on left side",
// "on center" => "on center",
// "on right side" => "on right side",
// "Site logo title (on mouse over)" => "Site logo title (on mouse over)",
// "Alt. description (e.g. for text browsers)" => "Alt. description (e.g. for text browsers)",
// "Site Search Bar" => "Site Search Bar",
// "Site Login Bar" => "Site Login Bar",
// "Top Bar" => "Top Bar",
// "Site menu bar" => "Site menu bar",
// "Note: This feature also requires PHPLayers to be turned on in " => "Note: This feature also requires PHPLayers to be turned on in ",
// "Menu ID" => "Menu ID",
// "Current Version" => "Current Version",
// "Custom code" => "Custom code",
// "Users can Flip Columns" => "Users can Flip Columns",
// "Left column" => "Left column",
// "always" => "always",
// "user decides" => "user decides",
// "Site Breadcrumbs" => "Site Breadcrumbs",
// "Site location bar" => "Site location bar",
// "at top of page" => "at top of page",
// "at top of center column" => "at top of center column",
// "Prefix breadcrumbs with 'Location : ' " => "Prefix breadcrumbs with 'Location : ' ",
// "Larger font for" => "Larger font for",
// "entire location" => "entire location",
// "page name" => "page name",
// "Use page description:" => "Use page description:",
// "Right column" => "Right column",
// "Site Report Bar" => "Site Report Bar",
// "Webmaster Report" => "Webmaster Report",
// "Webmaster Email" => "Webmaster Email",
// "Left blank to use the default sender email" => "Left blank to use the default sender email",
// "Custom Site Footer" => "Custom Site Footer",
// "Bottom bar" => "Bottom bar",
// "Bottom bar icons" => "Bottom bar icons",
// "Bottom bar debug" => "Bottom bar debug",
// "Pagination links" => "Pagination links",
// "Use relative (next / previous) pagination links" => "Use relative (next / previous) pagination links",
// "Use direct pagination links" => "Use direct pagination links",
// "Max. number of links around the current item:" => "Max. number of links around the current item:",
// "Max. number of links after the first or before the last item:" => "Max. number of links after the first or before the last item:",
// "Display 'First' and 'Last' links" => "Display 'First' and 'Last' links",
// "Display fast move links (by 10 percent of the total number of pages) " => "Display fast move links (by 10 percent of the total number of pages) ",
// "Use Icons" => "Use Icons",
// "Display menus as folders" => "Display menus as folders",
// "Use Tabs" => "Use Tabs",
// "Layout per section" => "Layout per section",
// "Admin layout per section" => "Admin layout per section",
// "Other options" => "Other options",
// "Use context menus for actions (icons) (only in file galleries yet)" => "Use context menus for actions (icons) (only in file galleries yet)",
// "Use context menus for actions (text) (only in file galleries yet)" => "Use context menus for actions (text) (only in file galleries yet)",
// "Favicon icon file name:" => "Favicon icon file name:",
// "Favicon icon MIME type:" => "Favicon icon MIME type:",
// "image/png" => "image/png",
// "image/bmp" => "image/bmp",
// "image/x-icon" => "image/x-icon",
// "full path to mapfiles" => "full path to mapfiles",
// "default mapfile" => "default mapfile",
// "Wiki Page for Help" => "Wiki Page for Help",
// "Wiki Page for Comments" => "Wiki Page for Comments",
// "Full path to gdaltindex" => "Full path to gdaltindex",
// "Full path to ogr2ogr" => "Full path to ogr2ogr",
// "Map Zone" => "Map Zone",
// "Generate User Map" => "Generate User Map",
// "Users can opt-out internal messages" => "Users can opt-out internal messages",
// "Users accept internal messages by default" => "Users accept internal messages by default",
// "Maximum mailbox size (messages, 0=unlimited)" => "Maximum mailbox size (messages, 0=unlimited)",
// "Maximum mail archive size (messages, 0=unlimited)" => "Maximum mail archive size (messages, 0=unlimited)",
// "Maximum sent box size (messages, 0=unlimited)" => "Maximum sent box size (messages, 0=unlimited)",
// "Value" => "Value",
// "Meta Keywords" => "Meta Keywords",
// "Insert freetags in keyword list" => "Insert freetags in keyword list",
// "Use the thread title in Forum pages instead" => "Use the thread title in Forum pages instead",
// "Use the image title in Image gallery pages instead" => "Use the image title in Image gallery pages instead",
// "Meta Description" => "Meta Description",
// "Meta Author" => "Meta Author",
// "Geourl" => "Geourl",
// "geo.position" => "geo.position",
// "geo.region" => "geo.region",
// "geo.placename" => "geo.placename",
// "Robots" => "Robots",
// "meta robots" => "meta robots",
// "revisit after" => "revisit after",
// "Right &amp; left boxes" => "Right &amp; left boxes",
// "Administer modules" => "Administer modules",
// "Show Module Controls" => "Show Module Controls",
// "Users can Configure Modules" => "Users can Configure Modules",
// "Users can Shade Modules" => "Users can Shade Modules",
// "module decides" => "module decides",
// "Display modules to all groups always" => "Display modules to all groups always",
// "Hide anonymous-only modules from registered users" => "Hide anonymous-only modules from registered users",
// "ProgressBarPlay Color" => "ProgressBarPlay Color",
// "ProgressBarLoad Color" => "ProgressBarLoad Color",
// "ProgressBarButton Color" => "ProgressBarButton Color",
// "ProgressBar Color" => "ProgressBar Color",
// "Volume On Color" => "Volume On Color",
// "Volume Off Color" => "Volume Off Color",
// "Volume Button Color" => "Volume Button Color",
// "Button Color" => "Button Color",
// "Button Pressed Color" => "Button Pressed Color",
// "Button Over Color" => "Button Over Color",
// "Button Info Color" => "Button Info Color",
// "Button Info Pressed Color" => "Button Info Pressed Color",
// "Button Info Over Color" => "Button Info Over Color",
// "Button Info Text Color" => "Button Info Text Color",
// "ID3 Tag Color" => "ID3 Tag Color",
// "Play Time Color" => "Play Time Color",
// "Total Time Color" => "Total Time Color",
// "Panel Display Color" => "Panel Display Color",
// "Alert Message Color" => "Alert Message Color",
// "Flash Lenght" => "Flash Lenght",
// "Flash Heigth" => "Flash Heigth",
// "Video Lenght" => "Video Lenght",
// "Video Heigth" => "Video Heigth",
// "Preload Delay" => "Preload Delay",
// "Max Play time" => "Max Play time",
// "URL Append" => "URL Append",
// "Message after limited time" => "Message after limited time",
// "ID of System File Galleries to upload multimedia files" => "ID of System File Galleries to upload multimedia files",
// "To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or",
// "Allow Anonymous Poll Voting" => "Allow Anonymous Poll Voting",
// "Show categories" => "Show categories",
// "Show objects" => "Show objects",
// "Tikiwiki Profiles" => "Tikiwiki Profiles",
// "Configuration" => "Configuration",
// "Profile repositories" => "Profile repositories",
// "Profiles can be installed from multiple repositories. Enter one repository URL per line." => "Profiles can be installed from multiple repositories. Enter one repository URL per line.",
// "Profile repository status" => "Profile repository status",
// "Profile list" => "Profile list",
// "Repository" => "Repository",
// "Profile" => "Profile",
// "List" => "List",
// "Use this page to configure the RSS feeds generated by Tiki. To syndicate RSS feeds from other sites, use the <strong>Admin</strong> &gt; <strong>RSS modules</strong> menu option, or" => "Use this page to configure the RSS feeds generated by Tiki. To syndicate RSS feeds from other sites, use the <strong>Admin</strong> &gt; <strong>RSS modules</strong> menu option, or",
// "Feed for articles" => "Feed for articles",
// "Feature is disabled." => "Feature is disabled.",
// "Enable now" => "Enable now",
// "Maximum number of items to display" => "Maximum number of items to display",
// "Feed for blogs" => "Feed for blogs",
// "Individual blogs" => "Individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Image galleries" => "Image galleries",
// "Individual image galleries" => "Individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Individual file galleries" => "Individual file galleries",
// "Feed for wiki" => "Feed for wiki",
// "Feed for forums" => "Feed for forums",
// "Individual forums" => "Individual forums",
// "Individual trackers items" => "Individual trackers items",
// "Calendar events" => "Calendar events",
// "Feed for directory" => "Feed for directory",
// "Feed for maps" => "Feed for maps",
// "Map files" => "Map files",
// "Defaults" => "Defaults",
// "Default RDF version" => "Default RDF version",
// "Specification" => "Specification",
// "Documentation" => "Documentation",
// "Editor" => "Editor",
// "Webmaster" => "Webmaster",
// "Image Path" => "Image Path",
// "Caching time:" => "Caching time:",
// "seconds (0 = cache inactive)" => "seconds (0 = cache inactive)",
// "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public." => "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public.",
// "You can see users rank by score in the module users_rank, for that go to" => "You can see users rank by score in the module users_rank, for that go to",
// "Admin modules" => "Admin modules",
// "Expiration" => "Expiration",
// "can be seen on page" => "can be seen on page",
// "in Admin menu" => "in Admin menu",
// "Referer Search Highlighting" => "Referer Search Highlighting",
// "Parse the result (can be slow)" => "Parse the result (can be slow)",
// "Database Search using MySQL 'Full-Text' Feature" => "Database Search using MySQL 'Full-Text' Feature",
// "Activate MySQL Full-Text feature" => "Activate MySQL Full-Text feature",
// "Activate MySQL 'Full-Text' feature" => "Activate MySQL 'Full-Text' feature",
// "Performance issues" => "Performance issues",
// "Ignore individual object permissions" => "Ignore individual object permissions",
// "Database Independent Full Text Search or Tiki Search" => "Database Independent Full Text Search or Tiki Search",
// "This is activated by default if MySQL 'Full-Text' feature is not activated above" => "This is activated by default if MySQL 'Full-Text' feature is not activated above",
// "Refresh wiki search index now" => "Refresh wiki search index now",
// "Refresh trackers search index now" => "Refresh trackers search index now",
// "Refresh tracker search index now" => "Refresh tracker search index now",
// "Refresh files search index now" => "Refresh files search index now",
// "Search features" => "Search features",
// "SearchStats" => "SearchStats",
// "Settings for searching content" => "Settings for searching content",
// "Search refresh mode" => "Search refresh mode",
// "random" => "random",
// "Search refresh rate" => "Search refresh rate",
// "0 for no refresh" => "0 for no refresh",
// "Minimum length of search word" => "Minimum length of search word",
// "Max. number of words containing a syllable" => "Max. number of words containing a syllable",
// "Max. age in hours of syllable search cache" => "Max. age in hours of syllable search cache",
// "LRU list purging rate" => "LRU list purging rate",
// "LRU list length" => "LRU list length",
// "Text area (that apply throughout many features)" => "Text area (that apply throughout many features)",
// "Allow Smileys" => "Allow Smileys",
// "AutoLinks" => "AutoLinks",
// "Open external links in new window" => "Open external links in new window",
// "Show quicktags over textareas (instead on left side)" => "Show quicktags over textareas (instead on left side)",
// "Default number of rows (wiki)" => "Default number of rows (wiki)",
// "Default number of rows (comments)" => "Default number of rows (comments)",
// "Default number of rows (forum)" => "Default number of rows (forum)",
// "Default number of rows (forum replies)" => "Default number of rows (forum replies)",
// "To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or",
// "Trackers attachments preferences" => "Trackers attachments preferences",
// "Trackers with mirror tables" => "Trackers with mirror tables",
// "Use trackers with mirror tables" => "Use trackers with mirror tables",
// "Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki" => "Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki",
// "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely" => "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely",
// "Validate choice" => "Validate choice",
// "Trackers attachments" => "Trackers attachments",
// "dls" => "dls",
// "Storage" => "Storage",
// "Change" => "Change",
// "No records" => "No records",
// "Change all to db" => "Change all to db",
// "Change all to file" => "Change all to file",
// "Quota (Mb)" => "Quota (Mb)",
// "Use database to store userfiles" => "Use database to store userfiles",
// "Use a directory to store userfiles" => "Use a directory to store userfiles",
// "Allow viewing HTML mails?" => "Allow viewing HTML mails?",
// "Maximum size for each attachment" => "Maximum size for each attachment",
// "Unlimited" => "Unlimited",
// "To add/edit wiki pages easily, add the module quick_edit via \"Modules\" on the application menu, or" => "To add/edit wiki pages easily, add the module quick_edit via \"Modules\" on the application menu, or",
// "Dumps" => "Dumps",
// "Generate dump" => "Generate dump",
// "Download last dump" => "Download last dump",
// "Create a Tag for the Current Wiki" => "Create a Tag for the Current Wiki",
// "Tag name:" => "Tag name:",
// "Restore the Wiki" => "Restore the Wiki",
// "restore" => "restore",
// "Remove a Tag" => "Remove a Tag",
// "Wiki Comments Settings" => "Wiki Comments Settings",
// "Default number of comments per page:" => "Default number of comments per page:",
// "List displayed by default" => "List displayed by default",
// "Export Wiki Pages" => "Export Wiki Pages",
// "Wiki attachments" => "Wiki attachments",
// "Wiki attachments:" => "Wiki attachments:",
// "Use database to store files:" => "Use database to store files:",
// "Use a directory to store files:" => "Use a directory to store files:",
// "Path:" => "Path:",
// "Manage attachments" => "Manage attachments",
// "Wiki Administration" => "Wiki Administration",
// "Remove unused pictures" => "Remove unused pictures",
// "Wiki Home Page" => "Wiki Home Page",
// "Wiki Discussion" => "Wiki Discussion",
// "Discuss pages on forums" => "Discuss pages on forums",
// "Forums are disabled." => "Forums are disabled.",
// "Forum for discussion:" => "Forum for discussion:",
// "No forums" => "No forums",
// "Wiki Link Format" => "Wiki Link Format",
// "Controls recognition of Wiki links using the two parenthesis Wiki link syntax <i>((page name))</i>." => "Controls recognition of Wiki links using the two parenthesis Wiki link syntax <i>((page name))</i>.",
// "complete" => "complete",
// "latin" => "latin",
// "english" => "english",
// "Page name display stripper: choose a character that will be used as a delimiter to strip a final part of the page name (only concerns display)" => "Page name display stripper: choose a character that will be used as a delimiter to strip a final part of the page name (only concerns display)",
// "Wiki Page Staging and Approval" => "Wiki Page Staging and Approval",
// "Use wiki page staging and approval:" => "Use wiki page staging and approval:",
// "Unique page name prefix to indicate staging copy:" => "Unique page name prefix to indicate staging copy:",
// "Hide page name prefix:" => "Hide page name prefix:",
// "Category for staging pages:" => "Category for staging pages:",
// "Category for approved pages:" => "Category for approved pages:",
// "Category for pages out of sync:" => "Category for pages out of sync:",
// "Force bounce of editing of approved pages to staging:" => "Force bounce of editing of approved pages to staging:",
// "Categorize approved pages with categories of staging copy on approval:" => "Categorize approved pages with categories of staging copy on approval:",
// "Replace freetags with that of staging pages on approval:" => "Replace freetags with that of staging pages on approval:",
// "Add new freetags of approved copy (into tags field) when editing staging pages:" => "Add new freetags of approved copy (into tags field) when editing staging pages:",
// "Delete staging pages at approval:" => "Delete staging pages at approval:",
// "If not in the group, edit is always redirected to the staging page edit:" => "If not in the group, edit is always redirected to the staging page edit:",
// "Wiki Page List Configuration" => "Wiki Page List Configuration",
// "Id" => "Id",
// "Name length:" => "Name length:",
// "Last version" => "Last version",
// "Comment length:" => "Comment length:",
// "Description length:" => "Description length:",
// "Status" => "Status",
// "Versions" => "Versions",
// "Categories path" => "Categories path",
// "Default sort order:" => "Default sort order:",
// "Wiki 3D Browser Configuration" => "Wiki 3D Browser Configuration",
// "Enable wiki 3D browser:" => "Enable wiki 3D browser:",
// "Load page on navigation:" => "Load page on navigation:",
// "Browser width:" => "Browser width:",
// "Browser height:" => "Browser height:",
// "Navigation depth:" => "Navigation depth:",
// "Node size:" => "Node size:",
// "Text size:" => "Text size:",
// "Spring (connection) size:" => "Spring (connection) size:",
// "Existing page node color:" => "Existing page node color:",
// "Missing page node color:" => "Missing page node color:",
// "Camera distance adjusted relative to nearest node:" => "Camera distance adjusted relative to nearest node:",
// "Camera distance:" => "Camera distance:",
// "Field of view:" => "Field of view:",
// "Feed animation interval (milisecs):" => "Feed animation interval (milisecs):",
// "Friction constant:" => "Friction constant:",
// "Elastic constant:" => "Elastic constant:",
// "Eletrostatic constant:" => "Eletrostatic constant:",
// "Node mass:" => "Node mass:",
// "Node charge:" => "Node charge:",
// "Wiki Features" => "Wiki Features",
// "Sandbox:" => "Sandbox:",
// "Anonymous editors must input anti-bot code:" => "Anonymous editors must input anti-bot code:",
// "Last changes:" => "Last changes:",
// "Dump:" => "Dump:",
// "Export:" => "Export:",
// "Rating:" => "Rating:",
// "History:" => "History:",
// "View source:" => "View source:",
// "List pages:" => "List pages:",
// "Backlinks:" => "Backlinks:",
// "Similar:" => "Similar:",
// "Rankings:" => "Rankings:",
// "Undo:" => "Undo:",
// "Save Draft:" => "Save Draft:",
// "MultiPrint:" => "MultiPrint:",
// "Comments:" => "Comments:",
// "Spellchecking:" => "Spellchecking:",
// "Use templates:" => "Use templates:",
// "Warn on edit conflict:" => "Warn on edit conflict:",
// "Edit idle timeout:" => "Edit idle timeout:",
// "Pictures:" => "Pictures:",
// "Show page title:" => "Show page title:",
// "Show page ID:" => "Show page ID:",
// "Cache wiki pages (global):" => "Cache wiki pages (global):",
// "Individual cache:" => "Individual cache:",
// "Footnotes:" => "Footnotes:",
// "Users can lock pages (if perm):" => "Users can lock pages (if perm):",
// "Use WikiWords:" => "Use WikiWords:",
// "Accept dashes and underscores in WikiWords:" => "Accept dashes and underscores in WikiWords:",
// "Link plural WikiWords to their singular forms:" => "Link plural WikiWords to their singular forms:",
// "Use Wiki paragraph formatting:" => "Use Wiki paragraph formatting:",
// "But still create line breaks within paragraphs:" => "But still create line breaks within paragraphs:",
// "Automonospaced text:" => "Automonospaced text:",
// "Tables syntax:" => "Tables syntax:",
// "|| for rows" => "|| for rows",
// "\\n for rows" => "\\n for rows",
// "Uses Slideshow:" => "Uses Slideshow:",
// "Open page as structure:" => "Open page as structure:",
// "Make structure from page:" => "Make structure from page:",
// "Categorize structure pages together:" => "Categorize structure pages together:",
// "Create webhelp from structure:" => "Create webhelp from structure:",
// "Use external link icons:" => "Use external link icons:",
// "User's Page:" => "User's Page:",
// "UserPage prefix:" => "UserPage prefix:",
// "Page creators are admin of their pages:" => "Page creators are admin of their pages:",
// "Import HTML:" => "Import HTML:",
// "Import Page:" => "Import Page:",
// "Protect email against spam:" => "Protect email against spam:",
// "When viewing a page, if it doesn't exist and has one like page, automatic redirection to this like page:" => "When viewing a page, if it doesn't exist and has one like page, automatic redirection to this like page:",
// "Show/hide heading icon displayed before the heading:" => "Show/hide heading icon displayed before the heading:",
// "Force and limit categorization to within subtree of:" => "Force and limit categorization to within subtree of:",
// "Print Page:" => "Print Page:",
// "Allow HTML:" => "Allow HTML:",
// "Show page version:" => "Show page version:",
// "Page navigation bar position (displayed when page break '...page...' are used):" => "Page navigation bar position (displayed when page break '...page...' are used):",
// "Top bar" => "Top bar",
// "Wiki actions bar position (e.g. Save, Preview, Cancel, ...):" => "Wiki actions bar position (e.g. Save, Preview, Cancel, ...):",
// "Regex search and replace:" => "Regex search and replace:",
// "Edit section:" => "Edit section:",
// "Log bytes changes (+/-) in Action Logs (slows each page modifications)" => "Log bytes changes (+/-) in Action Logs (slows each page modifications)",
// "Wiki History" => "Wiki History",
// "Maximum number of versions for history:" => "Maximum number of versions for history:",
// "Never delete versions younger than days:" => "Never delete versions younger than days:",
// "IP address displayed in history:" => "IP address displayed in history:",
// "Diff style:" => "Diff style:",
// "Only with last version" => "Only with last version",
// "Any 2 versions" => "Any 2 versions",
// "History only for data, description, comment change" => "History only for data, description, comment change",
// "Wiki Watch" => "Wiki Watch",
// "Create watch for author on page creation:" => "Create watch for author on page creation:",
// "Enable watch events when I am the editor:" => "Enable watch events when I am the editor:",
// "Enable watches on comments:" => "Enable watches on comments:",
// "Watch minor:" => "Watch minor:",
// "Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>" => "Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>",
// "Wysiwyg Editor Features" => "Wysiwyg Editor Features",
// "Wysiwyg Editor is optional" => "Wysiwyg Editor is optional",
// "... and is displayed by default" => "... and is displayed by default",
// "Reopen with the same editor" => "Reopen with the same editor",
// "Content is parsed like wiki page" => "Content is parsed like wiki page",
// "Content is partially parsed" => "Content is partially parsed",
// "Toolbar skin" => "Toolbar skin",
// "Toolbar content" => "Toolbar content",
// "Restore defaults" => "Restore defaults",
// "A new version of Tikiwiki, <b>{\$tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>." => "A new version of Tikiwiki, <b>{\$tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>.",
// "disabled" => "disabled",
// "enabled" => "enabled",
// "More Links" => "More Links",
// "Crosslinks to other features and settings" => "Crosslinks to other features and settings",
// "Other sections" => "Other sections",
// "Administration features" => "Administration features",
// "Security" => "Security",
// "System" => "System",
// "SysLogs" => "SysLogs",
// "Mods" => "Mods",
// "Transversal features" => "Transversal features",
// "which apply to more than one section" => "which apply to more than one section",
// "Navigation features" => "Navigation features",
// "Look &amp; feel" => "Look &amp; feel",
// "themes" => "themes",
// "Text area features" => "Text area features",
// "features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "features you can use in all text areas, like wiki pages, blogs, articles, forums, etc",
// "Stats &amp; banners" => "Stats &amp; banners",
// "View tpl" => "View tpl",
// "Admin Groups Template" => "Admin Groups Template",
// "Report" => "Report",
// "Setting" => "Setting",
// "Please select some actions to view." => "Please select some actions to view.",
// "User:" => "User:",
// "Group:" => "Group:",
// "Category:" => "Category:",
// "bytes" => "bytes",
// "kb" => "kb",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot:" => "Group Bar Plot:",
// "Accumulated Bar Plot:" => "Accumulated Bar Plot:",
// "Background color:" => "Background color:",
// "Legend background color:" => "Legend background color:",
// "Save graphs to image gallery:" => "Save graphs to image gallery:",
// "contribution" => "contribution",
// "contributor" => "contributor",
// "Edit Contribution" => "Edit Contribution",
// "Edit Action" => "Edit Action",
// "Save Action" => "Save Action",
// "Statistics" => "Statistics",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volumn per category" => "Volumn per category",
// "Volumn per category and per user" => "Volumn per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volumn per the users'group and per contribution" => "Volumn per the users'group and per contribution",
// "Volumn per group and per contribution" => "Volumn per group and per contribution",
// "Volumn per user and per contribution" => "Volumn per user and per contribution",
// "Volumn per users'contribution and time" => "Volumn per users'contribution and time",
// "Volumn per contribution and time" => "Volumn per contribution and time",
// "Days" => "Days",
// "Weeks" => "Weeks",
// "recorded" => "recorded",
// "viewed" => "viewed",
// "Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki page actions except viewed will always be recorded but can be not reported",
// "Help on Banning System" => "Help on Banning System",
// "Admin banning tpl" => "Admin banning tpl",
// "Add or edit a rule" => "Add or edit a rule",
// "Rule title" => "Rule title",
// "Username regex matching" => "Username regex matching",
// "IP regex matching" => "IP regex matching",
// "Banned from sections" => "Banned from sections",
// "Rule activated by dates" => "Rule activated by dates",
// "Rule active from" => "Rule active from",
// "Rule active until" => "Rule active until",
// "Custom message to the user" => "Custom message to the user",
// "Rules" => "Rules",
// "x" => "x",
// "User/IP" => "User/IP",
// "Sections" => "Sections",
// "Admin Calendars" => "Admin Calendars",
// "Configure/Options" => "Configure/Options",
// "List of Calendars" => "List of Calendars",
// "Loc" => "Loc",
// "Participants" => "Participants",
// "Cat" => "Cat",
// "Lang" => "Lang",
// "Url" => "Url",
// "Prio" => "Prio",
// "Subscription" => "Subscription",
// "Perso" => "Perso",
// "Permissions" => "Permissions",
// "Create/edit Calendars" => "Create/edit Calendars",
// "Custom Locations" => "Custom Locations",
// "Custom Participants" => "Custom Participants",
// "Custom Categories" => "Custom Categories",
// "Custom Languages" => "Custom Languages",
// "Custom URL" => "Custom URL",
// "Custom Subscription List" => "Custom Subscription List",
// "Custom Priorities" => "Custom Priorities",
// "Personal Calendar" => "Personal Calendar",
// "Start of day" => "Start of day",
// "h" => "h",
// "End of day" => "End of day",
// "Custom foreground color" => "Custom foreground color",
// "Custom background color" => "Custom background color",
// "Delete events older than:" => "Delete events older than:",
// "Admin Categories tpl" => "Admin Categories tpl",
// "browse the category system" => "browse the category system",
// "Current category" => "Current category",
// "Top" => "Top",
// "Current Category ID:" => "Current Category ID:",
// "Child categories" => "Child categories",
// "Edit permissions for this category" => "Edit permissions for this category",
// "Assign Permissions" => "Assign Permissions",
// "Edit this category:" => "Edit this category:",
// "Create New" => "Create New",
// "Add new category" => "Add new category",
// "Perms inherited from closest parent if possible or from global perms" => "Perms inherited from closest parent if possible or from global perms",
// "Assign permissions automatically" => "Assign permissions automatically",
// "recommended for best performance" => "recommended for best performance",
// "Objects in category" => "Objects in category",
// "Remove from this Category" => "Remove from this Category",
// "No records found." => "No records found.",
// "Add objects to category" => "Add objects to category",
// "image gal" => "image gal",
// "file gal" => "file gal",
// "Poll" => "Poll",
// "Admin chart items" => "Admin chart items",
// "charts" => "charts",
// "Edit Chart" => "Edit Chart",
// "Add or edit an item" => "Add or edit an item",
// "URL" => "URL",
// "Update" => "Update",
// "Chart items" => "Chart items",
// "No items defined yet" => "No items defined yet",
// "Admin charts" => "Admin charts",
// "View template" => "View template",
// "Admin Charts Template" => "Admin Charts Template",
// "Add or edit a chart" => "Add or edit a chart",
// "Active" => "Active",
// "Users can vote for only one item from this chart per period" => "Users can vote for only one item from this chart per period",
// "Prevent users from voting for the same item more than once" => "Prevent users from voting for the same item more than once",
// "Users can suggest new items" => "Users can suggest new items",
// "Auto validate user suggestions" => "Auto validate user suggestions",
// "Ranking shows" => "Ranking shows",
// "All items" => "All items",
// "Top 10 items" => "Top 10 items",
// "Top 20 items" => "Top 20 items",
// "Top 40 items" => "Top 40 items",
// "Top 50 items" => "Top 50 items",
// "Top 100 items" => "Top 100 items",
// "Top 250 items" => "Top 250 items",
// "Voting system" => "Voting system",
// "Vote items" => "Vote items",
// "Rank 1..5" => "Rank 1..5",
// "Rank 1..10" => "Rank 1..10",
// "Ranking frequency" => "Ranking frequency",
// "Realtime" => "Realtime",
// "Each 5 minutes" => "Each 5 minutes",
// "Daily" => "Daily",
// "Weekly" => "Weekly",
// "Monthly" => "Monthly",
// "Show Average" => "Show Average",
// "Show Votes" => "Show Votes",
// "Use Cookies for unregistered users" => "Use Cookies for unregistered users",
// "Users can vote again after" => "Users can vote again after",
// "Anytime" => "Anytime",
// "1 day" => "1 day",
// "1 week" => "1 week",
// "1 month" => "1 month",
// "Items" => "Items",
// "Ranks" => "Ranks",
// "No charts defined yet" => "No charts defined yet",
// "Chat Administration" => "Chat Administration",
// "Chat Admin" => "Chat Admin",
// "Chat Admin tpl" => "Chat Admin tpl",
// "Create/edit channel" => "Create/edit channel",
// "Refresh rate" => "Refresh rate",
// "Half a second" => "Half a second",
// "second" => "second",
// "Chat channels" => "Chat channels",
// "Admin templates" => "Admin templates",
// "Admin Content Templates" => "Admin Content Templates",
// "Admin Content Templates Template" => "Admin Content Templates Template",
// "Edit this template:" => "Edit this template:",
// "Create new template" => "Create new template",
// "Use in" => "Use in",
// "CMS" => "CMS",
// "No features are configured to use templates." => "No features are configured to use templates.",
// "Template" => "Template",
// "Templates" => "Templates",
// "Last Modif" => "Last Modif",
// "Admin Contributions" => "Admin Contributions",
// "Edit the contribution:" => "Edit the contribution:",
// "Settings" => "Settings",
// "Contributions are mandatory in wiki pages" => "Contributions are mandatory in wiki pages",
// "Contributions are mandatory in forums" => "Contributions are mandatory in forums",
// "Contributions are mandatory in comments" => "Contributions are mandatory in comments",
// "Contributions are mandatory in blogs" => "Contributions are mandatory in blogs",
// "Contributions are displayed in the comment/post" => "Contributions are displayed in the comment/post",
// "Create a new contribution" => "Create a new contribution",
// "List of contributions" => "List of contributions",
// "Admin cookies" => "Admin cookies",
// "Cookie" => "Cookie",
// "Admin FortuneCookie tpl" => "Admin FortuneCookie tpl",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}." => "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}.",
// "Create/edit cookies" => "Create/edit cookies",
// "Upload Cookies from textfile" => "Upload Cookies from textfile",
// "Upload from disk:" => "Upload from disk:",
// "Upload" => "Upload",
// "Remove all cookies" => "Remove all cookies",
// "cookie" => "cookie",
// "Help on Drawings" => "Help on Drawings",
// "Admin Drawings tpl" => "Admin Drawings tpl",
// "To create a drawing in a Wiki page, use {literal}{draw name=foo}{/literal}, where foo is the name of the drawing. After saving, click on the drawing link." => "To create a drawing in a Wiki page, use {literal}{draw name=foo}{/literal}, where foo is the name of the drawing. After saving, click on the drawing link.",
// "Available drawings" => "Available drawings",
// "Ver" => "Ver",
// "Admin DSN" => "Admin DSN",
// "tiki-admin_dsn tpl" => "tiki-admin_dsn tpl",
// "Use Admin DSN to define the database to be used by the SQL plugin." => "Use Admin DSN to define the database to be used by the SQL plugin.",
// "Create/edit dsn" => "Create/edit dsn",
// "Admin external wikis" => "Admin external wikis",
// "Admin External Wikis" => "Admin External Wikis",
// "tiki admin external wikis template" => "tiki admin external wikis template",
// "Create/Edit External Wiki" => "Create/Edit External Wiki",
// "URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)",
// "ExtWiki" => "ExtWiki",
// "Admin Forums" => "Admin Forums",
// "Admin Forums Template" => "Admin Forums Template",
// "Create new forum" => "Create new forum",
// "Duplicate forum" => "Duplicate forum",
// "View this forum" => "View this forum",
// "Import forums" => "Import forums",
// "Edit this Forum:" => "Edit this Forum:",
// "Create New Forum" => "Create New Forum",
// "There are individual permissions set for this forum" => "There are individual permissions set for this forum",
// "Show description" => "Show description",
// "Prevent flooding" => "Prevent flooding",
// "Minimum time between posts" => "Minimum time between posts",
// "Section" => "Section",
// "Create new" => "Create new",
// "Moderator user" => "Moderator user",
// "Moderator group" => "Moderator group",
// "Password protected" => "Password protected",
// "Topics only" => "Topics only",
// "All posts" => "All posts",
// "Forum password" => "Forum password",
// "Only allow replies to the first message (flat forum)" => "Only allow replies to the first message (flat forum)",
// "Send this forums posts to this email" => "Send this forums posts to this email",
// "Prune unreplied messages after" => "Prune unreplied messages after",
// "Prune old messages after" => "Prune old messages after",
// "Topic list configuration" => "Topic list configuration",
// "Posts can be rated" => "Posts can be rated",
// "Display last post titles" => "Display last post titles",
// "no display" => "no display",
// "Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address",
// "Send mails even when the post is generated by inbound mail" => "Send mails even when the post is generated by inbound mail",
// "Append a reply link to outbound mails" => "Append a reply link to outbound mails",
// "Originating e-mail address for mails from this forum" => "Originating e-mail address for mails from this forum",
// "Add messages from this email to the forum" => "Add messages from this email to the forum",
// "POP3 server" => "POP3 server",
// "Use topic smileys" => "Use topic smileys",
// "Show topic summary" => "Show topic summary",
// "User information display" => "User information display",
// "Avatar" => "Avatar",
// "Flag" => "Flag",
// "Online" => "Online",
// "Approval type" => "Approval type",
// "All posted" => "All posted",
// "Queue anonymous posts" => "Queue anonymous posts",
// "Queue all posts" => "Queue all posts",
// "No attachments" => "No attachments",
// "Everybody can attach" => "Everybody can attach",
// "Only users with attach permission" => "Only users with attach permission",
// "Moderators and admin can attach" => "Moderators and admin can attach",
// "Store attachments in:" => "Store attachments in:",
// "Database" => "Database",
// "Max attachment size (bytes)" => "Max attachment size (bytes)",
// "Max:" => "Max:",
// "Set topics preferences" => "Set topics preferences",
// "Show topics preferences" => "Show topics preferences",
// "hide topics preferences" => "hide topics preferences",
// "Default ordering for topics" => "Default ordering for topics",
// "Date (desc)" => "Date (desc)",
// "Date (asc)" => "Date (asc)",
// "Score (desc)" => "Score (desc)",
// "Replies (desc)" => "Replies (desc)",
// "Reads (desc)" => "Reads (desc)",
// "Topics per page" => "Topics per page",
// "Set thread preferences" => "Set thread preferences",
// "show threads preferences" => "show threads preferences",
// "hide threads preferences" => "hide threads preferences",
// "Default ordering for threads" => "Default ordering for threads",
// "Default style for threads" => "Default style for threads",
// "Duplicate Forum" => "Duplicate Forum",
// "Duplicate" => "Duplicate",
// "List Forums" => "List Forums",
// "Coms" => "Coms",
// "Age" => "Age",
// "PPD" => "PPD",
// "Last Post" => "Last Post",
// "..." => "...",
// "Admin Hotwords" => "Admin Hotwords",
// "Admin Hotwords Template" => "Admin Hotwords Template",
// "Add Hotword" => "Add Hotword",
// "Word" => "Word",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
// "Admin HTML pages" => "Admin HTML pages",
// "Edit this page" => "Edit this page",
// "View page" => "View page",
// "Edit zone" => "Edit zone",
// "Zone" => "Zone",
// "Dynamic zones" => "Dynamic zones",
// "zone" => "zone",
// "content" => "content",
// "Mass update" => "Mass update",
// "Admin Html Pages" => "Admin Html Pages",
// "Admin Html Pages Template" => "Admin Html Pages Template",
// "Create new HTML page" => "Create new HTML page",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
// "Edit this HTML page:" => "Edit this HTML page:",
// "Dynamic" => "Dynamic",
// "Static" => "Static",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
// "Admin dynamic zones" => "Admin dynamic zones",
// "Tiki integrator" => "Tiki integrator",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature." => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature.",
// "Edit Repository:" => "Edit Repository:",
// "Create New Repository" => "Create New Repository",
// "List Repositories" => "List Repositories",
// "New Repository" => "New Repository",
// "View Repository" => "View Repository",
// "Human readable repository name" => "Human readable repository name",
// "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')",
// "File name of start page" => "File name of start page",
// "Start page" => "Start page",
// "CSS file to load when browse this repository" => "CSS file to load when browse this repository",
// "CSS file" => "CSS file",
// "Is repository visible to users" => "Is repository visible to users",
// "Can files from repository be cached" => "Can files from repository be cached",
// "Cacheable" => "Cacheable",
// "Are files from repository can be cached" => "Are files from repository can be cached",
// "Clear all cached pages of this repository" => "Clear all cached pages of this repository",
// "Clear cache" => "Clear cache",
// "Seconds count 'till cached page will be expired" => "Seconds count 'till cached page will be expired",
// "Cache expiration" => "Cache expiration",
// "Human readable text description of repository" => "Human readable text description of repository",
// "Available Repositories" => "Available Repositories",
// "Start" => "Start",
// "CSS File" => "CSS File",
// "Edit rules" => "Edit rules",
// "Edit Rules for Repository:" => "Edit Rules for Repository:",
// "Configure Repositories" => "Configure Repositories",
// "Configure this Repository" => "Configure this Repository",
// "View this Repository" => "View this Repository",
// "Add new rule" => "Add new rule",
// "New Rule" => "New Rule",
// "view/hide copy rules dialog" => "view/hide copy rules dialog",
// "Copy Rules" => "Copy Rules",
// "Source repository" => "Source repository",
// "Copy" => "Copy",
// "According this order rules will be applied ('0' or empty = auto)" => "According this order rules will be applied ('0' or empty = auto)",
// "Rule order" => "Rule order",
// "Text to search for" => "Text to search for",
// "Text to replace" => "Text to replace",
// "Replace" => "Replace",
// "Is this regular expression or simple search/replacer" => "Is this regular expression or simple search/replacer",
// "Regex" => "Regex",
// "Is case sensitive (for simple replacer)" => "Is case sensitive (for simple replacer)",
// "Case sensitive" => "Case sensitive",
// "subset of chars: imsxeADSXUu, which is regex modifiers" => "subset of chars: imsxeADSXUu, which is regex modifiers",
// "Regex modifiers" => "Regex modifiers",
// "Human readable text description of rule" => "Human readable text description of rule",
// "Check to enable this rule" => "Check to enable this rule",
// "Enabled" => "Enabled",
// "Preview options" => "Preview options",
// "Apply all rules or just this to generate preview" => "Apply all rules or just this to generate preview",
// "Apply all rules" => "Apply all rules",
// "View source code after rules applied" => "View source code after rules applied",
// "Code preview" => "Code preview",
// "Generate HTML preview" => "Generate HTML preview",
// "HTML preview" => "HTML preview",
// "Test file from repository to generate preview for (empty = configured start page)" => "Test file from repository to generate preview for (empty = configured start page)",
// "Preview Results" => "Preview Results",
// "Rules List" => "Rules List",
// "Case" => "Case",
// "Admin layout" => "Admin layout",
// "layout options" => "layout options",
// "Admin Featured Links" => "Admin Featured Links",
// "Admin Featured Links Template" => "Admin Featured Links Template",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\"> module</a>." => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\"> module</a>.",
// "Generate positions by hits" => "Generate positions by hits",
// "List of featured links" => "List of featured links",
// "Position" => "Position",
// "Add Featured Link" => "Add Featured Link",
// "Edit this Featured Link:" => "Edit this Featured Link:",
// "Create new Featured Link" => "Create new Featured Link",
// "disables the link" => "disables the link",
// "Link type" => "Link type",
// "replace current page" => "replace current page",
// "framed" => "framed",
// "open new window" => "open new window",
// "Mail-in accounts" => "Mail-in accounts",
// "Admin Webmail" => "Admin Webmail",
// "Admin Mailing Template" => "Admin Mailing Template",
// "Account" => "Account",
// "Add new Mail-in account" => "Add new Mail-in account",
// "Edit Mail-in account" => "Edit Mail-in account",
// "Account name" => "Account name",
// "POP server" => "POP server",
// "Port" => "Port",
// "SMTP server" => "SMTP server",
// "SMTP requires authentication" => "SMTP requires authentication",
// "article-put" => "article-put",
// "wiki-get" => "wiki-get",
// "wiki-put" => "wiki-put",
// "wiki-append" => "wiki-append",
// "Article Topic" => "Article Topic",
// "Article Type" => "Article Type",
// "Allow anonymous acces" => "Allow anonymous acces",
// "Allow attachments" => "Allow attachments",
// "Discard to the end from" => "Discard to the end from",
// "Check Mail-in accounts" => "Check Mail-in accounts",
// "Check automatically" => "Check automatically",
// "Frequency" => "Frequency",
// "mn" => "mn",
// "List menus" => "List menus",
// "Edit this menu" => "Edit this menu",
// "Edit menu options" => "Edit menu options",
// "Show Quick Urls" => "Show Quick Urls",
// "Some useful URLs" => "Some useful URLs",
// "Hide Quick Urls" => "Hide Quick Urls",
// "For wiki page, use ((PageName))." => "For wiki page, use ((PageName)).",
// "Separate multiple sections with a comma ( , )." => "Separate multiple sections with a comma ( , ).",
// "Separate multiple permissions with a comma ( , )." => "Separate multiple permissions with a comma ( , ).",
// "Use Ctrl+Click to select multiple groups." => "Use Ctrl+Click to select multiple groups.",
// "Level" => "Level",
// "option" => "option",
// "section level 0" => "section level 0",
// "section level 1" => "section level 1",
// "section level 2" => "section level 2",
// "section level 3" => "section level 3",
// "sorted section level 0" => "sorted section level 0",
// "separator" => "separator",
// "Choose" => "Choose",
// "Home Page" => "Home Page",
// "Home Image Gal" => "Home Image Gal",
// "Home Image Gallery" => "Home Image Gallery",
// "Home File Gal" => "Home File Gal",
// "Home File Gallery" => "Home File Gallery",
// "User preferences" => "User preferences",
// "User prefs" => "User prefs",
// "List image galleries" => "List image galleries",
// "Gallery Rankings" => "Gallery Rankings",
// "Browse a gallery" => "Browse a gallery",
// "All articles" => "All articles",
// "Submit" => "Submit",
// "Create blog" => "Create blog",
// "File galleries" => "File galleries",
// "View a forum" => "View a forum",
// "View a thread" => "View a thread",
// "View a FAQ" => "View a FAQ",
// "Take a quiz" => "Take a quiz",
// "Stats for a Quiz" => "Stats for a Quiz",
// "Preview menu" => "Preview menu",
// "Menu options" => "Menu options",
// "Number of lines" => "Number of lines",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Export CSV data" => "Export CSV data",
// "Import CSV data" => "Import CSV data",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'." => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'.",
// "Admin Menu Builder" => "Admin Menu Builder",
// "Admin Menus Template" => "Admin Menus Template",
// "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=siteid\">Site identity</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu." => "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=siteid\">Site identity</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu.",
// "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes:" => "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes:",
// "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>" => "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>",
// "To use a menu in a tiki format: " => "To use a menu in a tiki format: ",
// "To use menu in a css/suckerfish format: " => "To use menu in a css/suckerfish format: ",
// "Edit this Menu:" => "Edit this Menu:",
// "Create new Menu" => "Create new Menu",
// "dynamic collapsed" => "dynamic collapsed",
// "dynamic extended" => "dynamic extended",
// "fixed" => "fixed",
// "Path to the folder icon for close sections" => "Path to the folder icon for close sections",
// "Example:" => "Example:",
// "Provide also a folder icon for open sections with the same name with the letter 'o' before in the same directory (ex: folder.png and ofolder.png)" => "Provide also a folder icon for open sections with the same name with the letter 'o' before in the same directory (ex: folder.png and ofolder.png)",
// "Default:" => "Default:",
// "Options" => "Options",
// "Admin Modules Template" => "Admin Modules Template",
// "Assign Module" => "Assign Module",
// "Left Modules" => "Left Modules",
// "Right Modules" => "Right Modules",
// "Edit/Create" => "Edit/Create",
// "Clear Cache" => "Clear Cache",
// "User Modules" => "User Modules",
// "Assign" => "Assign",
// "Assign new module" => "Assign new module",
// "Edit this assigned module:" => "Edit this assigned module:",
// "Module Name" => "Module Name",
// "Left" => "Left",
// "Right" => "Right",
// "Order" => "Order",
// "Cache Time" => "Cache Time",
// "Rows" => "Rows",
// "Parameters" => "Parameters",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme'). Separator between params:'&'. E.g. maxlen=15&nonums=y." => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme'). Separator between params:'&'. E.g. maxlen=15&nonums=y.",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups." => "setting will override your selection of specific groups.",
// "Visibility" => "Visibility",
// "Displayed now for all eligible users even with personal assigned modules" => "Displayed now for all eligible users even with personal assigned modules",
// "Displayed for the eligible users with no personal assigned modules" => "Displayed for the eligible users with no personal assigned modules",
// "Displayed now, can't be unassigned" => "Displayed now, can't be unassigned",
// "Not displayed until a user chooses it" => "Not displayed until a user chooses it",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// " or " => " or ",
// "to make sure users will notice any newly assigned modules." => "to make sure users will notice any newly assigned modules.",
// "Assigned Modules" => "Assigned Modules",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "Move to Right Column" => "Move to Right Column",
// "Unassign" => "Unassign",
// "Move to Left Column" => "Move to Left Column",
// "Create new user module" => "Create new user module",
// "Edit this user module:" => "Edit this user module:",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site." => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site.",
// "Must be wiki parsed" => "Must be wiki parsed",
// "Objects that can be included" => "Objects that can be included",
// "Available polls" => "Available polls",
// "Random active poll" => "Random active poll",
// "Random current poll" => "Random current poll",
// "Use Poll" => "Use Poll",
// "Random image from" => "Random image from",
// "Use Gallery" => "Use Gallery",
// "Dynamic content blocks" => "Dynamic content blocks",
// "Use Dynamic Content" => "Use Dynamic Content",
// "Use RSS Module" => "Use RSS Module",
// "Use Menu" => "Use Menu",
// "phpLayersMenus" => "phpLayersMenus",
// "Use phplayermenu" => "Use phplayermenu",
// "Banner zones" => "Banner zones",
// "Use Banner Zone" => "Use Banner Zone",
// "Use Wiki Structure" => "Use Wiki Structure",
// "Admin newsletter subscriptions" => "Admin newsletter subscriptions",
// "List Newsletters" => "List Newsletters",
// "Admin Newsletters" => "Admin Newsletters",
// "Add a subscription newsletters" => "Add a subscription newsletters",
// "You can add several email addresses by separating them with commas." => "You can add several email addresses by separating them with commas.",
// "Add email:" => "Add email:",
// "Add user:" => "Add user:",
// "Group users" => "Group users",
// "Group subscription also subscribes included groups" => "Group subscription also subscribes included groups",
// "Don't send confirmation mail" => "Don't send confirmation mail",
// "The user email will be refreshed at each newsletter sending" => "The user email will be refreshed at each newsletter sending",
// "Batch e-mail subscribe" => "Batch e-mail subscribe",
// "txt file, one e-mail per line" => "txt file, one e-mail per line",
// "Export Subscriber Emails" => "Export Subscriber Emails",
// "Subscribe group" => "Subscribe group",
// "Included group, group users and emails will be refreshed at each newsletter sending" => "Included group, group users and emails will be refreshed at each newsletter sending",
// "Add subscribers of another newsletter" => "Add subscribers of another newsletter",
// "Subscriptions" => "Subscriptions",
// "Valid" => "Valid",
// "subscribed" => "subscribed",
// "Admin Newsletters Template" => "Admin Newsletters Template",
// "Create/Edit Newsletters" => "Create/Edit Newsletters",
// "There are individual permissions set for this newsletter" => "There are individual permissions set for this newsletter",
// "Users can subscribe/unsubscribe to this list" => "Users can subscribe/unsubscribe to this list",
// "Users can subscribe any email address" => "Users can subscribe any email address",
// "Add unsubscribe instructions to each newsletter" => "Add unsubscribe instructions to each newsletter",
// "Validate email addresses" => "Validate email addresses",
// "Allow customized text message to be sent with the html version" => "Allow customized text message to be sent with the html version",
// "Editions" => "Editions",
// "Drafts" => "Drafts",
// "Last Sent" => "Last Sent",
// "Send Newsletter" => "Send Newsletter",
// "EMail notifications" => "EMail notifications",
// "Admin Email Notifications" => "Admin Email Notifications",
// "Admin Notifications Template" => "Admin Notifications Template",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications." => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications.",
// "Add notification" => "Add notification",
// "Alert" => "Alert",
// "Event" => "Event",
// "A user registers" => "A user registers",
// "A user submits an article" => "A user submits an article",
// "Any wiki page is changed" => "Any wiki page is changed",
// "Any wiki page is changed, even minor changes" => "Any wiki page is changed, even minor changes",
// "A comment in a wiki page is posted or edited" => "A comment in a wiki page is posted or edited",
// "PHP error" => "PHP error",
// "Email:" => "Email:",
// "Preload Admin Account" => "Preload Admin Account",
// "Admin Polls" => "Admin Polls",
// "List polls" => "List polls",
// "Edit this poll" => "Edit this poll",
// "Preview poll" => "Preview poll",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
// "Option" => "Option",
// "Poll options" => "Poll options",
// "Votes" => "Votes",
// "Admin Polls Template" => "Admin Polls Template",
// "Configure Polls" => "Configure Polls",
// "Set last poll as current" => "Set last poll as current",
// "Close all polls but last" => "Close all polls but last",
// "Activate all polls" => "Activate all polls",
// "Create poll" => "Create poll",
// "Edit poll" => "Edit poll",
// "active" => "active",
// "current" => "current",
// "template" => "template",
// "object" => "object",
// "PublishDate" => "PublishDate",
// "Objects" => "Objects",
// "Add poll to pages" => "Add poll to pages",
// "Wiki pages" => "Wiki pages",
// "Use Ctrl+Click to select multiple pages." => "Use Ctrl+Click to select multiple pages.",
// "Lock the pages" => "Lock the pages",
// "Admin Quicktags" => "Admin Quicktags",
// "tiki admin quicktags template" => "tiki admin quicktags template",
// "Create/Edit QuickTags" => "Create/Edit QuickTags",
// "Quicktags category filter" => "Quicktags category filter",
// "Insert (use 'text' for figuring the selection)" => "Insert (use 'text' for figuring the selection)",
// "Path to the tag icon" => "Path to the tag icon",
// "Admin RSS modules" => "Admin RSS modules",
// "Admin RSS Modules" => "Admin RSS Modules",
// "Admin RSSmodules Template" => "Admin RSSmodules Template",
// "Tips" => "Tips",
// "This page is to configure settings of RSS feeds read/imported by Tiki. To generate/export RSS feeds, look for \"RSS feeds\" on the admin panel, or" => "This page is to configure settings of RSS feeds read/imported by Tiki. To generate/export RSS feeds, look for \"RSS feeds\" on the admin panel, or",
// "To use RSS feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the RSS feed." => "To use RSS feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the RSS feed.",
// "Content for the feed" => "Content for the feed",
// "Edit this RSS module:" => "Edit this RSS module:",
// "Create new RSS module" => "Create new RSS module",
// "show feed title" => "show feed title",
// "show publish date" => "show publish date",
// "RSS channels" => "RSS channels",
// "Last update" => "Last update",
// "Show Title?" => "Show Title?",
// "Show Date?" => "Show Date?",
// "View feed" => "View feed",
// "Score System" => "Score System",
// "security admin" => "security admin",
// "security admin tpl" => "security admin tpl",
// "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>." => "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>.",
// "PHP settings" => "PHP settings",
// "PHP variable" => "PHP variable",
// "Risk Factor" => "Risk Factor",
// "Explanation" => "Explanation",
// "Tikiwiki settings" => "Tikiwiki settings",
// "Tiki variable" => "Tiki variable",
// "Security checks" => "Security checks",
// "Check all tiki files" => "Check all tiki files",
// "Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Note, that this can take a very long time. You should check your max_execution_time setting in php.ini.",
// "Note: You have to import security data via installation process (<a href=\"tiki-install.php\">tiki-install.php</a>). Import the *secdb* update files in your database." => "Note: You have to import security data via installation process (<a href=\"tiki-install.php\">tiki-install.php</a>). Import the *secdb* update files in your database.",
// "File checks" => "File checks",
// "Check file permissions" => "Check file permissions",
// "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments." => "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments.",
// "See end of table for detailed explanations." => "See end of table for detailed explanations.",
// "type" => "type",
// "owner" => "owner",
// "special" => "special",
// "user" => "user",
// "group" => "group",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
// "sticky" => "sticky",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results?" => "What to do with these check results?",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"." => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\".",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content." => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content.",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information." => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information.",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes!" => "Inodes that are not files or directories are not part of tiki. Review these Inodes!",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod." => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod.",
// "Admin Shoutbox Words" => "Admin Shoutbox Words",
// "Admin Shoutbox Words Template" => "Admin Shoutbox Words Template",
// "Add Banned Word" => "Add Banned Word",
// "Are you sure you want to delete this word?" => "Are you sure you want to delete this word?",
// "Admin structures template" => "Admin structures template",
// "The structure" => "The structure",
// "has just been created." => "has just been created.",
// "You will remove structure" => "You will remove structure",
// "Destroy the structure leaving the wiki pages" => "Destroy the structure leaving the wiki pages",
// "Destroy the structure and remove the pages" => "Destroy the structure and remove the pages",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict:" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict:",
// "The following pages have automatically been categorized with the same categories as the structure:" => "The following pages have automatically been categorized with the same categories as the structure:",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent:" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent:",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent:" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent:",
// "Structure ID" => "Structure ID",
// "Edit structure" => "Edit structure",
// "Export Pages" => "Export Pages",
// "PDF" => "PDF",
// "Dump Tree" => "Dump Tree",
// "Create WebHelp" => "Create WebHelp",
// "View WebHelp" => "View WebHelp",
// "Create new structure" => "Create new structure",
// "Alias" => "Alias",
// "Tree" => "Tree",
// "Note" => "Note",
// "Use single spaces to indent structure levels" => "Use single spaces to indent structure levels",
// "Create New Structure" => "Create New Structure",
// "Edit survey questions" => "Edit survey questions",
// "Survey Stats" => "Survey Stats",
// "this survey stats" => "this survey stats",
// "Edit this Survey" => "Edit this Survey",
// "Admin Surveys" => "Admin Surveys",
// "Create/edit questions for survey" => "Create/edit questions for survey",
// "Question" => "Question",
// "One choice" => "One choice",
// "Multiple choices" => "Multiple choices",
// "Short text" => "Short text",
// "Wiki textaera" => "Wiki textaera",
// "Rate (1..5)" => "Rate (1..5)",
// "Rate (1..10)" => "Rate (1..10)",
// "Rate" => "Rate",
// "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots",
// "For a rate, you can give the maximum value." => "For a rate, you can give the maximum value.",
// "Options (if apply)" => "Options (if apply)",
// "Questions" => "Questions",
// "question" => "question",
// "administer surveys template" => "administer surveys template",
// "Edit this Survey:" => "Edit this Survey:",
// "Create New Survey" => "Create New Survey",
// "There are individual permissions set for this survey" => "There are individual permissions set for this survey",
// "Open" => "Open",
// "system admin" => "system admin",
// "system admin tpl" => "system admin tpl",
// "If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed).",
// "Exterminator of cached content" => "Exterminator of cached content",
// "Empty" => "Empty",
// "All user prefs sessions" => "All user prefs sessions",
// "Directories to save:" => "Directories to save:",
// "Templates compiler" => "Templates compiler",
// "Compile" => "Compile",
// "Advanced feature" => "Advanced feature",
// "Fix UTF-8 Errors in Tables" => "Fix UTF-8 Errors in Tables",
// "Warning: Make a backup of your Database before using this function!" => "Warning: Make a backup of your Database before using this function!",
// "Warning: If you try to convert large tables, raise the maximum execution time in your php.ini!" => "Warning: If you try to convert large tables, raise the maximum execution time in your php.ini!",
// "This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "This function converts ISO-8859-1 encoded strings in your tables to UTF-8",
// "This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1" => "This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1",
// "UTF-8 Errors fixed" => "UTF-8 Errors fixed",
// "Table" => "Table",
// "Field" => "Field",
// "Investigate" => "Investigate",
// "Fix it" => "Fix it",
// "Admin Topics" => "Admin Topics",
// "Admin Topics Template" => "Admin Topics Template",
// "Create a new topic" => "Create a new topic",
// "Topic Name" => "Topic Name",
// "Upload Image" => "Upload Image",
// "List of topics" => "List of topics",
// "Active?" => "Active?",
// "Articles (subs)" => "Articles (subs)",
// "topic image" => "topic image",
// "Remove with articles" => "Remove with articles",
// "Inactive - Click to Activate" => "Inactive - Click to Activate",
// "Deactivate" => "Deactivate",
// "Active - Click to Deactivate" => "Active - Click to Deactivate",
// "Active Permissions" => "Active Permissions",
// "Admin Tracker" => "Admin Tracker",
// "admin Tracker fields tpl" => "admin Tracker fields tpl",
// "edit" => "edit",
// "Admin Trackers" => "Admin Trackers",
// "Edit This Tracker" => "Edit This Tracker",
// "View This Tracker's Items" => "View This Tracker's Items",
// "New tracker field" => "New tracker field",
// "Edit tracker field" => "Edit tracker field",
// "Select list items that will be displayed:" => "Select list items that will be displayed:",
// "Is column visible when listing tracker items?" => "Is column visible when listing tracker items?",
// "Column links to edit/view item?" => "Column links to edit/view item?",
// "Multilingual content" => "Multilingual content",
// "Column is searchable?" => "Column is searchable?",
// "Field is public? (viewed in trackerlist plugin)" => "Field is public? (viewed in trackerlist plugin)",
// "Field is hidden?" => "Field is hidden?",
// "not hidden" => "not hidden",
// "editable by admin only" => "editable by admin only",
// "visible by creator &amp; admin only" => "visible by creator &amp; admin only",
// "The option creator needs a field of type user selector and option 1" => "The option creator needs a field of type user selector and option 1",
// "Visible by:" => "Visible by:",
// "Editable by:" => "Editable by:",
// "Field is mandatory?" => "Field is mandatory?",
// "Error message:" => "Error message:",
// "Tracker fields" => "Tracker fields",
// "isMain" => "isMain",
// "Tbl vis" => "Tbl vis",
// "Searchable" => "Searchable",
// "Public" => "Public",
// "Hidden" => "Hidden",
// "Mandatory" => "Mandatory",
// "Import/Export Trackers Fields" => "Import/Export Trackers Fields",
// "Export fieldId also" => "Export fieldId also",
// "Admin Trackers tpl" => "Admin Trackers tpl",
// "Edit This Tracker's Fields" => "Edit This Tracker's Fields",
// "Edit Tracker" => "Edit Tracker",
// "Import/Export" => "Import/Export",
// "Create Trackers" => "Create Trackers",
// "Duplicate Tracker" => "Duplicate Tracker",
// "Found" => "Found",
// "trackers" => "trackers",
// "Fields" => "Fields",
// "with" => "with",
// "Create/Edit Trackers" => "Create/Edit Trackers",
// "There are individual permissions set for this tracker" => "There are individual permissions set for this tracker",
// "No individual permissions. Global permissions apply." => "No individual permissions. Global permissions apply.",
// "Description text is tiki-parsed:" => "Description text is tiki-parsed:",
// "Use Ratings:" => "Use Ratings:",
// "with values" => "with values",
// "and display rating results in listing?" => "and display rating results in listing?",
// "Auto create corresponding categories" => "Auto create corresponding categories",
// "Use \"explicit\" names in the mirror table" => "Use \"explicit\" names in the mirror table",
// "tracker name must be unique, field names must be unique \nfor a tracker and they must be valid in SQL" => "tracker name must be unique, field names must be unique \nfor a tracker and they must be valid in SQL",
// "Show status" => "Show status",
// "Default status displayed in list mode" => "Default status displayed in list mode",
// "Show status to tracker admin only" => "Show status to tracker admin only",
// "Send copies of all activity in this tracker to this e-mail address" => "Send copies of all activity in this tracker to this e-mail address",
// "Use simplified e-mail format" => "Use simplified e-mail format",
// "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender",
// "New items are created with status" => "New items are created with status",
// "Authoritative status for modified items" => "Authoritative status for modified items",
// "No change" => "No change",
// "Item creator can modify his items?" => "Item creator can modify his items?",
// "The tracker needs a user field with the option 1" => "The tracker needs a user field with the option 1",
// "Only one item per user or IP" => "Only one item per user or IP",
// "The tracker needs a user or IP field with the option 1" => "The tracker needs a user or IP field with the option 1",
// "Member of the default group of creator can modify items?" => "Member of the default group of creator can modify items?",
// "The tracker needs a group field with the option 1" => "The tracker needs a group field with the option 1",
// "Show creation date when listing tracker items?" => "Show creation date when listing tracker items?",
// "Format if not the default short one:" => "Format if not the default short one:",
// "Show creation date when viewing tracker item?" => "Show creation date when viewing tracker item?",
// "Show lastModif date when listing tracker items?" => "Show lastModif date when listing tracker items?",
// "Show lastModif date when viewing tracker item?" => "Show lastModif date when viewing tracker item?",
// "What field is used for default sort?" => "What field is used for default sort?",
// "LastModif" => "LastModif",
// "ItemId" => "ItemId",
// "What is default sort order in list?" => "What is default sort order in list?",
// "Tracker items allow ratings?" => "Tracker items allow ratings?",
// "Tracker items allow comments?" => "Tracker items allow comments?",
// "and display comments in listing?" => "and display comments in listing?",
// "Tracker items allow attachments?" => "Tracker items allow attachments?",
// "and display attachments in listing?" => "and display attachments in listing?",
// "Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)",
// "Filesize" => "Filesize",
// "Filetype" => "Filetype",
// "LongDesc" => "LongDesc",
// "Items can be created only during a certain time" => "Items can be created only during a certain time",
// "After:" => "After:",
// "Before:" => "Before:",
// "Do not show empty fields in item view?" => "Do not show empty fields in item view?",
// "Show these fields (ID comma separated) in a popup on item link when listing tracker items?" => "Show these fields (ID comma separated) in a popup on item link when listing tracker items?",
// "Import/export trackers" => "Import/export trackers",
// "Charset encoding" => "Charset encoding",
// "UTF-8" => "UTF-8",
// "ISO-8859-1" => "ISO-8859-1",
// "Separator" => "Separator",
// "Delimitors" => "Delimitors",
// "Carriage Return inside Field Value" => "Carriage Return inside Field Value",
// "Parse" => "Parse",
// "Info" => "Info",
// "status" => "status",
// "lastModif" => "lastModif",
// "Fields visible in items list" => "Fields visible in items list",
// "Fields searchable or visible in items list" => "Fields searchable or visible in items list",
// "Fields visible in an item view" => "Fields visible in an item view",
// "All fields" => "All fields",
// "or list of fields separated by comma" => "or list of fields separated by comma",
// "Date Format" => "Date Format",
// "timestamp" => "timestamp",
// "Admin groups" => "Admin groups",
// "Admin users" => "Admin users",
// "Add new group" => "Add new group",
// "Edit group" => "Edit group",
// "Members" => "Members",
// "Add a New Group" => "Add a New Group",
// "List of existing groups" => "List of existing groups",
// "Includes" => "Includes",
// "User Choice" => "User Choice",
// "Include" => "Include",
// "Only directly included" => "Only directly included",
// "will have all the permissions of the included groups" => "will have all the permissions of the included groups",
// "Group Homepage" => "Group Homepage",
// "Use wiki page name or full URL" => "Use wiki page name or full URL",
// "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)." => "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>).",
// "Enable now." => "Enable now.",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
// "Group Theme" => "Group Theme",
// "Use site default" => "Use site default",
// "Group Information Tracker" => "Group Information Tracker",
// "choose a group tracker ..." => "choose a group tracker ...",
// "choose a field ..." => "choose a field ...",
// "Users Information Tracker" => "Users Information Tracker",
// "choose a users tracker ..." => "choose a users tracker ...",
// "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)",
// "User can assign to the group himself" => "User can assign to the group himself",
// "Group tracker item : {\$groupitemid}" => "Group tracker item : {\$groupitemid}",
// "Edit Item" => "Edit Item",
// "Group tracker item not found" => "Group tracker item not found",
// "Create item" => "Create item",
// "Members List" => "Members List",
// "Remove from Group" => "Remove from Group",
// "users in group" => "users in group",
// "Download CSV export" => "Download CSV export",
// "Charset encoding:" => "Charset encoding:",
// "Assign users to group:" => "Assign users to group:",
// "User must already exist." => "User must already exist.",
// "To create users and assign them to groups, got to admin->users" => "To create users and assign them to groups, got to admin->users",
// "CSV File" => "CSV File",
// "Admin Users Template" => "Admin Users Template",
// "Add a New User" => "Add a New User",
// "Warning: since this tiki site is in slave mode, all user information you enter manually will be automatically overriden by other site's data, including users permissions" => "Warning: since this tiki site is in slave mode, all user information you enter manually will be automatically overriden by other site's data, including users permissions",
// "Batch Upload Results" => "Batch Upload Results",
// "Updated users" => "Updated users",
// "Rejected users" => "Rejected users",
// "Reason" => "Reason",
// "Edit user" => "Edit user",
// "More Criteria" => "More Criteria",
// "Group (direct)" => "Group (direct)",
// "Change user preferences" => "Change user preferences",
// "Edit Account Settings" => "Edit Account Settings",
// "User Information" => "User Information",
// "Need to validate email" => "Need to validate email",
// "Assign Group" => "Assign Group",
// "Edit Included Group" => "Edit Included Group",
// "Validate" => "Validate",
// "Remove Users and their Userpages" => "Remove Users and their Userpages",
// "Manage Group Assignments" => "Manage Group Assignments",
// "Set Default Groups" => "Set Default Groups",
// "Assign selected to" => "Assign selected to",
// "Remove selected from" => "Remove selected from",
// "the following groups:" => "the following groups:",
// "Tip: Hold down CTRL to select multiple" => "Tip: Hold down CTRL to select multiple",
// "Set the default group of the selected users to" => "Set the default group of the selected users to",
// "Assign to Groups" => "Assign to Groups",
// "Use the email as username" => "Use the email as username",
// "Warning: changing the username will require the user to change his password and will mess with slave intertiki sites that use this one as master" => "Warning: changing the username will require the user to change his password and will mess with slave intertiki sites that use this one as master",
// "Warning: changing the username will require the user to change his password" => "Warning: changing the username will require the user to change his password",
// "No password is required" => "No password is required",
// "Tikiwiki is configured to delegate the password managment to LDAP through PEAR Auth." => "Tikiwiki is configured to delegate the password managment to LDAP through PEAR Auth.",
// "Pass" => "Pass",
// "Again" => "Again",
// "User must change his password at first login" => "User must change his password at first login",
// "Registration" => "Registration",
// "Overwrite" => "Overwrite",
// "Overwrite but keep the previous login if the login exists in another case" => "Overwrite but keep the previous login if the login exists in another case",
// "Don't overwrite" => "Don't overwrite",
// "Overwrite groups:" => "Overwrite groups:",
// "User tracker item : {\$usersitemid}" => "User tracker item : {\$usersitemid}",
// "Loading..." => "Loading...",
// "Approve page changes in staging" => "Approve page changes in staging",
// "Page has been approved" => "Page has been approved",
// "New attachments" => "New attachments",
// "Old attachments" => "Old attachments",
// "Changes from the following versions under staging have been merged into the approved version" => "Changes from the following versions under staging have been merged into the approved version",
// "Admin Article Types" => "Admin Article Types",
// "Article Types tpl" => "Article Types tpl",
// "show help" => "show help",
// "Shows up in the drop down list of article types" => "Shows up in the drop down list of article types",
// "Allow ratings by the author" => "Allow ratings by the author",
// "Show before publish date" => "Show before publish date",
// "non-admins can view before the publish date" => "non-admins can view before the publish date",
// "Show after expire date" => "Show after expire date",
// "non-admins can view after the expire date" => "non-admins can view after the expire date",
// "Heading only" => "Heading only",
// "No article body, heading only" => "No article body, heading only",
// "Allow comments for this type" => "Allow comments for this type",
// "Comment Can Rate Article" => "Comment Can Rate Article",
// "Allow comments to include a rating value" => "Allow comments to include a rating value",
// "Show image" => "Show image",
// "Show topic or own image" => "Show topic or own image",
// "Show avatar" => "Show avatar",
// "Show author's avatar" => "Show author's avatar",
// "Show author" => "Show author",
// "Show author name" => "Show author name",
// "Show publish date" => "Show publish date",
// "Show expire date" => "Show expire date",
// "Show reads" => "Show reads",
// "Show the number of times the article was read" => "Show the number of times the article was read",
// "Show size" => "Show size",
// "Show the size of the article" => "Show the size of the article",
// "Show topline" => "Show topline",
// "Show a small title over the title" => "Show a small title over the title",
// "Show subtitle" => "Show subtitle",
// "Show the subtitle" => "Show the subtitle",
// "Show source" => "Show source",
// "Show link to source after article body" => "Show link to source after article body",
// "Show Image Caption" => "Show Image Caption",
// "Show a legend under the image" => "Show a legend under the image",
// "Show Language" => "Show Language",
// "Show the language" => "Show the language",
// "Creator can edit" => "Creator can edit",
// "The person who submits an article of this type can edit it" => "The person who submits an article of this type can edit it",
// "Delete this type" => "Delete this type",
// "List of types" => "List of types",
// "Show lang" => "Show lang",
// "Review" => "Review",
// "Classified" => "Classified",
// "Create a new type" => "Create a new type",
// "Assign permissions to group" => "Assign permissions to group",
// "Help for Assigning Permissions" => "Help for Assigning Permissions",
// "Edit Article Tpl" => "Edit Article Tpl",
// "Group Information" => "Group Information",
// "Desc" => "Desc",
// "level configuration" => "level configuration",
// "Create level" => "Create level",
// "all permissions in level" => "all permissions in level",
// "level" => "level",
// "inherited from" => "inherited from",
// "inherited" => "inherited",
// "Assign User {\$assign_user} to Groups" => "Assign User {\$assign_user} to Groups",
// "Default Group" => "Default Group",
// "Assign Perms to this Group" => "Assign Perms to this Group",
// "Assign User to Group" => "Assign User to Group",
// "backlinks to" => "backlinks to",
// "No backlinks to this page" => "No backlinks to this page",
// "Directory batch upload" => "Directory batch upload",
// "Browse gallery" => "Browse gallery",
// "Upload from disk" => "Upload from disk",
// "available images" => "available images",
// "width" => "width",
// "height" => "height",
// "Remove File Extension from Image Name" => "Remove File Extension from Image Name",
// "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field",
// "convert the last sub directory to a sub gallery" => "convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Select a Gallery" => "Select a Gallery",
// "Process" => "Process",
// "Browse file gallery" => "Browse file gallery",
// "Please do not use this feature to upload data into the database." => "Please do not use this feature to upload data into the database.",
// "available files" => "available files",
// "Select a File Gallery" => "Select a File Gallery",
// "Process files" => "Process files",
// "If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. " => "If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. ",
// "Wiki Help" => "Wiki Help",
// "The TikiWiki community" => "The TikiWiki community",
// "TikiWiki CMS/Groupware" => "TikiWiki CMS/Groupware",
// "Admin the Category System" => "Admin the Category System",
// "Admin Category" => "Admin Category",
// "Watch Only This Category" => "Watch Only This Category",
// "Watch This Category and Their Descendants" => "Watch This Category and Their Descendants",
// "Stop Watching Only This Category" => "Stop Watching Only This Category",
// "Stop Watching This Category and Their Descendants" => "Stop Watching This Category and Their Descendants",
// "Browse in" => "Browse in",
// "Trackers Items" => "Trackers Items",
// "Sheets" => "Sheets",
// "in the current category - and its subcategories: " => "in the current category - and its subcategories: ",
// "Hide subcategories objects" => "Hide subcategories objects",
// "Show subcategories objects" => "Show subcategories objects",
// "Upper level" => "Upper level",
// "Browse related tags" => "Browse related tags",
// "Network of Tags related to" => "Network of Tags related to",
// "Clear" => "Clear",
// "With all selected tags" => "With all selected tags",
// "With one selected tag" => "With one selected tag",
// "With last selected tag" => "With last selected tag",
// "More Popular Tags" => "More Popular Tags",
// "Sort:" => "Sort:",
// "Alphabetically" => "Alphabetically",
// "By Size" => "By Size",
// "Cloud" => "Cloud",
// "results found" => "results found",
// "Browsing Gallery" => "Browsing Gallery",
// "List Galleries" => "List Galleries",
// "Edit Gallery" => "Edit Gallery",
// "Rebuild Thumbnails" => "Rebuild Thumbnails",
// "Directory batch" => "Directory batch",
// "List Gallery" => "List Gallery",
// "All Images" => "All Images",
// "Monitor this Gallery" => "Monitor this Gallery",
// "Stop Monitoring this Gallery" => "Stop Monitoring this Gallery",
// "Sort Images by" => "Sort Images by",
// "subgallery" => "subgallery",
// "Subgallery" => "Subgallery",
// "Hit" => "Hit",
// "Original Size" => "Original Size",
// "rotate right" => "rotate right",
// "rotate" => "rotate",
// "Details" => "Details",
// "popup" => "popup",
// "Browsing Image" => "Browsing Image",
// "Return to Gallery" => "Return to Gallery",
// "Edit Image" => "Edit Image",
// "First Image" => "First Image",
// "Prev Image" => "Prev Image",
// "Smaller" => "Smaller",
// "Bigger" => "Bigger",
// "Popup window" => "Popup window",
// "Next Image" => "Next Image",
// "Slideshow Forward" => "Slideshow Forward",
// "Last Image" => "Last Image",
// "Stop" => "Stop",
// "Cyclic" => "Cyclic",
// "Direction" => "Direction",
// "Click to zoom" => "Click to zoom",
// "Image Name" => "Image Name",
// "Image size" => "Image size",
// "Image Scale" => "Image Scale",
// "Latitude (WGS84/decimal degrees)" => "Latitude (WGS84/decimal degrees)",
// "Longitude (WGS84/decimal degrees)" => "Longitude (WGS84/decimal degrees)",
// "Move image" => "Move image",
// "You can view this image in your browser using" => "You can view this image in your browser using",
// "You can include the image in an HTML page using one of these lines" => "You can include the image in an HTML page using one of these lines",
// "You can include the image in a tiki page using one of these lines" => "You can include the image in a tiki page using one of these lines",
// "Add Event" => "Add Event",
// "Click to select visible calendars" => "Click to select visible calendars",
// "Visible Calendars" => "Visible Calendars",
// "Group Calendars" => "Group Calendars",
// "Zoom" => "Zoom",
// "Change Focus" => "Change Focus",
// "+" => "+",
// "Hours" => "Hours",
// "Calendar Item" => "Calendar Item",
// "Config Calendars" => "Config Calendars",
// "Edit Calendar" => "Edit Calendar",
// "View event" => "View event",
// "Edit event" => "Edit event",
// "New event" => "New event",
// "Edit Calendar Item" => "Edit Calendar Item",
// "New Calendar Item" => "New Calendar Item",
// "End" => "End",
// "Duration" => "Duration",
// "Date and time of end" => "Date and time of end",
// "Tentative" => "Tentative",
// "Confirmed" => "Confirmed",
// "Cancelled" => "Cancelled",
// "or new" => "or new",
// "Location" => "Location",
// "Organized by" => "Organized by",
// "Roles" => "Roles",
// "chair" => "chair",
// "default role" => "default role",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non participant" => "non participant",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in:" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in:",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"." => "If no role is provided, default role will be \"Chair participant\".",
// "Duplicate to" => "Duplicate to",
// "Calendar import" => "Calendar import",
// "Calendar has been updated" => "Calendar has been updated",
// "import" => "import",
// "Focus:" => "Focus:",
// "Assign permissions to category" => "Assign permissions to category",
// "Categories checking is not done in the database search." => "Categories checking is not done in the database search.",
// "Current permissions for this category" => "Current permissions for this category",
// "Permission" => "Permission",
// "Remove from this Category Only" => "Remove from this Category Only",
// "Remove from this Category &amp; all its Children" => "Remove from this Category &amp; all its Children",
// "Assign permissions" => "Assign permissions",
// "to group" => "to group",
// "this category &amp; all its children" => "this category &amp; all its children",
// "this category only" => "this category only",
// "Assigning permissions for <b>all children</b> is recommended for best performance." => "Assigning permissions for <b>all children</b> is recommended for best performance.",
// "Change password enforced" => "Change password enforced",
// "Old password" => "Old password",
// "Again please" => "Again please",
// "Send a message to us" => "Send a message to us",
// "Contact us by email" => "Contact us by email",
// "Click here to send us an email" => "Click here to send us an email",
// "Contacts" => "Contacts",
// "Group View" => "Group View",
// "Create/edit contacts" => "Create/edit contacts",
// "First Name" => "First Name",
// "Publish this contact to groups" => "Publish this contact to groups",
// "Last Name" => "Last Name",
// "Nickname" => "Nickname",
// "You can browse the generated WebHelp here" => "You can browse the generated WebHelp here",
// "Structure" => "Structure",
// "Top page" => "Top page",
// "Tiki Debugger Console" => "Tiki Debugger Console",
// "Close" => "Close",
// "Current URL" => "Current URL",
// "Command" => "Command",
// "exec" => "exec",
// "Type <code>help</code> to get list of available commands" => "Type <code>help</code> to get list of available commands",
// "Add a new site" => "Add a new site",
// "You cannot add sites until Directory Categories are setup." => "You cannot add sites until Directory Categories are setup.",
// "Please contact the Site Administrator" => "Please contact the Site Administrator",
// "<a href=\"tiki-directory_admin_categories.php\">Add a category now</a>." => "<a href=\"tiki-directory_admin_categories.php\">Add a category now</a>.",
// "Site added" => "Site added",
// "The following site was added, but may require validation by the admin before appearing on the lists." => "The following site was added, but may require validation by the admin before appearing on the lists.",
// "Edit a site" => "Edit a site",
// "Add a site" => "Add a site",
// "URL:" => "URL:",
// "Categories:" => "Categories:",
// "Use Ctrl+Click to select multiple categories." => "Use Ctrl+Click to select multiple categories.",
// "Is valid" => "Is valid",
// "Directory Administration" => "Directory Administration",
// "Admin Directory tpl" => "Admin Directory tpl",
// "Edit Tpl" => "Edit Tpl",
// "There are" => "There are",
// "invalid sites" => "invalid sites",
// "valid sites" => "valid sites",
// "Users have visited" => "Users have visited",
// "sites from the directory" => "sites from the directory",
// "Users have searched" => "Users have searched",
// "times from the directory" => "times from the directory",
// "Admin sites" => "Admin sites",
// "Admin category relationships" => "Admin category relationships",
// "Validate links" => "Validate links",
// "Browse" => "Browse",
// "Related" => "Related",
// "Admin directory categories" => "Admin directory categories",
// "Admin Directory Categories tpl" => "Admin Directory Categories tpl",
// "Parent category" => "Parent category",
// "Add a directory category" => "Add a directory category",
// "Edit this directory category" => "Edit this directory category",
// "Children type" => "Children type",
// "Most visited sub-categories" => "Most visited sub-categories",
// "Category description" => "Category description",
// "Random sub-categories" => "Random sub-categories",
// "Maximum number of children to show" => "Maximum number of children to show",
// "Allow sites in this category" => "Allow sites in this category",
// "Show number of sites in this category" => "Show number of sites in this category",
// "Editor group" => "Editor group",
// "Subcategories" => "Subcategories",
// "cType" => "cType",
// "allow" => "allow",
// "count" => "count",
// "editor" => "editor",
// "relate" => "relate",
// "Admin related categories" => "Admin related categories",
// "Admin Directory Related " => "Admin Directory Related ",
// "directory admin related tpl" => "directory admin related tpl",
// "Add a related category" => "Add a related category",
// "Mutual" => "Mutual",
// "Related categories" => "Related categories",
// "Admin Directory Sites" => "Admin Directory Sites",
// "Admin Directory Sites tpl" => "Admin Directory Sites tpl",
// "Perform action with selected:" => "Perform action with selected:",
// "New Sites" => "New Sites",
// "Cool Sites" => "Cool Sites",
// "Add a Site" => "Add a Site",
// "Add a Category" => "Add a Category",
// "any" => "any",
// "in entire directory" => "in entire directory",
// "in current category" => "in current category",
// "Sort by" => "Sort by",
// "name (desc)" => "name (desc)",
// "name (asc)" => "name (asc)",
// "hits (desc)" => "hits (desc)",
// "hits (asc)" => "hits (asc)",
// "creation date (desc)" => "creation date (desc)",
// "creation date (asc)" => "creation date (asc)",
// "last updated (desc)" => "last updated (desc)",
// "last updated (asc)" => "last updated (asc)",
// "sort" => "sort",
// "Added" => "Added",
// "Last updated" => "Last updated",
// "No records." => "No records.",
// "Total categories" => "Total categories",
// "Total links" => "Total links",
// "Links to validate" => "Links to validate",
// "Searches performed" => "Searches performed",
// "Total links visited" => "Total links visited",
// "Directory ranking" => "Directory ranking",
// "Search results" => "Search results",
// "Validate sites" => "Validate sites",
// "Validate Sites" => "Validate Sites",
// "directory validate sites tpl" => "directory validate sites tpl",
// "country" => "country",
// "Edit Article" => "Edit Article",
// "List Articles" => "List Articles",
// "View Articles" => "View Articles",
// "One of the email addresses you typed is invalid" => "One of the email addresses you typed is invalid",
// "Topline" => "Topline",
// "Subtitle" => "Subtitle",
// "Author Name" => "Author Name",
// "Own Image" => "Own Image",
// "Use own image" => "Use own image",
// "Float text around image" => "Float text around image",
// "Own image size x" => "Own image size x",
// "Own image size y" => "Own image size y",
// "Image caption" => "Image caption",
// "Heading" => "Heading",
// "Body" => "Body",
// "Expiration Date" => "Expiration Date",
// "Emails to be notified (separated with commas)" => "Emails to be notified (separated with commas)",
// "Edit or create banners" => "Edit or create banners",
// "List banners" => "List banners",
// "URL to link the banner" => "URL to link the banner",
// "Client" => "Client",
// "Max impressions" => "Max impressions",
// "-1 for unlimited" => "-1 for unlimited",
// "Or, create a new zone" => "Or, create a new zone",
// "Show the banner only between these dates" => "Show the banner only between these dates",
// "From date" => "From date",
// "To date" => "To date",
// "Use dates" => "Use dates",
// "Show the banner only in this hours" => "Show the banner only in this hours",
// "to" => "to",
// "Show the banner only on" => "Show the banner only on",
// "Mon" => "Mon",
// "Tue" => "Tue",
// "Wed" => "Wed",
// "Thu" => "Thu",
// "Fri" => "Fri",
// "Sat" => "Sat",
// "Sun" => "Sun",
// "Select ONE method for the banner" => "Select ONE method for the banner",
// "Use HTML" => "Use HTML",
// "HTML code" => "HTML code",
// "Use image" => "Use image",
// "Image:" => "Image:",
// "Current Image" => "Current Image",
// "Use image generated by URL (the image will be requested at the URL for each impression)" => "Use image generated by URL (the image will be requested at the URL for each impression)",
// "Use Flash" => "Use Flash",
// "Movie URL" => "Movie URL",
// "Movie Size" => "Movie Size",
// "Pixels" => "Pixels",
// "FlashPlugin min version" => "FlashPlugin min version",
// "ex" => "ex",
// "Use text" => "Use text",
// "Text" => "Text",
// "Save the Banner" => "Save the Banner",
// "Remove Zones (you lose entered info for the banner)" => "Remove Zones (you lose entered info for the banner)",
// "Edit Blog" => "Edit Blog",
// "Create Blog" => "Create Blog",
// "Edit Blog Tpl" => "Edit Blog Tpl",
// "A category is mandatory" => "A category is mandatory",
// "Current heading" => "Current heading",
// "There are individual permissions set for this blog" => "There are individual permissions set for this blog",
// "Number of posts to show" => "Number of posts to show",
// "Allow other user to post in this blog" => "Allow other user to post in this blog",
// "Use titles in blog posts" => "Use titles in blog posts",
// "Allow search" => "Allow search",
// "Allow comments" => "Allow comments",
// "Show user avatar" => "Show user avatar",
// "Blog heading" => "Blog heading",
// "Edit Style Sheet" => "Edit Style Sheet",
// "Style Sheet" => "Style Sheet",
// "choose a stylesheet" => "choose a stylesheet",
// "Try" => "Try",
// "File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model." => "File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model.",
// "Show Plugins Help" => "Show Plugins Help",
// "For more information, please see <a href=\"{\$prefs.helpurl}Wiki Page Editor\">Wiki Page Editor</a>" => "For more information, please see <a href=\"{\$prefs.helpurl}Wiki Page Editor\">Wiki Page Editor</a>",
// "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines." => "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines.",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line.",
// "Quicktag" => "Quicktag",
// "Wiki Syntax" => "Wiki Syntax",
// "Format" => "Format",
// "Bold text" => "Bold text",
// "underscores" => "underscores",
// "Italic text" => "Italic text",
// "single quotes" => "single quotes",
// "Centered text" => "Centered text",
// "colons" => "colons",
// "some text" => "some text",
// "Underlined text" => "Underlined text",
// "equals" => "equals",
// "Text box" => "Text box",
// "One carat" => "One carat",
// "Creates a box with the data" => "Creates a box with the data",
// "Box content" => "Box content",
// "Title bar" => "Title bar",
// "creates a title bar" => "creates a title bar",
// "Will display using the indicated HTML color or color name" => "Will display using the indicated HTML color or color name",
// "Lists" => "Lists",
// "for bullet lists" => "for bullet lists",
// "for numbered lists" => "for numbered lists",
// "for definiton lists" => "for definiton lists",
// "Indentation" => "Indentation",
// "Creates an indentation for each plus(useful in list to continue at the same level)" => "Creates an indentation for each plus(useful in list to continue at the same level)",
// "Headings" => "Headings",
// "make headings" => "make headings",
// "Show/Hide" => "Show/Hide",
// "show/hide heading section. + (shown) or - (hidden) by default" => "show/hide heading section. + (shown) or - (hidden) by default",
// "Autonumbered Headings" => "Autonumbered Headings",
// "make autonumbered headings" => "make autonumbered headings",
// "Tables" => "Tables",
// "row" => "row",
// "col" => "col",
// "creates a table" => "creates a table",
// "Horizontal rule" => "Horizontal rule",
// "makes a horizontal rule" => "makes a horizontal rule",
// "Wiki References" => "Wiki References",
// "JoinCapitalizedWords or use" => "JoinCapitalizedWords or use",
// "page|desc" => "page|desc",
// "for wiki references" => "for wiki references",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
// "SomeName" => "SomeName",
// "prevents referencing" => "prevents referencing",
// "External links" => "External links",
// "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)." => "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox).",
// "For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))",
// "displays an image" => "displays an image",
// "imalign, height, width, desc, link, rel, title, usemap, class and align are optional" => "imalign, height, width, desc, link, rel, title, usemap, class and align are optional",
// "Non cacheable images" => "Non cacheable images",
// "height width desc link and align are optional" => "height width desc link and align are optional",
// "Line break" => "Line break",
// "(very useful especially in tables)" => "(very useful especially in tables)",
// "creates the editable drawing foo" => "creates the editable drawing foo",
// "Multi-page pages" => "Multi-page pages",
// "to separate pages" => "to separate pages",
// "Wiki File Attachments" => "Wiki File Attachments",
// "Creates a link to the named file.  If page is not given, the file must be attached to the current page.  If desc is not given, the file name is used for the link text, unless showdesc is used, which makes the file description be used for the link text.  If image=1 is given, the attachment is treated as an image and is displayed directly on the page; no link is generated." => "Creates a link to the named file.  If page is not given, the file must be attached to the current page.  If desc is not given, the file name is used for the link text, unless showdesc is used, which makes the file description be used for the link text.  If image=1 is given, the attachment is treated as an image and is displayed directly on the page; no link is generated.",
// "RSS feeds" => "RSS feeds",
// "displays rss feed with id=n maximum=m items" => "displays rss feed with id=n maximum=m items",
// "Will be replaced by the actual value of the dynamic content block with id=n" => "Will be replaced by the actual value of the dynamic content block with id=n",
// "Dynamic variables" => "Dynamic variables",
// "Inserts an editable variable" => "Inserts an editable variable",
// "Non parsed sections" => "Non parsed sections",
// "Prevents wiki parsing of the enclosed data." => "Prevents wiki parsing of the enclosed data.",
// "Preformated sections" => "Preformated sections",
// "\"~pp~ data ~/pp~\" Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  \"~pre~ data ~/pre~\" also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text." => "\"~pp~ data ~/pp~\" Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  \"~pre~ data ~/pre~\" also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text.",
// "\"~tc~ Tiki Comment ~/tc~\" makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  \"~hc~ HTML Comment ~/hc~\" makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar." => "\"~tc~ Tiki Comment ~/tc~\" makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  \"~hc~ HTML Comment ~/hc~\" makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar.",
// "Square Brackets" => "Square Brackets",
// "Use [[foo] to show [foo]." => "Use [[foo] to show [foo].",
// "Block Preformatting" => "Block Preformatting",
// "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that.",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew." => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew.",
// "\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "Misc" => "Misc",
// "Show Text Formatting Rules" => "Show Text Formatting Rules",
// "Plugins" => "Plugins",
// "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;",
// "Plugin" => "Plugin",
// "No description available" => "No description available",
// "bold" => "bold",
// "italic" => "italic",
// "underline" => "underline",
// "table" => "table",
// "table new" => "table new",
// "external link" => "external link",
// "wiki link'" => "wiki link'",
// "heading1" => "heading1",
// "title bar" => "title bar",
// "box" => "box",
// "rss feed" => "rss feed",
// "dynamic content" => "dynamic content",
// "tagline" => "tagline",
// "hr" => "hr",
// "center text" => "center text",
// "colored text" => "colored text",
// "dynamic variable" => "dynamic variable",
// "New wms Metadata" => "New wms Metadata",
// "New Class" => "New Class",
// "New Projection" => "New Projection",
// "New Query" => "New Query",
// "New Scalebar" => "New Scalebar",
// "New Layer" => "New Layer",
// "New Label" => "New Label",
// "New Reference" => "New Reference",
// "New Legend" => "New Legend",
// "New Web" => "New Web",
// "New Outputformat" => "New Outputformat",
// "New Mapfile" => "New Mapfile",
// "Add another image" => "Add another image",
// "special chars" => "special chars",
// "special characters" => "special characters",
// "Leave Fullscreen Edit" => "Leave Fullscreen Edit",
// "Fullscreen Edit" => "Fullscreen Edit",
// "Browse Images" => "Browse Images",
// "Edit successful!" => "Edit successful!",
// "The following image was successfully edited" => "The following image was successfully edited",
// "Image Description" => "Image Description",
// "Upload from disk to change the image:" => "Upload from disk to change the image:",
// "Save and Go Next" => "Save and Go Next",
// "Edit and create Languages" => "Edit and create Languages",
// "Im- Export Languages" => "Im- Export Languages",
// "Toggle interactive translation off" => "Toggle interactive translation off",
// "Toggle interactive translation on" => "Toggle interactive translation on",
// "Edit and create languages" => "Edit and create languages",
// "Create Language" => "Create Language",
// "Shortname" => "Shortname",
// "like" => "like",
// "Longname" => "Longname",
// "Select the language to edit" => "Select the language to edit",
// "Add a translation" => "Add a translation",
// "Edit translations" => "Edit translations",
// "Translate recorded" => "Translate recorded",
// "Original" => "Original",
// "Translate" => "Translate",
// "reset table" => "reset table",
// "Program dynamic content for block" => "Program dynamic content for block",
// "Create New Block" => "Create New Block",
// "Return to block listing" => "Return to block listing",
// "Block description: " => "Block description: ",
// "You are editing block:" => "You are editing block:",
// "Publishing date" => "Publishing date",
// "Publishing Date" => "Publishing Date",
// "Edit question options" => "Edit question options",
// "Quiz Stats" => "Quiz Stats",
// "This Quiz Stats" => "This Quiz Stats",
// "Edit this Quiz" => "Edit this Quiz",
// "Admin Quizzes" => "Admin Quizzes",
// "Create/edit options for question" => "Create/edit options for question",
// "points" => "points",
// "Admin quizzes" => "Admin quizzes",
// "Admin Quizzes tpl" => "Admin Quizzes tpl",
// "Create/edit quizzes" => "Create/edit quizzes",
// "There are individual permissions set for this quiz" => "There are individual permissions set for this quiz",
// "Quiz can be repeated" => "Quiz can be repeated",
// "Store quiz results" => "Store quiz results",
// "Immediate feedback" => "Immediate feedback",
// "Show correct answers" => "Show correct answers",
// "Shuffle questions" => "Shuffle questions",
// "Shuffle answers" => "Shuffle answers",
// "Questions per page" => "Questions per page",
// "Quiz is time limited" => "Quiz is time limited",
// "Maximum time" => "Maximum time",
// "Passing Percentage" => "Passing Percentage",
// "%" => "%",
// "canRepeat" => "canRepeat",
// "timeLimit" => "timeLimit",
// "Results" => "Results",
// "Edit quiz questions" => "Edit quiz questions",
// "Edit Quiz Questions" => "Edit Quiz Questions",
// "Edit Quiz Questions Tpl" => "Edit Quiz Questions Tpl",
// "Create/edit questions for quiz" => "Create/edit questions for quiz",
// "Question Type" => "Question Type",
// "Import questions from text" => "Import questions from text",
// "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character." => "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character.",
// "Input" => "Input",
// "maxScore" => "maxScore",
// "From Points" => "From Points",
// "To Points" => "To Points",
// "Answer" => "Answer",
// "Modify Structure" => "Modify Structure",
// "You will remove" => "You will remove",
// "and its subpages from the structure, now you have two options:" => "and its subpages from the structure, now you have two options:",
// "and its subpages from the structure" => "and its subpages from the structure",
// "Remove only from structure" => "Remove only from structure",
// "Remove from structure and remove page too" => "Remove from structure and remove page too",
// "The page already exists. The page that has been added to the structure is the existing one." => "The page already exists. The page that has been added to the structure is the existing one.",
// "The following pages added have automatically been categorized with the same categories as the structure:" => "The following pages added have automatically been categorized with the same categories as the structure:",
// "Structure Layout" => "Structure Layout",
// "Monitor the Sub-Structure" => "Monitor the Sub-Structure",
// "Stop Monitoring the Sub-Structure" => "Stop Monitoring the Sub-Structure",
// "Promote" => "Promote",
// "Demote" => "Demote",
// "Previous" => "Previous",
// "Current Node" => "Current Node",
// "Page alias" => "Page alias",
// "Move in this structure" => "Move in this structure",
// "Move to another structure" => "Move to another structure",
// "at the beginning" => "at the beginning",
// "at the end" => "at the end",
// "Add pages to current node" => "Add pages to current node",
// "After page" => "After page",
// "Create Page" => "Create Page",
// "Use pre-existing page" => "Use pre-existing page",
// "Categorize all pages in structure together" => "Categorize all pages in structure together",
// "Remove existing categories from ALL pages before recategorizing" => "Remove existing categories from ALL pages before recategorizing",
// "Help on Articles" => "Help on Articles",
// "Edit Submissions Tpl" => "Edit Submissions Tpl",
// "List Submissions" => "List Submissions",
// "<b>*</b>=optional" => "<b>*</b>=optional",
// "<b>Topline</b>=small line above Title" => "<b>Topline</b>=small line above Title",
// "<b>Subtitle</b>=small line below Title" => "<b>Subtitle</b>=small line below Title",
// "<b>Source</b>=URL to article source" => "<b>Source</b>=URL to article source",
// "Submit Article" => "Submit Article",
// "Auto-Approve Article" => "Auto-Approve Article",
// "EditTemplates" => "EditTemplates",
// "EditTemplates tpl" => "EditTemplates tpl",
// "Template listing" => "Template listing",
// "Available templates" => "Available templates",
// "Save Only in the Theme:" => "Save Only in the Theme:",
// "Delete the copy in the theme:" => "Delete the copy in the theme:",
// "Edit a topic" => "Edit a topic",
// "Add Notification Email" => "Add Notification Email",
// "Admin notifications" => "Admin notifications",
// "Translate:" => "Translate:",
// "Edit Translations" => "Edit Translations",
// "Edit Translations Template" => "Edit Translations Template",
// "You must specify the object language" => "You must specify the object language",
// "The object doesn't exist" => "The object doesn't exist",
// "The object doesn't have a language" => "The object doesn't have a language",
// "The object has already a translation for this language" => "The object has already a translation for this language",
// "The object is already in the set of translations" => "The object is already in the set of translations",
// "Language of newly translated page" => "Language of newly translated page",
// "Name of newly translated page" => "Name of newly translated page",
// "Create translation" => "Create translation",
// "Or" => "Or",
// "Add existing page as a translation of this page" => "Add existing page as a translation of this page",
// "Manage existing translations of this page" => "Manage existing translations of this page",
// "detach" => "detach",
// "Change language for this page" => "Change language for this page",
// "Select from available options..." => "Select from available options...",
// "Change Language" => "Change Language",
// "No language is assigned to this page." => "No language is assigned to this page.",
// "Please select a language before performing translation." => "Please select a language before performing translation.",
// "Set Current Page's Language" => "Set Current Page's Language",
// "Edit Section:" => "Edit Section:",
// "View object" => "View object",
// "Preview your changes." => "Preview your changes.",
// "Save the page." => "Save the page.",
// "Cancel the edit, you will lose your changes." => "Cancel the edit, you will lose your changes.",
// "Your edit session will expire in" => "Your edit session will expire in",
// "Your edit session will expire in 1 minute. You must PREVIEW or SAVE your work now, to avoid losing your edits." => "Your edit session will expire in 1 minute. You must PREVIEW or SAVE your work now, to avoid losing your edits.",
// "Update '{\$page}' based on '{\$source_page}'" => "Update '{\$page}' based on '{\$source_page}'",
// "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval." => "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval.",
// "This is a new staging page that has not been approved before." => "This is a new staging page that has not been approved before.",
// "The current staging copy may contain changes that have yet to be approved." => "The current staging copy may contain changes that have yet to be approved.",
// "View changes since last approval." => "View changes since last approval.",
// "You are editing the approved copy of this page." => "You are editing the approved copy of this page.",
// "There are currently changes in the staging copy that have yet to be approved." => "There are currently changes in the staging copy that have yet to be approved.",
// "Are you sure you do not want to edit" => "Are you sure you do not want to edit",
// "the staging copy" => "the staging copy",
// "instead?" => "instead?",
// "Draft written on" => "Draft written on",
// "Warning: new versions of this page have been made after this draft" => "Warning: new versions of this page have been made after this draft",
// "Perhaps you are looking for:" => "Perhaps you are looking for:",
// "This edit session will expire in {\$edittimeout} minutes" => "This edit session will expire in {\$edittimeout} minutes",
// "<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer." => "<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer.",
// "Categories will be inherited from the structure top page" => "Categories will be inherited from the structure top page",
// "Use rating" => "Use rating",
// "disable" => "disable",
// "There is no available poll template." => "There is no available poll template.",
// "You should ask an admin to create them." => "You should ask an admin to create them.",
// "or use" => "or use",
// "an existing poll" => "an existing poll",
// "votes" => "votes",
// "Regex search " => "Regex search ",
// "Replace to" => "Replace to",
// "Case Insensitivity" => "Case Insensitivity",
// "Translation request" => "Translation request",
// "Send urgent translation request." => "Send urgent translation request.",
// "Import HTML" => "Import HTML",
// "Try to convert HTML to wiki" => "Try to convert HTML to wiki",
// "Lock this page" => "Lock this page",
// "List Sheets" => "List Sheets",
// "Graph" => "Graph",
// "Export to file" => "Export to file",
// "Autodetect" => "Autodetect",
// "Admin FAQ" => "Admin FAQ",
// "View FAQ" => "View FAQ",
// "Edit this FAQ" => "Edit this FAQ",
// "New Question" => "New Question",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
// "Use a question from another FAQ" => "Use a question from another FAQ",
// "FAQ questions" => "FAQ questions",
// "Suggested questions" => "Suggested questions",
// "Approve" => "Approve",
// "No suggested questions" => "No suggested questions",
// "File Archive" => "File Archive",
// "Upload File" => "Upload File",
// "File Galleries tpl" => "File Galleries tpl",
// "Be carefull to set the right permissions on the files you link to" => "Be carefull to set the right permissions on the files you link to",
// "Browse Gallery" => "Browse Gallery",
// "Create New File Gallery" => "Create New File Gallery",
// "You can access the file gallery using the following URL" => "You can access the file gallery using the following URL",
// "Size (width x height)" => "Size (width x height)",
// "Forum Importer" => "Forum Importer",
// "Import from a Local SQL File" => "Import from a Local SQL File",
// "Forum Type" => "Forum Type",
// "DB Prefix" => "DB Prefix",
// "Local SQL Filename on Server (path will be stripped)" => "Local SQL Filename on Server (path will be stripped)",
// "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>." => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>.",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred." => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred.",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into?" => "Which Forum Do You Wish to Import this Into?",
// "Message queue for" => "Message queue for",
// "back to forum" => "back to forum",
// "Edit queued message" => "Edit queued message",
// "make this a thread of" => "make this a thread of",
// "None, this is a thread message" => "None, this is a thread message",
// "summary" => "summary",
// "normal" => "normal",
// "announce" => "announce",
// "hot" => "hot",
// "no feeling" => "no feeling",
// "frown" => "frown",
// "exclaim" => "exclaim",
// "idea" => "idea",
// "mad" => "mad",
// "neutral" => "neutral",
// "sad" => "sad",
// "happy" => "happy",
// "wink" => "wink",
// "Save and Approve" => "Save and Approve",
// "convert to topic" => "convert to topic",
// "List of messages" => "List of messages",
// "New Topic" => "New Topic",
// "no summary" => "no summary",
// "No messages queued yet" => "No messages queued yet",
// "Reject" => "Reject",
// "Search by name" => "Search by name",
// "Search in content" => "Search in content",
// "Configure Forum" => "Configure Forum",
// "Reported messages for" => "Reported messages for",
// "Reported by" => "Reported by",
// "No records to display" => "No records to display",
// "Perfom action with checked:" => "Perfom action with checked:",
// "Un-report" => "Un-report",
// "Tag translation" => "Tag translation",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag." => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag.",
// "Until then, they cannot be translated." => "Until then, they cannot be translated.",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
// "Set language" => "Set language",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
// "friends tpl" => "friends tpl",
// "Pending requests" => "Pending requests",
// "Request Time" => "Request Time",
// "Accept" => "Accept",
// "Refuse" => "Refuse",
// "Waiting requests" => "Waiting requests",
// "Cancel friendship request" => "Cancel friendship request",
// "Your friends" => "Your friends",
// "break friendship" => "break friendship",
// "Activity completed" => "Activity completed",
// "Admin process activities" => "Admin process activities",
// "To learn more about the <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://workflow.tikiwiki.org\">Galaxia workflow engine</a>" => "To learn more about the <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://workflow.tikiwiki.org\">Galaxia workflow engine</a>",
// "Add or edit an activity" => "Add or edit an activity",
// "activity" => "activity",
// "split" => "split",
// "join" => "join",
// "standalone" => "standalone",
// "interactive" => "interactive",
// "auto routed" => "auto routed",
// "Expiration Time" => "Expiration Time",
// "Years" => "Years",
// "Months" => "Months",
// "Minutes" => "Minutes",
// "Add transitions" => "Add transitions",
// "Add transition from:" => "Add transition from:",
// "Add transition to:" => "Add transition to:",
// "No roles associated to this activity" => "No roles associated to this activity",
// "Add Role" => "Add Role",
// "Add New" => "Add New",
// "Process activities" => "Process activities",
// "Int" => "Int",
// "Routing" => "Routing",
// "Interactive" => "Interactive",
// "Automatic" => "Automatic",
// "Auto routed" => "Auto routed",
// "Manual" => "Manual",
// "#" => "#",
// "inter" => "inter",
// "route" => "route",
// "(no roles)" => "(no roles)",
// "Code" => "Code",
// "No activities defined yet" => "No activities defined yet",
// "Process Transitions" => "Process Transitions",
// "List of transitions" => "List of transitions",
// "From:" => "From:",
// "Origin" => "Origin",
// "No transitions defined yet" => "No transitions defined yet",
// "Add a transition" => "Add a transition",
// "Process Graph" => "Process Graph",
// "Galaxia Admin Graph" => "Galaxia Admin Graph",
// "Galaxia Admin Graph tpl" => "Galaxia Admin Graph tpl",
// "This process is invalid" => "This process is invalid",
// "Process Graph for" => "Process Graph for",
// "No process graph is available. Either the process still contains errors, the graph is not generated yet, or <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a> is not properly installed." => "No process graph is available. Either the process still contains errors, the graph is not generated yet, or <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a> is not properly installed.",
// "List of processes" => "List of processes",
// "Inactive" => "Inactive",
// "act" => "act",
// "val" => "val",
// "Active Process" => "Active Process",
// "Invalid Process" => "Invalid Process",
// "Valid Process" => "Valid Process",
// "Activities" => "Activities",
// "New Minor" => "New Minor",
// "New Major" => "New Major",
// "No processes defined yet" => "No processes defined yet",
// "Admin instance" => "Admin instance",
// "Process:" => "Process:",
// "Instance" => "Instance",
// "Workitems" => "Workitems",
// "exception" => "exception",
// "completed" => "completed",
// "Aborted" => "Aborted",
// "Owner" => "Owner",
// "Send all to" => "Send all to",
// "Don't move" => "Don't move",
// "Started" => "Started",
// "Act status" => "Act status",
// "Ended" => "Ended",
// "Not Defined" => "Not Defined",
// "Not Interactive" => "Not Interactive",
// "Not Ended" => "Not Ended",
// "Property" => "Property",
// "Add property" => "Add property",
// "run instance" => "run instance",
// "Executed" => "Executed",
// "Pop-up" => "Pop-up",
// "erase" => "erase",
// "Galaxia Admin Processes" => "Galaxia Admin Processes",
// "Galaxia Admin Processes tpl" => "Galaxia Admin Processes tpl",
// "Add or edit a process" => "Add or edit a process",
// "Process Name" => "Process Name",
// "ver:" => "ver:",
// "is active?" => "is active?",
// "Or upload a process using this form" => "Or upload a process using this form",
// "Admin process roles" => "Admin process roles",
// "Add or edit a role" => "Add or edit a role",
// "Process roles" => "Process roles",
// "No roles defined yet" => "No roles defined yet",
// "Map users to roles" => "Map users to roles",
// "Map" => "Map",
// "map" => "map",
// "Map groups to roles" => "Map groups to roles",
// "Operation" => "Operation",
// "Warning" => "Warning",
// "No roles are defined yet so no roles can be mapped" => "No roles are defined yet so no roles can be mapped",
// "List of mappings" => "List of mappings",
// "No mappings defined yet" => "No mappings defined yet",
// "Admin process sources" => "Admin process sources",
// "select source" => "select source",
// "Shared code" => "Shared code",
// "Set next user" => "Set next user",
// "Get property" => "Get property",
// "Set property" => "Set property",
// "Complete" => "Complete",
// "Process form" => "Process form",
// "Set Next act" => "Set Next act",
// "If:SetNextact" => "If:SetNextact",
// "Switch construct" => "Switch construct",
// "Map process roles" => "Map process roles",
// "Admin Processes" => "Admin Processes",
// "Admin Activities" => "Admin Activities",
// "Admin Roles" => "Admin Roles",
// "Edit this Process" => "Edit this Process",
// "Galaxia Monitor Activities" => "Galaxia Monitor Activities",
// "Galaxia Monitor Activities tpl" => "Galaxia Monitor Activities tpl",
// "List of activities" => "List of activities",
// "Proc" => "Proc",
// "auto" => "auto",
// "int" => "int",
// "routing" => "routing",
// "Instances" => "Instances",
// "run" => "run",
// "run activity" => "run activity",
// "Enter the name of this instance" => "Enter the name of this instance",
// "The name is not valid. Please, enter the name again" => "The name is not valid. Please, enter the name again",
// "Monitor" => "Monitor",
// "monitor processes" => "monitor processes",
// "monitor activities" => "monitor activities",
// "monitor instances" => "monitor instances",
// "monitor workitems" => "monitor workitems",
// "Galaxia Monitor Instances" => "Galaxia Monitor Instances",
// "Galaxia Monitor Instances tpl" => "Galaxia Monitor Instances tpl",
// "List of instances" => "List of instances",
// "Not ended" => "Not ended",
// "No instances created yet" => "No instances created yet",
// "Galaxia Monitor Processes" => "Galaxia Monitor Processes",
// "Galaxia Monitor Processes tpl" => "Galaxia Monitor Processes tpl",
// "processes" => "processes",
// "being run" => "being run",
// "Completed" => "Completed",
// "Exceptions" => "Exceptions",
// "Monitor workitems" => "Monitor workitems",
// "List of workitems" => "List of workitems",
// "instance" => "instance",
// "Instance Id" => "Instance Id",
// "Instance Name" => "Instance Name",
// "Instance Status" => "Instance Status",
// "Elapsed time" => "Elapsed time",
// "My activities" => "My activities",
// "Current Activity" => "Current Activity",
// "Assigned To" => "Assigned To",
// "exception instance" => "exception instance",
// "exceptions instance" => "exceptions instance",
// "Send Instance" => "Send Instance",
// "abort instance" => "abort instance",
// "grab instance" => "grab instance",
// "release instance" => "release instance",
// "No activities found" => "No activities found",
// "My instances" => "My instances",
// "No instances found" => "No instances found",
// "User Activities" => "User Activities",
// "Galaxia User Activities" => "Galaxia User Activities",
// "Galaxia User Activities tpl" => "Galaxia User Activities tpl",
// "process" => "process",
// "No processes defined or activated yet" => "No processes defined or activated yet",
// "user processes" => "user processes",
// "user activities" => "user activities",
// "user instances" => "user instances",
// "Galaxia User Instances" => "Galaxia User Instances",
// "Galaxia User Instances tpl" => "Galaxia User Instances tpl",
// "Inst Status" => "Inst Status",
// "Not defined" => "Not defined",
// "No instances defined yet" => "No instances defined yet",
// "Galaxia User Processes" => "Galaxia User Processes",
// "Galaxia User Processes tpl" => "Galaxia User Processes tpl",
// "Browsing Workitem" => "Browsing Workitem",
// "Workitem information" => "Workitem information",
// "galleries tpl" => "galleries tpl",
// "Create New Gallery" => "Create New Gallery",
// "Create a gallery" => "Create a gallery",
// "Edit this gallery:" => "Edit this gallery:",
// "There are individual permissions set for this gallery" => "There are individual permissions set for this gallery",
// "Geographic" => "Geographic",
// "Fields to show during browsing the gallery" => "Fields to show during browsing the gallery",
// "Image ID" => "Image ID",
// "Creation Date" => "Creation Date",
// "XY-Size" => "XY-Size",
// "Gallery Image" => "Gallery Image",
// "Available scales" => "Available scales",
// "Global default" => "Global default",
// "Bounding box" => "Bounding box",
// "default scale" => "default scale",
// "No scales available" => "No scales available",
// "Original image is default scale" => "Original image is default scale",
// "Add scaled images with bounding box of square size" => "Add scaled images with bounding box of square size",
// "Other users can upload images to this gallery" => "Other users can upload images to this gallery",
// "You can access the gallery using the following URL" => "You can access the gallery using the following URL",
// "Available Galleries" => "Available Galleries",
// "Choose a filter" => "Choose a filter",
// "Imgs" => "Imgs",
// "Make Map" => "Make Map",
// "Save clicked point" => "Save clicked point",
// "Save current view as default" => "Save current view as default",
// "Reset view to site-wide default" => "Reset view to site-wide default",
// "Users Map" => "Users Map",
// "Select Graphic Type" => "Select Graphic Type",
// "Pie Chart" => "Pie Chart",
// "Multiline" => "Multiline",
// "Multibar" => "Multibar",
// "Bar Stack" => "Bar Stack",
// "Landscape" => "Landscape",
// "Portrait" => "Portrait",
// "Independant Scale" => "Independant Scale",
// "Horizontal" => "Horizontal",
// "Vertical" => "Vertical",
// "Horizontal Scale" => "Horizontal Scale",
// "Bottom" => "Bottom",
// "Vertical Scale" => "Vertical Scale",
// "Series" => "Series",
// "Wiki plug-in" => "Wiki plug-in",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
// " To " => " To ",
// "Calendar Import" => "Calendar Import",
// "ICal File" => "ICal File",
// "Im- Export languages" => "Im- Export languages",
// "Select the language to Import" => "Select the language to Import",
// "Select the language to Export" => "Select the language to Export",
// "Modify String in Source Language" => "Modify String in Source Language",
// "Original String" => "Original String",
// "New String" => "New String",
// "Import From File" => "Import From File",
// "Grab Wiki Tables" => "Grab Wiki Tables",
// "Import pages from a Structured Text Dump" => "Import pages from a Structured Text Dump",
// "ImportingPagesPhpWikiPageAdmin" => "ImportingPagesPhpWikiPageAdmin",
// "tiki-import_phpwiki tpl" => "tiki-import_phpwiki tpl",
// "Name of the dump file (it has to be in dump/)" => "Name of the dump file (it has to be in dump/)",
// "Overwrite existing pages if the name is the same" => "Overwrite existing pages if the name is the same",
// "Previously remove existing page versions" => "Previously remove existing page versions",
// "excerpt" => "excerpt",
// "Result" => "Result",
// "body" => "body",
// "Tiki installer" => "Tiki installer",
// "Success" => "Success",
// "MultiTiki setup" => "MultiTiki setup",
// "To add a new virtual host" => "To add a new virtual host",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
// "MultiTiki" => "MultiTiki",
// "Tiki cannot find a database connection" => "Tiki cannot find a database connection",
// "Please enter your database connection information" => "Please enter your database connection information",
// "Database type" => "Database type",
// "Select the type of database to use with Tiki." => "Select the type of database to use with Tiki.",
// "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension." => "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension.",
// "Host:" => "Host:",
// "Enter the hostname or IP for your database. Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Enter the hostname or IP for your database. Use <strong>localhost</strong> if the database is running on the same machine as Tiki",
// "For SQLite, enter the path and filename to your database file" => "For SQLite, enter the path and filename to your database file",
// "Database name" => "Database name",
// "Enter the name of the database that Tiki will use." => "Enter the name of the database that Tiki will use.",
// "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your\nhosting provider.  Normally Tiki tables won't conflict with other product names" => "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your\nhosting provider.  Normally Tiki tables won't conflict with other product names",
// "For Oracle" => "For Oracle",
// "Enter your TNS Name here and leave Host empty" => "Enter your TNS Name here and leave Host empty",
// "Override tnsnames.ora and put your SID here and enter your hostname:port in the Host field" => "Override tnsnames.ora and put your SID here and enter your hostname:port in the Host field",
// "Database User" => "Database User",
// "Enter the database user with administrator permission for the Database" => "Enter the database user with administrator permission for the Database",
// "Enter the password for the database user" => "Enter the password for the database user",
// "Connect" => "Connect",
// "Welcome to the installation{if \$tikidb_created} &amp; upgrade{/if} script!" => "Welcome to the installation{if \$tikidb_created} &amp; upgrade{/if} script!",
// "Reinstall database." => "Reinstall database.",
// "This will destroy your current database" => "This will destroy your current database",
// "Install" => "Install",
// "Create a new database (clean install) with profile" => "Create a new database (clean install) with profile",
// "No profiles available." => "No profiles available.",
// "See the documentation for <a target=\"_blank\" href=\"http://doc.tikiwiki.org/Profiles\" class=\"link\" title=\"{tr}Description of available profiles." => "See the documentation for <a target=\"_blank\" href=\"http://doc.tikiwiki.org/Profiles\" class=\"link\" title=\"{tr}Description of available profiles.",
// "Upgrade" => "Upgrade",
// "Backup your database with mysqldump, phpmyadmin, or other before upgrading." => "Backup your database with mysqldump, phpmyadmin, or other before upgrading.",
// "Update database using script" => "Update database using script",
// "No scripts available." => "No scripts available.",
// "To upgrade from" => "To upgrade from",
// "Use this script" => "Use this script",
// "Then rerun the installer using tiki_1.9to2.0." => "Then rerun the installer using tiki_1.9to2.0.",
// "See <a target=\"help\" class=\"link\" href=\"http://doc.tikiwiki.org/Upgrade+1.7+to+1.8\">Tiki database 1.7.x to 1.8x instructions" => "See <a target=\"help\" class=\"link\" href=\"http://doc.tikiwiki.org/Upgrade+1.7+to+1.8\">Tiki database 1.7.x to 1.8x instructions",
// "For information about <strong>tiki-secdb_*.sql</strong> files, please see <a target=\"help\" class=\"link\" href=\"http://doc.tikiwiki.org/Security+Admin\">http://doc.tikiwiki.org/Security+Admin" => "For information about <strong>tiki-secdb_*.sql</strong> files, please see <a target=\"help\" class=\"link\" href=\"http://doc.tikiwiki.org/Security+Admin\">http://doc.tikiwiki.org/Security+Admin",
// "Other Options" => "Other Options",
// "Do nothing and enter Tiki" => "Do nothing and enter Tiki",
// "Reset database connection settings" => "Reset database connection settings",
// "This site has an admin account configured" => "This site has an admin account configured",
// "Please login with your admin password to continue" => "Please login with your admin password to continue",
// "Installation" => "Installation",
// "Your database has been configured and Tikiwiki is ready to run!" => "Your database has been configured and Tikiwiki is ready to run!",
// "If this is your first install, your admin password is <strong>admin</strong>." => "If this is your first install, your admin password is <strong>admin</strong>.",
// "You can now log in into Tikiwiki as user <strong>admin</strong> and start configuring the application." => "You can now log in into Tikiwiki as user <strong>admin</strong> and start configuring the application.",
// "operations executed successfully" => "operations executed successfully",
// "SQL queries" => "SQL queries",
// "Failed" => "Failed",
// "Operations failed" => "Operations failed",
// "Display details" => "Display details",
// "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages." => "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages.",
// "Important Information" => "Important Information",
// "Please read the following notes before entering Tikiwiki." => "Please read the following notes before entering Tikiwiki.",
// "Memory" => "Memory",
// "TikiWiki requires <strong>at least</strong> 16MB of PHP memory for script execution. Use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 16M) and restart your webserver" => "TikiWiki requires <strong>at least</strong> 16MB of PHP memory for script execution. Use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 16M) and restart your webserver",
// "Allocating too little memory will cause TikiWiki to display blank pages" => "Allocating too little memory will cause TikiWiki to display blank pages",
// "Tiki has not detected your PHP memory_limit. This probably means you have no set limit (all is well)" => "Tiki has not detected your PHP memory_limit. This probably means you have no set limit (all is well)",
// "Tiki has detected your PHP memory limit at" => "Tiki has detected your PHP memory limit at",
// "Tiki has detected your PHP memory_limit at" => "Tiki has detected your PHP memory_limit at",
// "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu." => "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu.",
// "Entering TikiWiki" => "Entering TikiWiki",
// "Change the administrator password" => "Change the administrator password",
// "Continue in installer" => "Continue in installer",
// "Go back and run another install/upgrade script" => "Go back and run another install/upgrade script",
// "Do not use your browser's Back button." => "Do not use your browser's Back button.",
// "Clear cached version and refresh cache" => "Clear cached version and refresh cache",
// "configure rules" => "configure rules",
// "Edit Repository" => "Edit Repository",
// "Interactive translator" => "Interactive translator",
// "has been updated" => "has been updated",
// "Close this window" => "Close this window",
// "Go Back" => "Go Back",
// "Clicking 'Close this window' will reload the main window from where it was opened" => "Clicking 'Close this window' will reload the main window from where it was opened",
// "weeks" => "weeks",
// "Search by Date" => "Search by Date",
// "LastChanges" => "LastChanges",
// "hist" => "hist",
// "v" => "v",
// "Rollback" => "Rollback",
// "Pages like" => "Pages like",
// "No pages found" => "No pages found",
// "List Articles Tpl" => "List Articles Tpl",
// "Edit New Article" => "Edit New Article",
// "ExpireDate" => "ExpireDate",
// "AuthorName" => "AuthorName",
// "Admin Banners" => "Admin Banners",
// "Admin Banners tpl" => "Admin Banners tpl",
// "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone." => "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone.",
// "Create banner" => "Create banner",
// "Method" => "Method",
// "Use Dates?" => "Use Dates?",
// "Max Impressions" => "Max Impressions",
// "Impressions" => "Impressions",
// "Clicks" => "Clicks",
// "Create New Blog" => "Create New Blog",
// "Admin Cache" => "Admin Cache",
// "Admin Cache tpl" => "Admin Cache tpl",
// "The cache is used by:" => "The cache is used by:",
// "Orphan" => "Orphan",
// "Dynamic content system" => "Dynamic content system",
// "Help on Dynamic Content" => "Help on Dynamic Content",
// "Admin DynamicContent tpl" => "Admin DynamicContent tpl",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block." => "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block.",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block." => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block.",
// "Edit content block" => "Edit content block",
// "Create content block" => "Create content block",
// "Available content blocks" => "Available content blocks",
// "Current Value" => "Current Value",
// "Current ver" => "Current ver",
// "Next ver" => "Next ver",
// "Future vers" => "Future vers",
// "Program" => "Program",
// "List FAQs Tpl" => "List FAQs Tpl",
// "Edit this FAQ:" => "Edit this FAQ:",
// "Create new FAQ" => "Create new FAQ",
// "Create New FAQ:" => "Create New FAQ:",
// "Users can suggest questions" => "Users can suggest questions",
// "Available FAQs" => "Available FAQs",
// "Create a file gallery" => "Create a file gallery",
// "SlideShow" => "SlideShow",
// "Your comment" => "Your comment",
// "optional" => "optional",
// "Modifications" => "Modifications",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Gallery Images" => "Gallery Images",
// "games tpl" => "games tpl",
// "/" => "/",
// "All games are from" => "All games are from",
// "visit the site for more games and fun" => "visit the site for more games and fun",
// "Upload a game" => "Upload a game",
// "Upload a new game" => "Upload a new game",
// "Flash binary (.swf or .dcr)" => "Flash binary (.swf or .dcr)",
// "Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)" => "Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)",
// "Edit game" => "Edit game",
// "Played" => "Played",
// "times" => "times",
// "If you can't see the game then you need a flash plugin for your browser" => "If you can't see the game then you need a flash plugin for your browser",
// "List Posts Tpl" => "List Posts Tpl",
// "Blog Title" => "Blog Title",
// "List Quizzes Tpl" => "List Quizzes Tpl",
// "Edit New Submission" => "Edit New Submission",
// "Edit Quiz Stats Tpl" => "Edit Quiz Stats Tpl",
// "Survey stats" => "Survey stats",
// "Take Survey" => "Take Survey",
// "List Trackers Tpl" => "List Trackers Tpl",
// "users registered" => "users registered",
// "Distance (km)" => "Distance (km)",
// "List Movies" => "List Movies",
// "Choose a movie" => "Choose a movie",
// "Last mod" => "Last mod",
// "Last modification" => "Last modification",
// "Page creator" => "Page creator",
// "Last author" => "Last author",
// "Last ver." => "Last ver.",
// "Status of the page" => "Status of the page",
// "Vers." => "Vers.",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// "Backl." => "Backl.",
// "Page size" => "Page size",
// "Lang." => "Lang.",
// "unlocked" => "unlocked",
// "Perform action with checked" => "Perform action with checked",
// "Admin Live Support tpl" => "Admin Live Support tpl",
// "Open client window" => "Open client window",
// "Generate HTML" => "Generate HTML",
// "Transcripts" => "Transcripts",
// "Support tickets" => "Support tickets",
// "Online operators" => "Online operators",
// "Operator" => "Operator",
// "Accepted requests" => "Accepted requests",
// "transcripts" => "transcripts",
// "offline" => "offline",
// "Offline operators" => "Offline operators",
// "Add an operator to the system" => "Add an operator to the system",
// "Operators must be tiki users" => "Operators must be tiki users",
// "Set as Operator" => "Set as Operator",
// "Chat started" => "Chat started",
// "Operator:" => "Operator:",
// "Live support:User window" => "Live support:User window",
// "Request live support" => "Request live support",
// "Request support" => "Request support",
// "Open a support ticket instead" => "Open a support ticket instead",
// "Your request is being processed" => "Your request is being processed",
// "cancel request and exit" => "cancel request and exit",
// "cancel request and leave a message" => "cancel request and leave a message",
// "Live support:Console" => "Live support:Console",
// "be online" => "be online",
// "be offline" => "be offline",
// "Support requests" => "Support requests",
// "Requested" => "Requested",
// "Join" => "Join",
// "Support chat transcripts" => "Support chat transcripts",
// "back to admin" => "back to admin",
// "operator" => "operator",
// "started" => "started",
// "reason" => "reason",
// "msgs" => "msgs",
// "Transcript" => "Transcript",
// "For security purposes we must periodically validate your email address to allow continued access to this site." => "For security purposes we must periodically validate your email address to allow continued access to this site.",
// "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site." => "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site.",
// "Thank you" => "Thank you",
// "Mail-in feature" => "Mail-in feature",
// "User Calendar" => "User Calendar",
// "User Calendar Doc tpl" => "User Calendar Doc tpl",
// "Prefs" => "Prefs",
// "Remove old events" => "Remove old events",
// "duration" => "duration",
// "Add event" => "Add event",
// "Mini Calendar: Preferences" => "Mini Calendar: Preferences",
// "User Calendar Doc" => "User Calendar Doc",
// "User Calendar Preferences Doc tpl" => "User Calendar Preferences Doc tpl",
// "Calendar Interval in daily view" => "Calendar Interval in daily view",
// "Start hour for days" => "Start hour for days",
// "End hour for days" => "End hour for days",
// "Reminders" => "Reminders",
// "no reminders" => "no reminders",
// "Or enter path or URL" => "Or enter path or URL",
// "Add Topic" => "Add Topic",
// "Tikiwiki Mods" => "Tikiwiki Mods",
// "Mods Configuration" => "Mods Configuration",
// "Update remote index" => "Update remote index",
// "Rebuild local list" => "Rebuild local list",
// "Republish all" => "Republish all",
// "Publish all" => "Publish all",
// "Unpublish all" => "Unpublish all",
// "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>." => "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>.",
// "Attention" => "Attention",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"./fixperms fix\" for example)." => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"./fixperms fix\" for example).",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"./fixperms.sh open\" to set it up). After installation you need to remove that permission (using \"./fixperms fix\")." => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"./fixperms.sh open\" to set it up). After installation you need to remove that permission (using \"./fixperms fix\").",
// "all types" => "all types",
// "Display only this type" => "Display only this type",
// "Unpublish" => "Unpublish",
// "Republish" => "Republish",
// "licence" => "licence",
// "Tikiwiki Mods Configuration" => "Tikiwiki Mods Configuration",
// "Mods Install/uninstall" => "Mods Install/uninstall",
// "Enable Mods providing" => "Enable Mods providing",
// "Mods local directory" => "Mods local directory",
// "Mods remote server" => "Mods remote server",
// "Package Config" => "Package Config",
// "my tiki tpl" => "my tiki tpl",
// "User Pages" => "User Pages",
// "y" => "y",
// "User Galleries" => "User Galleries",
// "Assigned items" => "Assigned items",
// "Unread Messages" => "Unread Messages",
// "User forum topics" => "User forum topics",
// "Forum topics" => "Forum topics",
// "Date of post" => "Date of post",
// "User forum replies" => "User forum replies",
// "Forum replies" => "Forum replies",
// "User Blogs" => "User Blogs",
// "To display the objects you participate:" => "To display the objects you participate:",
// "Contacts Preferences" => "Contacts Preferences",
// "MyFiles" => "MyFiles",
// "My Infos" => "My Infos",
// "My Contacts" => "My Contacts",
// "My Wiki Pages" => "My Wiki Pages",
// "My Galleries" => "My Galleries",
// "My Tracker Items" => "My Tracker Items",
// "My Messages" => "My Messages",
// "My Tasks" => "My Tasks",
// "Subscribe" => "Subscribe",
// "Sent Edition" => "Sent Edition",
// "HTML version" => "HTML version",
// "Text version" => "Text version",
// "Errors:" => "Errors:",
// "Delete errors" => "Delete errors",
// "Not sent" => "Not sent",
// "Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed.",
// "Your email address was removed from the list of subscriptors." => "Your email address was removed from the list of subscriptors.",
// "Subscription confirmed!" => "Subscription confirmed!",
// "Subscribe to Newsletter" => "Subscribe to Newsletter",
// "Subscribe to This Newsletter" => "Subscribe to This Newsletter",
// "Available Newsletters" => "Available Newsletters",
// "Select news group" => "Select news group",
// "Back to servers" => "Back to servers",
// "Msgs" => "Msgs",
// "News from" => "News from",
// "Back to groups" => "Back to groups",
// "Save position" => "Save position",
// "Reading article from" => "Reading article from",
// "Back to list of articles" => "Back to list of articles",
// "First" => "First",
// "Newsgroup" => "Newsgroup",
// "Configure news servers" => "Configure news servers",
// "Configure Newsreader" => "Configure Newsreader",
// "configure newsreader server tpl" => "configure newsreader server tpl",
// "Select a news server to browse" => "Select a news server to browse",
// "server" => "server",
// "Read the news" => "Read the news",
// "Add a news server" => "Add a news server",
// "Edit news server" => "Edit news server",
// "News server" => "News server",
// "Notes" => "Notes",
// "Write a note" => "Write a note",
// "quota" => "quota",
// "No notes yet" => "No notes yet",
// "Merge selected notes into" => "Merge selected notes into",
// "Reading note:" => "Reading note:",
// "List notes" => "List notes",
// "Write note" => "Write note",
// "Wiki Create" => "Wiki Create",
// "Wiki Overwrite" => "Wiki Overwrite",
// "Assign permissions to " => "Assign permissions to ",
// "Back" => "Back",
// "View Permissions" => "View Permissions",
// "Edit Permissions" => "Edit Permissions",
// "These permissions override any global permissions or category permissions affecting this object." => "These permissions override any global permissions or category permissions affecting this object.",
// "To edit global permissions <a class=\"rbox-link\" href=\"tiki-admingroups.php\">click here</a>." => "To edit global permissions <a class=\"rbox-link\" href=\"tiki-admingroups.php\">click here</a>.",
// "Current permissions for this object" => "Current permissions for this object",
// "No individual permissions, category permissions apply" => "No individual permissions, category permissions apply",
// "Current permissions for categories that this object belongs to" => "Current permissions for categories that this object belongs to",
// "These permissions do not apply. Special permissions apply." => "These permissions do not apply. Special permissions apply.",
// "No category permissions; global permissions apply" => "No category permissions; global permissions apply",
// "No category permissions; special permissions apply" => "No category permissions; special permissions apply",
// "and also to all pages of the sub-structure:" => "and also to all pages of the sub-structure:",
// "Assign permissions to this object" => "Assign permissions to this object",
// "Perms Help" => "Perms Help",
// "Published" => "Published",
// "Your OpenID identity is valid" => "Your OpenID identity is valid",
// "However, no account is associated to the OpenID identifier." => "However, no account is associated to the OpenID identifier.",
// "Create a new Tikiwiki account from OpenID" => "Create a new Tikiwiki account from OpenID",
// "Associate OpenID with an existing Tikiwiki account" => "Associate OpenID with an existing Tikiwiki account",
// "Your identity gives you access to multiple user accounts." => "Your identity gives you access to multiple user accounts.",
// "Select account" => "Select account",
// "Orphan Pages" => "Orphan Pages",
// "Browser not supported" => "Browser not supported",
// "Make Structure" => "Make Structure",
// "{\$atts|@count} files attached" => "{\$atts|@count} files attached",
// "Preview of version" => "Preview of version",
// "(current)" => "(current)",
// "Rollback to this version" => "Rollback to this version",
// "Source of version" => "Source of version",
// "s=source" => "s=source",
// "b=rollback" => "b=rollback",
// "HTML diff" => "HTML diff",
// "Side-by-side diff" => "Side-by-side diff",
// "Side-by-side diff by characters" => "Side-by-side diff by characters",
// "Inline diff" => "Inline diff",
// "Inline diff by characters" => "Inline diff by characters",
// "Full side-by-side diff by characters" => "Full side-by-side diff by characters",
// "Full inline diff" => "Full inline diff",
// "Full inline diff by characters" => "Full inline diff by characters",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "Update Translation" => "Update Translation",
// "Hide translation history" => "Hide translation history",
// "Show translation history" => "Show translation history",
// "Avatar:" => "Avatar:",
// "Pick your avatar" => "Pick your avatar",
// "User Preferences" => "User Preferences",
// "Your current avatar" => "Your current avatar",
// "no avatar" => "no avatar",
// "reset" => "reset",
// "Pick avatar from the library" => "Pick avatar from the library",
// "Pick user Avatar" => "Pick user Avatar",
// "Hide all" => "Hide all",
// "icons" => "icons",
// "Show all" => "Show all",
// "Avatar Image" => "Avatar Image",
// "Upload your own avatar" => "Upload your own avatar",
// "(Only .gif images, and aproximately 45px x 45px)" => "(Only .gif images, and aproximately 45px x 45px)",
// "Any" => "Any",
// "Items found:" => "Items found:",
// "atts" => "atts",
// "List Attachments" => "List Attachments",
// "View Results" => "View Results",
// "Vote poll" => "Vote poll",
// "Other Polls" => "Other Polls",
// "Poll Results" => "Poll Results",
// "Top Voted Polls" => "Top Voted Polls",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Average:" => "Average:",
// "List Votes" => "List Votes",
// "Note: Remember that this is only a preview, and has not yet been saved!" => "Note: Remember that this is only a preview, and has not yet been saved!",
// "Permission denied. You do not have permission to read complete articles." => "Permission denied. You do not have permission to read complete articles.",
// "Print multiple pages" => "Print multiple pages",
// "Selected Structures" => "Selected Structures",
// "Add Structure" => "Add Structure",
// "No structures" => "No structures",
// "Add Pages" => "Add Pages",
// "No pages" => "No pages",
// "Use Ctrl+Click to select multiple pages" => "Use Ctrl+Click to select multiple pages",
// "Add Pages from Structures" => "Add Pages from Structures",
// "Add Structure Pages" => "Add Structure Pages",
// "Selected Pages" => "Selected Pages",
// "No pages selected." => "No pages selected.",
// "Edit quiz" => "Edit quiz",
// "General Options" => "General Options",
// "Name:" => "Name:",
// "Publication Date" => "Publication Date",
// "at " => "at ",
// "Use " => "Use ",
// "randomly selected questions." => "randomly selected questions.",
// "Test-time Options" => "Test-time Options",
// "Limit questions displayed per page to " => "Limit questions displayed per page to ",
// "&nbsp question(s)." => "&nbsp question(s).",
// "Impose a time limit of " => "Impose a time limit of ",
// "Allow students to store partial results and return to quiz." => "Allow students to store partial results and return to quiz.",
// "Allow students to retake this quiz " => "Allow students to retake this quiz ",
// "Grading and Feedback" => "Grading and Feedback",
// "Grading method " => "Grading method ",
// "Show students their score " => "Show students their score ",
// "Show students the correct answers " => "Show students the correct answers ",
// "Publish statistics " => "Publish statistics ",
// "Extra Options" => "Extra Options",
// "Solicit additional questions from students" => "Solicit additional questions from students",
// "Link quiz to forum named: " => "Link quiz to forum named: ",
// "Prologue:" => "Prologue:",
// "Epilogue:" => "Epilogue:",
// "Quiz result stats" => "Quiz result stats",
// "Quiz" => "Quiz",
// "Time" => "Time",
// "User answers" => "User answers",
// "Stats for quizzes" => "Stats for quizzes",
// "taken" => "taken",
// "Av score" => "Av score",
// "Av time" => "Av time",
// "Stats for quiz" => "Stats for quiz",
// "Clear Stats" => "Clear Stats",
// "time taken" => "time taken",
// "P/F" => "P/F",
// "Passed" => "Passed",
// "Stats for this quiz Questions " => "Stats for this quiz Questions ",
// "Question:" => "Question:",
// "Average" => "Average",
// "Top 10" => "Top 10",
// "Top 20" => "Top 20",
// "Top 50" => "Top 50",
// "Top 100" => "Top 100",
// "Received Articles" => "Received Articles",
// "received articles tpl" => "received articles tpl",
// "Edit received article" => "Edit received article",
// "Use Image" => "Use Image",
// "Image x size" => "Image x size",
// "Image y size" => "Image y size",
// "Image name" => "Image name",
// "Accept Article" => "Accept Article",
// "Site" => "Site",
// "Received Pages" => "Received Pages",
// "Help on Communication Center" => "Help on Communication Center",
// "received pages tpl" => "received pages tpl",
// "Edit Received Page" => "Edit Received Page",
// "The highlight pages already exist." => "The highlight pages already exist.",
// "Please, change the name if you want the page to be uploaded." => "Please, change the name if you want the page to be uploaded.",
// "Received Structures" => "Received Structures",
// "Prefix the checked:" => "Prefix the checked:",
// "Postfix the checked:" => "Postfix the checked:",
// "Admin Referer Stats" => "Admin Referer Stats",
// "Admin Referer Stats tpl" => "Admin Referer Stats tpl",
// "Use your email as login" => "Use your email as login",
// "Lowercase only" => "Lowercase only",
// "Minimum {\$prefs.min_pass_length} characters long" => "Minimum {\$prefs.min_pass_length} characters long",
// "A valid email is mandatory to register" => "A valid email is mandatory to register",
// "Select your group" => "Select your group",
// "NOTE: Make sure to whitelist this domain to prevent registration emails being canned by your spam filter!" => "NOTE: Make sure to whitelist this domain to prevent registration emails being canned by your spam filter!",
// "Tiki site registered" => "Tiki site registered",
// "The following site was added and validation by admin may be needed before appearing on the lists" => "The following site was added and validation by admin may be needed before appearing on the lists",
// "You don't have permission to use this feature." => "You don't have permission to use this feature.",
// "Please register." => "Please register.",
// "Register this site at tikiwiki.org" => "Register this site at tikiwiki.org",
// "Read this first!" => "Read this first!",
// "On this page you can make your tiki site known to tikiwiki.org. It will get shown there in a list of known tiki sites." => "On this page you can make your tiki site known to tikiwiki.org. It will get shown there in a list of known tiki sites.",
// "Registering is voluntary." => "Registering is voluntary.",
// "Registering does not give you any benefits except one more link to your site." => "Registering does not give you any benefits except one more link to your site.",
// "You don't get any emails, we don't sell the data about your site." => "You don't get any emails, we don't sell the data about your site.",
// "Registering is just for us to get an overview of Tiki's usage." => "Registering is just for us to get an overview of Tiki's usage.",
// "If your site is private or inside your intranet, you should not register!" => "If your site is private or inside your intranet, you should not register!",
// "tikiwiki.org" => "tikiwiki.org",
// "Information about your site" => "Information about your site",
// "Enter your username or email." => "Enter your username or email.",
// "Send me my Password" => "Send me my Password",
// "Request Password Reset" => "Request Password Reset",
// "Return to HomePage" => "Return to HomePage",
// "Remove page" => "Remove page",
// "Last Version" => "Last Version",
// "return to wikipage" => "return to wikipage",
// "You are about to remove the page" => "You are about to remove the page",
// "permanently" => "permanently",
// "Remove all versions of this page" => "Remove all versions of this page",
// "Rename page" => "Rename page",
// "Replicate" => "Replicate",
// "Slave" => "Slave",
// "Master" => "Master",
// "Operations" => "Operations",
// "Operations Log" => "Operations Log",
// "Rollback page" => "Rollback page",
// "to_version" => "to_version",
// "Search Stats" => "Search Stats",
// "search stats tpl" => "search stats tpl",
// "Searched" => "Searched",
// "Search in" => "Search in",
// "Faqs" => "Faqs",
// "Simple search" => "Simple search",
// "No pages matched the search criteria" => "No pages matched the search criteria",
// "Send blog post" => "Send blog post",
// "A link to this post was sent to the following addresses:" => "A link to this post was sent to the following addresses:",
// "Send post to this addresses" => "Send post to this addresses",
// "List of email addresses separated by commas" => "List of email addresses separated by commas",
// "referenced by" => "referenced by",
// "references" => "references",
// "Please Confirm" => "Please Confirm",
// "Apply content template" => "Apply content template",
// "Data HTML" => "Data HTML",
// "Data Txt" => "Data Txt",
// "Save as Draft" => "Save as Draft",
// "Send objects" => "Send objects",
// "Admin Send Objects tpl" => "Admin Send Objects tpl",
// "Transmission results" => "Transmission results",
// "Send Wiki Pages" => "Send Wiki Pages",
// "Send a structure" => "Send a structure",
// "Send Articles" => "Send Articles",
// "Add Article" => "Add Article",
// "Send objects to this site" => "Send objects to this site",
// "Ex: http://tikiwiki.org or localhost" => "Ex: http://tikiwiki.org or localhost",
// "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need",
// "Debug" => "Debug",
// "sheets tpl" => "sheets tpl",
// "Create a sheet" => "Create a sheet",
// "Edit this sheet:" => "Edit this sheet:",
// "Create New Sheet" => "Create New Sheet",
// "There are individual permissions set for this sheet" => "There are individual permissions set for this sheet",
// "Class Name" => "Class Name",
// "Header Rows" => "Header Rows",
// "Footer Rows" => "Footer Rows",
// "Create new Sheet" => "Create new Sheet",
// "You can access the sheet using the following URL" => "You can access the sheet using the following URL",
// "Available Sheets" => "Available Sheets",
// "Tiki Shoutbox" => "Tiki Shoutbox",
// "Admin Tiki Shoutbox" => "Admin Tiki Shoutbox",
// "Admin Tiki Shoutbox tpl" => "Admin Tiki Shoutbox tpl",
// "Change shoutbox general settings" => "Change shoutbox general settings",
// "auto-link urls" => "auto-link urls",
// "Post or edit a message" => "Post or edit a message",
// "Click to Navigate" => "Click to Navigate",
// "This is the staging copy of" => "This is the staging copy of",
// "the approved version of this page." => "the approved version of this page.",
// "Viewing of changes since last approval is possible only after first approval." => "Viewing of changes since last approval is possible only after first approval.",
// "Approve changes." => "Approve changes.",
// "Latest changes will be synchronized after approval." => "Latest changes will be synchronized after approval.",
// "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time." => "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time.",
// "{icon _id=information.png style=\"vertical-align:middle\"} Content may be out of date" => "{icon _id=information.png style=\"vertical-align:middle\"} Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages:" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages:",
// "TOC" => "TOC",
// "big grin" => "big grin",
// "confused" => "confused",
// "cool" => "cool",
// "cry" => "cry",
// "eek" => "eek",
// "evil" => "evil",
// "lol" => "lol",
// "mr green" => "mr green",
// "razz" => "razz",
// "redface" => "redface",
// "rolleyes" => "rolleyes",
// "smile" => "smile",
// "surprised" => "surprised",
// "twisted" => "twisted",
// "arrow" => "arrow",
// "santa" => "santa",
// "Most viewed objects" => "Most viewed objects",
// "Most viewed objects in the last 7 days" => "Most viewed objects in the last 7 days",
// "Site Stats" => "Site Stats",
// "Days online" => "Days online",
// "Total pageviews" => "Total pageviews",
// "Average pageviews per day" => "Average pageviews per day",
// "pvs" => "pvs",
// "Best day" => "Best day",
// "Worst day" => "Worst day",
// "Wiki Stats" => "Wiki Stats",
// "Size of Wiki Pages" => "Size of Wiki Pages",
// "Mb" => "Mb",
// "Average page length" => "Average page length",
// "Average versions per page" => "Average versions per page",
// "Visits to wiki pages" => "Visits to wiki pages",
// "Average links per page" => "Average links per page",
// "Image galleries Stats" => "Image galleries Stats",
// "Average images per gallery" => "Average images per gallery",
// "Total size of images" => "Total size of images",
// "Average image size" => "Average image size",
// "Visits to image galleries" => "Visits to image galleries",
// "File galleries Stats" => "File galleries Stats",
// "Average files per gallery" => "Average files per gallery",
// "Total size of files" => "Total size of files",
// "Average file size" => "Average file size",
// "Visits to file galleries" => "Visits to file galleries",
// "CMS Stats" => "CMS Stats",
// "Total reads" => "Total reads",
// "Average reads per article" => "Average reads per article",
// "Total articles size" => "Total articles size",
// "Average article size" => "Average article size",
// "Forum Stats" => "Forum Stats",
// "Total topics" => "Total topics",
// "Average topics per forums" => "Average topics per forums",
// "Total replies" => "Total replies",
// "Average number of replies per topic" => "Average number of replies per topic",
// "Visits to forums" => "Visits to forums",
// "Blog Stats" => "Blog Stats",
// "Weblogs" => "Weblogs",
// "Total posts" => "Total posts",
// "Average posts per weblog" => "Average posts per weblog",
// "Total size of blog posts" => "Total size of blog posts",
// "Average posts size" => "Average posts size",
// "Visits to weblogs" => "Visits to weblogs",
// "Poll Stats" => "Poll Stats",
// "Total votes" => "Total votes",
// "Average votes per poll" => "Average votes per poll",
// "FAQ Stats" => "FAQ Stats",
// "Total questions" => "Total questions",
// "Average questions per FAQ" => "Average questions per FAQ",
// "User Stats" => "User Stats",
// "User bookmarks" => "User bookmarks",
// "Average bookmarks per user" => "Average bookmarks per user",
// "Average questions per quiz" => "Average questions per quiz",
// "Quizzes taken" => "Quizzes taken",
// "Average quiz score" => "Average quiz score",
// "Average time per quiz" => "Average time per quiz",
// "Usage chart" => "Usage chart",
// "Usage chart image" => "Usage chart image",
// "Daily Usage" => "Daily Usage",
// "Stats for surveys" => "Stats for surveys",
// "Last taken" => "Last taken",
// "Stats for survey" => "Stats for survey",
// "Stats for this survey Questions " => "Stats for this survey Questions ",
// "SysLog" => "SysLog",
// "System log help" => "System log help",
// "system logs" => "system logs",
// "system logs tpl" => "system logs tpl",
// "Clean logs older than" => "Clean logs older than",
// "months" => "months",
// "Clean" => "Clean",
// "Time Left" => "Time Left",
// "Send Answers" => "Send Answers",
// "Thank you for your submission" => "Thank you for your submission",
// "Send a link to a friend" => "Send a link to a friend",
// "Your email was sent" => "Your email was sent",
// "The link was sent to the following addresses:" => "The link was sent to the following addresses:",
// "Friend's email" => "Friend's email",
// "Separate multiple email addresses with a comma." => "Separate multiple email addresses with a comma.",
// "Your name" => "Your name",
// "Your email" => "Your email",
// "I found an interesting page that I thought you would like." => "I found an interesting page that I thought you would like.",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Logout" => "Use Current Session/Logout",
// "Recorded Links" => "Recorded Links",
// "Request:" => "Request:",
// "Element to compare (Xpath expression):" => "Element to compare (Xpath expression):",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "Notice" => "Notice",
// "PECL HTPP extension present" => "PECL HTPP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTPP and cURL extension not present. Replay of the TikiTest will not be possible." => "PECL HTPP and cURL extension not present. Replay of the TikiTest will not be possible.",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "File Name:" => "File Name:",
// "Start Recording Test" => "Start Recording Test",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: categories" => "Theme Control Center: categories",
// "ThemeControl" => "ThemeControl",
// "ThemeControl tpl" => "ThemeControl tpl",
// "To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>." => "To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>.",
// "Theme is selected as follows" => "Theme is selected as follows",
// "If a theme is assigned to the individual object that theme is used." => "If a theme is assigned to the individual object that theme is used.",
// "If not then if a theme is assigned to the object's category that theme is used" => "If not then if a theme is assigned to the object's category that theme is used",
// "If not then a theme for the section is used" => "If not then a theme for the section is used",
// "If none of the above was selected the user theme is used" => "If none of the above was selected the user theme is used",
// "Finally if the user didn't select a theme the default theme is used" => "Finally if the user didn't select a theme the default theme is used",
// "Control by Objects" => "Control by Objects",
// "Control by Sections" => "Control by Sections",
// "Assign themes to categories" => "Assign themes to categories",
// "Assigned categories" => "Assigned categories",
// "theme" => "theme",
// "Theme Control Center: Objects" => "Theme Control Center: Objects",
// "ThemeControl Objects" => "ThemeControl Objects",
// "theme control objects tpl" => "theme control objects tpl",
// "Control by Categories" => "Control by Categories",
// "Assign themes to objects" => "Assign themes to objects",
// "Assigned objects" => "Assigned objects",
// "Theme Control Center: sections" => "Theme Control Center: sections",
// "theme control sections tpl" => "theme control sections tpl",
// "Assign themes to sections" => "Assign themes to sections",
// "Assigned sections" => "Assigned sections",
// "Edit File:" => "Edit File:",
// "The following file was successfully uploaded" => "The following file was successfully uploaded",
// "The following files have been successfully uploaded" => "The following files have been successfully uploaded",
// "Additional Info" => "Additional Info",
// "You can download this file using" => "You can download this file using",
// "You can link to the file from a Wiki page using" => "You can link to the file from a Wiki page using",
// "You can display an image in a Wiki page using" => "You can display an image in a Wiki page using",
// "You can link to the file from an HTML page using" => "You can link to the file from an HTML page using",
// "Upload big files (e.g. PodCast files) here:" => "Upload big files (e.g. PodCast files) here:",
// "You locked the file" => "You locked the file",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
// "File Title" => "File Title",
// "Batch upload" => "Batch upload",
// "Unzip all zip files" => "Unzip all zip files",
// "Maximum amount of downloads" => "Maximum amount of downloads",
// "0 for no limit" => "0 for no limit",
// "Author if not the file creator" => "Author if not the file creator",
// "No gallery available." => "No gallery available.",
// "You have to create a gallery first!" => "You have to create a gallery first!",
// "Image Gallery tpl" => "Image Gallery tpl",
// "Upload successful!" => "Upload successful!",
// "The following image was successfully uploaded" => "The following image was successfully uploaded",
// "Thumbnail" => "Thumbnail",
// "Image ID thumb" => "Image ID thumb",
// "You can include the image in an Wiki page using" => "You can include the image in an Wiki page using",
// "or use filename" => "or use filename",
// "Now enter the image URL" => "Now enter the image URL",
// " or upload a local image from your disk" => " or upload a local image from your disk",
// "Thumbnail (optional, overrides automatic thumbnail generation)" => "Thumbnail (optional, overrides automatic thumbnail generation)",
// "Note: Maximum image size is limited to" => "Note: Maximum image size is limited to",
// "User assigned modules" => "User assigned modules",
// "User Assigned Modules" => "User Assigned Modules",
// "User Assigned Modules tpl" => "User Assigned Modules tpl",
// "Assign module" => "Assign module",
// "Column" => "Column",
// "User Bookmarks tpl" => "User Bookmarks tpl",
// "top" => "top",
// "Current folder" => "Current folder",
// "Folders" => "Folders",
// "Folder in" => "Folder in",
// "Remove Folder" => "Remove Folder",
// "Refresh Cache" => "Refresh Cache",
// "Admin folders and bookmarks" => "Admin folders and bookmarks",
// "a folder" => "a folder",
// "a URL" => "a URL",
// "User Contacts Preferences" => "User Contacts Preferences",
// "Edit User Contacts Preferences" => "Edit User Contacts Preferences",
// "Manage Fields" => "Manage Fields",
// "Default view" => "Default view",
// "Send me a message" => "Send me a message",
// "Gender" => "Gender",
// "Homepage" => "Homepage",
// "Users HomePage" => "Users HomePage",
// "Personal Wiki Page" => "Personal Wiki Page",
// "Create page" => "Create page",
// "This user is your friend" => "This user is your friend",
// "The user requested friendship with you" => "The user requested friendship with you",
// "Accept friendship from this user" => "Accept friendship from this user",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
// "Request friendship from this user" => "Request friendship from this user",
// "Forum comments" => "Forum comments",
// "Toggle options" => "Toggle options",
// "Toggle" => "Toggle",
// "UserPreferences tpl" => "UserPreferences tpl",
// "Personal Information" => "Personal Information",
// "Use Google Map locator" => "Use Google Map locator",
// "Your personal Wiki Page" => "Your personal Wiki Page",
// "Your personal tracker information" => "Your personal tracker information",
// "View extra information" => "View extra information",
// "Is email public? (uses scrambling to prevent spam)" => "Is email public? (uses scrambling to prevent spam)",
// "Unavailable - please set your e-mail below" => "Unavailable - please set your e-mail below",
// "Your preferred language" => "Your preferred language",
// "Can you read more languages?" => "Can you read more languages?",
// "Other languages you can read (select on the left to add to the list on the right)" => "Other languages you can read (select on the left to add to the list on the right)",
// "Select language..." => "Select language...",
// "My level" => "My level",
// "Account Information" => "Account Information",
// "Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Leave \"New password\" and \"Confirm new password\" fields blank to keep current password",
// "Email address" => "Email address",
// "Confirm new password" => "Confirm new password",
// "Current password (required)" => "Current password (required)",
// "Change administrative info" => "Change administrative info",
// "User Tasks tpl" => "User Tasks tpl",
// "New task" => "New task",
// "Task list" => "Task list",
// "Admin mode off" => "Admin mode off",
// "Admin mode on" => "Admin mode on",
// "Task help" => "Task help",
// "Empty Trash" => "Empty Trash",
// "Received task" => "Received task",
// "You received this task, please read and execute it" => "You received this task, please read and execute it",
// "Send task" => "Send task",
// "You send this task to a other user" => "You send this task to a other user",
// "Shared task" => "Shared task",
// "This task is public to a special group" => "This task is public to a special group",
// "Accepted by Task User and Creator" => "Accepted by Task User and Creator",
// "Accepted User and Creator" => "Accepted User and Creator",
// "Task is accepted by user and creator" => "Task is accepted by user and creator",
// "Not Accepted by One User" => "Not Accepted by One User",
// "Not Accepted User" => "Not Accepted User",
// "Task is rejected by one user" => "Task is rejected by one user",
// "Waiting for Me" => "Waiting for Me",
// "Task is not accepted by you, read the task and accept or reject it" => "Task is not accepted by you, read the task and accept or reject it",
// "Waiting for Other User" => "Waiting for Other User",
// "Task is not accepted/rejected by other user" => "Task is not accepted/rejected by other user",
// "Admin Mode" => "Admin Mode",
// "Edit task" => "Edit task",
// "Red" => "Red",
// "NOT accept" => "NOT accept",
// "Remove from Trash" => "Remove from Trash",
// "Move into Trash" => "Move into Trash",
// "Task saved" => "Task saved",
// "Edit Task" => "Edit Task",
// "View Task" => "View Task",
// "Open a new task" => "Open a new task",
// "taskId" => "taskId",
// "Task user" => "Task user",
// "Only the creator can delete this task" => "Only the creator can delete this task",
// "Use start date and time" => "Use start date and time",
// "Use end date and time" => "Use end date and time",
// "Open / In Process" => "Open / In Process",
// "Waiting / Not Started" => "Waiting / Not Started",
// "Percentage completed" => "Percentage completed",
// "Waiting" => "Waiting",
// "Shared for Group" => "Shared for Group",
// "Accepted by User" => "Accepted by User",
// "No / Rejected" => "No / Rejected",
// "Accepted by Creator" => "Accepted by Creator",
// "This message will be send to users if you are makeing changes of assigned tasks" => "This message will be send to users if you are makeing changes of assigned tasks",
// "Send message with changes" => "Send message with changes",
// "Modified by" => "Modified by",
// "Marked as deleted" => "Marked as deleted",
// "Inform task user by email" => "Inform task user by email",
// "You can only view this task" => "You can only view this task",
// "No tasks entered" => "No tasks entered",
// "Select One" => "Select One",
// "Undo Trash" => "Undo Trash",
// "Show:" => "Show:",
// "Received" => "Received",
// "Submitted" => "Submitted",
// "Shared" => "Shared",
// "All Shared Tasks" => "All Shared Tasks",
// "completed (100%)" => "completed (100%)",
// "Public for group" => "Public for group",
// "User Watches tpl" => "User Watches tpl",
// "Use \"watches\" to monitor wiki pages or other objects." => "Use \"watches\" to monitor wiki pages or other objects.",
// "Watch new items by clicking the {icon _id=eye} button on specific pages." => "Watch new items by clicking the {icon _id=eye} button on specific pages.",
// "Add Watch" => "Add Watch",
// "watched events" => "watched events",
// "A user submits a blog post" => "A user submits a blog post",
// "A user posts a forum thread" => "A user posts a forum thread",
// "A user posts a forum topic" => "A user posts a forum topic",
// "A user edited a wiki page" => "A user edited a wiki page",
// "A user created a wiki page in a language" => "A user created a wiki page in a language",
// "Watch language wiki page creations" => "Watch language wiki page creations",
// "Add watch" => "Add watch",
// "Used space:" => "Used space:",
// "up to" => "up to",
// "no limit for admin" => "no limit for admin",
// "May need to refresh twice to see changes" => "May need to refresh twice to see changes",
// "Add top level bookmarks to menu" => "Add top level bookmarks to menu",
// "Pos" => "Pos",
// "Mode" => "Mode",
// "replace window" => "replace window",
// "User_versions_for" => "User_versions_for",
// "Insert Row" => "Insert Row",
// "Insert Column" => "Insert Column",
// "Remove Row" => "Remove Row",
// "Remove Column" => "Remove Column",
// "Merge Cells" => "Merge Cells",
// "Restore Cells" => "Restore Cells",
// "Copy Calculation" => "Copy Calculation",
// "Format Cell" => "Format Cell",
// "Before" => "Before",
// "After" => "After",
// "expires:" => "expires:",
// "No articles." => "No articles.",
// "Banner stats" => "Banner stats",
// "Create new banner" => "Create new banner",
// "Banner Information" => "Banner Information",
// "Click ratio" => "Click ratio",
// "Weekdays" => "Weekdays",
// "mon" => "mon",
// "tue" => "tue",
// "wed" => "wed",
// "thu" => "thu",
// "fri" => "fri",
// "sat" => "sat",
// "sun" => "sun",
// "Banner raw data" => "Banner raw data",
// "This is a cached version of the page." => "This is a cached version of the page.",
// "Click here to view the Google cache of the page instead." => "Click here to view the Google cache of the page instead.",
// "Edit Items" => "Edit Items",
// "List Charts" => "List Charts",
// "Last Chart" => "Last Chart",
// "Previous Chart" => "Previous Chart",
// "Chart created" => "Chart created",
// "Next Chart" => "Next Chart",
// "Pre" => "Pre",
// "Permanency" => "Permanency",
// "chg" => "chg",
// "Avg" => "Avg",
// "info/vote" => "info/vote",
// "Next chart will be generated on" => "Next chart will be generated on",
// "View or vote items not listed in the chart" => "View or vote items not listed in the chart",
// "Select something to vote on" => "Select something to vote on",
// "Item information" => "Item information",
// "Dif" => "Dif",
// "Best Position" => "Best Position",
// "Vote this item" => "Vote this item",
// "Highest" => "Highest",
// "View FAQ Tpl" => "View FAQ Tpl",
// "Admin Menus tpl" => "Admin Menus tpl",
// "There are no questions in this FAQ." => "There are no questions in this FAQ.",
// "Answers" => "Answers",
// "Q" => "Q",
// "A" => "A",
// "Add Suggestion" => "Add Suggestion",
// "1 suggestion" => "1 suggestion",
// "suggestions" => "suggestions",
// "Forum List" => "Forum List",
// "Edit Forum" => "Edit Forum",
// "Manage Message Queue" => "Manage Message Queue",
// "Manage Reported Messages" => "Manage Reported Messages",
// "Monitor Topics of this Forum" => "Monitor Topics of this Forum",
// "Stop Monitoring Topics of this Forum" => "Stop Monitoring Topics of this Forum",
// "Monitor Topics and Threads of this Forum" => "Monitor Topics and Threads of this Forum",
// "Stop Monitoring Topics and Threads of this Forum" => "Stop Monitoring Topics and Threads of this Forum",
// "You have {\$unread} unread private messages" => "You have {\$unread} unread private messages",
// "Your message has been queued for approval, the message will be posted after a moderator approves it." => "Your message has been queued for approval, the message will be posted after a moderator approves it.",
// "You have to enter a title and text" => "You have to enter a title and text",
// "Another post with the same title and content already exists." => "Another post with the same title and content already exists.",
// "Please change your title or content then click Post." => "Please change your title or content then click Post.",
// "Editing" => "Editing",
// "Post New" => "Post New",
// "Summary" => "Summary",
// "Watch for replies" => "Watch for replies",
// "Send me an e-mail when someone replies to my topic" => "Send me an e-mail when someone replies to my topic",
// "Don't send me any e-mails" => "Don't send me any e-mails",
// "Editing posts" => "Editing posts",
// "Moderator Actions" => "Moderator Actions",
// "Move Selected Topics" => "Move Selected Topics",
// "Unlock Selected Topics" => "Unlock Selected Topics",
// "Lock Selected Topics" => "Lock Selected Topics",
// "Delete Selected Topics" => "Delete Selected Topics",
// "Merge" => "Merge",
// "Merge Selected Topics" => "Merge Selected Topics",
// "Reported Messages:" => "Reported Messages:",
// "Queued Messages:" => "Queued Messages:",
// "Merge into topic" => "Merge into topic",
// "Emot" => "Emot",
// "pts" => "pts",
// "Announce" => "Announce",
// "Hot" => "Hot",
// "Sticky" => "Sticky",
// "Unarchive" => "Unarchive",
// "No topics yet" => "No topics yet",
// "posts in this forum" => "posts in this forum",
// "Show posts" => "Show posts",
// "Last hour" => "Last hour",
// "Last 24 hours" => "Last 24 hours",
// "Last 48 hours" => "Last 48 hours",
// "Show archived posts" => "Show archived posts",
// "Jump to forum" => "Jump to forum",
// "Archived" => "Archived",
// " unread private messages" => " unread private messages",
// "The post has been reported and will be reviewed by a moderator." => "The post has been reported and will be reviewed by a moderator.",
// "prev topic" => "prev topic",
// "next topic" => "next topic",
// "Print this page only" => "Print this page only",
// "Print all pages" => "Print all pages",
// "IRC log" => "IRC log",
// "Show All" => "Show All",
// "Tracker:" => "Tracker:",
// "Stop Monitor" => "Stop Monitor",
// "Insert New Item" => "Insert New Item",
// "Edit Fields" => "Edit Fields",
// "Tracker Items for" => "Tracker Items for",
// "Format : x,y,zoom - You can use Google Map Locator in the item view script." => "Format : x,y,zoom - You can use Google Map Locator in the item view script.",
// "View inserted item" => "View inserted item",
// "Tracker Item:" => "Tracker Item:",
// "Edit/Delete" => "Edit/Delete",
// "View Item" => "View Item",
// "Filter Tracker Items" => "Filter Tracker Items",
// "Add a Comment" => "Add a Comment",
// "Items list" => "Items list",
// "Remove Image" => "Remove Image",
// "Google Map Locator" => "Google Map Locator",
// "Special Operations" => "Special Operations",
// "fields marked with a * are mandatory" => "fields marked with a * are mandatory",
// "Edit mail account" => "Edit mail account",
// "Add new mail account" => "Add new mail account",
// "User accounts" => "User accounts",
// "View All" => "View All",
// "Msg" => "Msg",
// "Clip" => "Clip",
// "Back To Mailbox" => "Back To Mailbox",
// "Full Headers" => "Full Headers",
// "Normal Headers" => "Normal Headers",
// "Reply To All" => "Reply To All",
// "Forward" => "Forward",
// "Select from address book" => "Select from address book",
// "Use HTML mail" => "Use HTML mail",
// "The following addresses are not in your address book" => "The following addresses are not in your address book",
// "Add Contacts" => "Add Contacts",
// "Attachment 1" => "Attachment 1",
// "Attachment 2" => "Attachment 2",
// "Attachment 3" => "Attachment 3",
// "Address book" => "Address book",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Word Count:" => "Word Count:",
// "Number of voices" => "Number of voices",
// "You have ever subscribed" => "You have ever subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
// "friends" => "friends",
// "Unsubscribe" => "Unsubscribe",
// "Google Maps is not enabled." => "Google Maps is not enabled.",
// "Use this thread to discuss the page:" => "Use this thread to discuss the page:",
// "Missing or incorrect trackerId parameter for the plugin." => "Missing or incorrect trackerId parameter for the plugin.",
// "Subscribe to a group" => "Subscribe to a group",
// "Show Filters" => "Show Filters",
// "Toggle display" => "Toggle display",
// "Start:" => "Start:",
// "Close:" => "Close:",
// "List authors:" => "List authors:",
// "as Creator &amp; Last Editor" => "as Creator &amp; Last Editor",
// "Business style" => "Business style",
// "Collaborative style" => "Collaborative style",
// "no (disabled)" => "no (disabled)",
// "Save the page as a partial translation." => "Save the page as a partial translation.",
// "Partial Translation" => "Partial Translation",
// "Save the page as a completed translation." => "Save the page as a completed translation.",
// "Complete Translation" => "Complete Translation",
// "Save the page, but do not send notifications and do not count it as new content to be translated." => "Save the page, but do not send notifications and do not count it as new content to be translated.",
// "Minor Edit" => "Minor Edit",
// "Save the page as a draft." => "Save the page as a draft.",
// "Save Draft" => "Save Draft",
// "If you want people to be able to reply to you, you have to check <a href='tiki-user_preferences.php'>Allow messages from other users</a>" => "If you want people to be able to reply to you, you have to check <a href='tiki-user_preferences.php'>Allow messages from other users</a>",
// "Permission denied you cannot view the Tiki calendar" => "Permission denied you cannot view the Tiki calendar",
// "Administration" => "Administration",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "%s enabled" => "%s enabled",
// "%s disabled" => "%s disabled",
// "Enable/disable Tiki features here, but configure them elsewhere" => "Enable/disable Tiki features here, but configure them elsewhere",
// "General preferences and settings" => "General preferences and settings",
// "User registration, login and authentication" => "User registration, login and authentication",
// "Wiki settings" => "Wiki settings",
// "Wiki Attachments" => "Wiki Attachments",
// "Article/CMS settings" => "Article/CMS settings",
// "Poll comments settings" => "Poll comments settings",
// "Configuration options for all blogs on your site" => "Configuration options for all blogs on your site",
// "Forums settings" => "Forums settings",
// "FAQ comments settings" => "FAQ comments settings",
// "Trackers settings" => "Trackers settings",
// "RSS settings" => "RSS settings",
// "Directory settings" => "Directory settings",
// "Maps configuration" => "Maps configuration",
// "Meta Tags settings" => "Meta Tags settings",
// "Search settings" => "Search settings",
// "Score settings" => "Score settings",
// "Community settings" => "Community settings",
// "Calendar settings" => "Calendar settings",
// "Intertiki settings" => "Intertiki settings",
// "Freetags settings" => "Freetags settings",
// "Configure Site Ads and Banners" => "Configure Site Ads and Banners",
// "Help on \$admintitle Config" => "Help on \$admintitle Config",
// "Current version is up to date : <b>%s</b>" => "Current version is up to date : <b>%s</b>",
// "A new %s  major release branch is available." => "A new %s  major release branch is available.",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Click here to delete the category:" => "Click here to delete the category:",
// "You can not create a category with a name already existing at this level" => "You can not create a category with a name already existing at this level",
// "The file does not have the required header:" => "The file does not have the required header:",
// "Category can`t be parent of itself" => "Category can`t be parent of itself",
// "No chart indicated" => "No chart indicated",
// "Upload failed" => "Upload failed",
// "You have to provide a hotword and a URL" => "You have to provide a hotword and a URL",
// "moved %d images, %d errors occured." => "moved %d images, %d errors occured.",
// "a timeout occured. Hit the reload button to move the rest" => "a timeout occured. Hit the reload button to move the rest",
// "Detected, Version:" => "Detected, Version:",
// "Not detected." => "Not detected.",
// "You cannot have a blank password" => "You cannot have a blank password",
// "Your admin password has been changed" => "Your admin password has been changed",
// "All Fields except gdaltindex must be filled" => "All Fields except gdaltindex must be filled",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "No valid gdaltindex executable" => "No valid gdaltindex executable",
// "You cannot mix old and new trackers" => "You cannot mix old and new trackers",
// "Tag already exists" => "Tag already exists",
// "Tag not found" => "Tag not found",
// "Repository name can't be an empty" => "Repository name can't be an empty",
// "Requested action is not supported on repository" => "Requested action is not supported on repository",
// "No repository" => "No repository",
// "Search is mandatory field" => "Search is mandatory field",
// "File not found " => "File not found ",
// "Requested action in not supported on repository" => "Requested action in not supported on repository",
// "Non-existent link" => "Non-existent link",
// "Mail-in account %s incorrect" => "Mail-in account %s incorrect",
// "Mail-in account %s saved" => "Mail-in account %s saved",
// "Frequency should be a positive integer!" => "Frequency should be a positive integer!",
// "Mail-in accounts set to be checked every %s minutes" => "Mail-in accounts set to be checked every %s minutes",
// "Automatic Mail-in accounts checking disabled" => "Automatic Mail-in accounts checking disabled",
// "No menu indicated" => "No menu indicated",
// "Cannot create or update module: You need to specify a name to the module" => "Cannot create or update module: You need to specify a name to the module",
// "Cannot create or update module: You cannot leave the data field empty" => "Cannot create or update module: You cannot leave the data field empty",
// "No newsletter indicated" => "No newsletter indicated",
// "Error opening uploaded file" => "Error opening uploaded file",
// "Invalid email" => "Invalid email",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "No poll indicated" => "No poll indicated",
// "Insert" => "Insert",
// "Icon" => "Icon",
// "unsafe" => "unsafe",
// "register_globals should be off by default. See the php manual for details." => "register_globals should be off by default. See the php manual for details.",
// "safe" => "safe",
// "session.use_trans_sid should be off by default. See the php manual for details." => "session.use_trans_sid should be off by default. See the php manual for details.",
// "upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser",
// "cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config." => "cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config.",
// "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them",
// "risky" => "risky",
// "allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off." => "allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off.",
// "The Path to store files in the filegallery should be outside the tiki root directory" => "The Path to store files in the filegallery should be outside the tiki root directory",
// "The Path to store files in the imagegallery should be outside the tiki root directory" => "The Path to store files in the imagegallery should be outside the tiki root directory",
// "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code.",
// "installed" => "installed",
// "The \"Snarf Wikiplugin\" is installed. It can be used by wiki editors to include pages from the local network and via regex replacement create any html." => "The \"Snarf Wikiplugin\" is installed. It can be used by wiki editors to include pages from the local network and via regex replacement create any html.",
// "The \"Regex Wikiplugin\" is installed. It can be used by wiki editors to create any html via regex replacement." => "The \"Regex Wikiplugin\" is installed. It can be used by wiki editors to create any html via regex replacement.",
// "The \"Lsdir Wikiplugin\" is installed. It can be used by wiki editors to view the contents of any directory." => "The \"Lsdir Wikiplugin\" is installed. It can be used by wiki editors to view the contents of any directory.",
// "The \"Bloglist Wikiplugin\" is installed. It can be used by wiki editors to disclose private blog posts." => "The \"Bloglist Wikiplugin\" is installed. It can be used by wiki editors to disclose private blog posts.",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
// "SQL injection" => "SQL injection",
// "SQL injection by authenticated user" => "SQL injection by authenticated user",
// "SQL injection by authenticated user with special privileges" => "SQL injection by authenticated user with special privileges",
// "SQL injection without authentication" => "SQL injection without authentication",
// "PHP command injection" => "PHP command injection",
// "PHP command injection by authenticated user" => "PHP command injection by authenticated user",
// "PHP command injection by authenticated user with special privileges" => "PHP command injection by authenticated user with special privileges",
// "PHP command injection without authentication" => "PHP command injection without authentication",
// "File upload" => "File upload",
// "File is not readable. Unable to check." => "File is not readable. Unable to check.",
// "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous." => "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous.",
// "This is a modified File. Cannot check version. Check if it is dangerous." => "This is a modified File. Cannot check version. Check if it is dangerous.",
// "This file is from another Tikiwiki version: " => "This file is from another Tikiwiki version: ",
// "You have to provide a word" => "You have to provide a word",
// "Permission denied you cannot view this page" => "Permission denied you cannot view this page",
// "Permission denied you cannot edit this page" => "Permission denied you cannot edit this page",
// "You must specify a page name, it will be created if it doesn't exist." => "You must specify a page name, it will be created if it doesn't exist.",
// "page not added (Exists)" => "page not added (Exists)",
// "No survey indicated" => "No survey indicated",
// "You don't have permission to use this feature" => "You don't have permission to use this feature",
// "No Errors detected" => "No Errors detected",
// "No tracker indicated" => "No tracker indicated",
// "Remove group: " => "Remove group: ",
// "Remove permission: %s on %s" => "Remove permission: %s on %s",
// "Group already exists" => "Group already exists",
// "User doesn't exist" => "User doesn't exist",
// "No records were found. Check the file please!" => "No records were found. Check the file please!",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
// "User login is required" => "User login is required",
// "Password is required" => "Password is required",
// "Email is required" => "Email is required",
// "User is duplicated" => "User is duplicated",
// "Created account %s <%s>" => "Created account %s <%s>",
// "Assigned %s in group %s" => "Assigned %s in group %s",
// "User %s already exists" => "User %s already exists",
// "User login contains invalid characters" => "User login contains invalid characters",
// "New %s created with %s %s." => "New %s created with %s %s.",
// "Impossible to create new %s with %s %s." => "Impossible to create new %s with %s %s.",
// "%s %s successfully deleted." => "%s %s successfully deleted.",
// "Deleted account %s" => "Deleted account %s",
// "%s %s removed from %s %s." => "%s %s removed from %s %s.",
// "%s <b>%s</b> successfully deleted." => "%s <b>%s</b> successfully deleted.",
// "%s <b>%s</b> assigned to %s <b>%s</b>." => "%s <b>%s</b> assigned to %s <b>%s</b>.",
// "%s <b>%s</b> removed from %s <b>%s</b>." => "%s <b>%s</b> removed from %s <b>%s</b>.",
// "group <b>%s</b> set as the default group of user <b>%s</b>." => "group <b>%s</b> set as the default group of user <b>%s</b>.",
// "%s modified successfully." => "%s modified successfully.",
// "password" => "password",
// "%s modification failed." => "%s modification failed.",
// "%s changed from %s to %s" => "%s changed from %s to %s",
// "Impossible to change %s from %s to %s" => "Impossible to change %s from %s to %s",
// "Login contains invalid characters" => "Login contains invalid characters",
// "Image annotations changed." => "Image annotations changed.",
// "approved by " => "approved by ",
// "This function is only for staging pages" => "This function is only for staging pages",
// "Permission denied you cannot approve staging pages" => "Permission denied you cannot approve staging pages",
// "Approved page was last saved after most recent staging edit" => "Approved page was last saved after most recent staging edit",
// "rss feed disabled" => "rss feed disabled",
// "Permission denied you cannot view this section" => "Permission denied you cannot view this section",
// "Tiki RSS feed for articles" => "Tiki RSS feed for articles",
// "Last articles." => "Last articles.",
// "Unassign perm %s from group %s" => "Unassign perm %s from group %s",
// "Unknown group" => "Unknown group",
// "Group doesn't exist" => "Group doesn't exist",
// "You have to indicate a group" => "You have to indicate a group",
// "This group is invalid" => "This group is invalid",
// "Permission denied you cannot view backlinks for this page" => "Permission denied you cannot view backlinks for this page",
// "The page cannot be found" => "The page cannot be found",
// "Image Galleries Admin Panel" => "Image Galleries Admin Panel",
// "Could not read image %s." => "Could not read image %s.",
// "Image %s upload failed." => "Image %s upload failed.",
// "Image %s uploaded successfully." => "Image %s uploaded successfully.",
// "Image %s removed from Batch directory." => "Image %s removed from Batch directory.",
// "Impossible to remove image %s from Batch directory." => "Impossible to remove image %s from Batch directory.",
// "Permission denied you cannot use the batch directory loading" => "Permission denied you cannot use the batch directory loading",
// "Incorrect directory chosen for batch upload of images." => "Incorrect directory chosen for batch upload of images.",
// "Please setup that dir on " => "Please setup that dir on ",
// "Please contact the website administrator." => "Please contact the website administrator.",
// "Invalid directory name" => "Invalid directory name",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "Could not read file %s." => "Could not read file %s.",
// "Could not write to file %s." => "Could not write to file %s.",
// "File %s upload failed." => "File %s upload failed.",
// "Upload was successful" => "Upload was successful",
// "File %s removed from Batch directory." => "File %s removed from Batch directory.",
// "Impossible to remove file %s from Batch directory." => "Impossible to remove file %s from Batch directory.",
// "Incorrect directory chosen for batch upload of files." => "Incorrect directory chosen for batch upload of files.",
// "Permission denied you cannot post" => "Permission denied you cannot post",
// "Permission denied you cannot edit this post" => "Permission denied you cannot edit this post",
// "You can't post in any blog maybe you have to create a blog first" => "You can't post in any blog maybe you have to create a blog first",
// "Top visited blogs" => "Top visited blogs",
// "Last posts" => "Last posts",
// "Top active blogs" => "Top active blogs",
// "Tiki RSS feed for blog: " => "Tiki RSS feed for blog: ",
// "Last modifications to the blog." => "Last modifications to the blog.",
// "No blogId specified" => "No blogId specified",
// "Tiki RSS feed for weblogs" => "Tiki RSS feed for weblogs",
// "Last posts to weblogs." => "Last posts to weblogs.",
// "TOP" => "TOP",
// "Nothing tagged yet" => "Nothing tagged yet",
// "You must clear your browser cache." => "You must clear your browser cache.",
// "Permission denied you cannot access this gallery" => "Permission denied you cannot access this gallery",
// "No gallery indicated" => "No gallery indicated",
// "Permission denied you can not view this section" => "Permission denied you can not view this section",
// "Permission denied you cannot remove images from this gallery" => "Permission denied you cannot remove images from this gallery",
// "Permission denied you cannot rebuild thumbnails in this gallery" => "Permission denied you cannot rebuild thumbnails in this gallery",
// "Permission denied you cannot rotate images in this gallery" => "Permission denied you cannot rotate images in this gallery",
// "No image indicated" => "No image indicated",
// "Permission denied you cannot move images from this gallery" => "Permission denied you cannot move images from this gallery",
// "Permission denied you cannot view the calendar" => "Permission denied you cannot view the calendar",
// "event without name" => "event without name",
// "Permission denied you can not view this page" => "Permission denied you can not view this page",
// "Access Denied" => "Access Denied",
// "First day of week: Sunday (its ID is 0) - translators you need to localize this string!" => "First day of week: Sunday (its ID is 0) - translators you need to localize this string!",
// "%H:%M %Z" => "%H:%M %Z",
// "Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
// "Upcoming events." => "Upcoming events.",
// "End:" => "End:",
// "No category indicated" => "No category indicated",
// "Permission denied; you cannot assign permissions for this category" => "Permission denied; you cannot assign permissions for this category",
// "Invalid username or activation code. Maybe this code has already been used." => "Invalid username or activation code. Maybe this code has already been used.",
// "You can not use the same password again" => "You can not use the same password again",
// "Invalid old password or unknown user" => "Invalid old password or unknown user",
// "Top authors" => "Top authors",
// "Problem. Try to log in again to receive new confirmation instructions." => "Problem. Try to log in again to receive new confirmation instructions.",
// "ERROR: you must include a subject or a message at least" => "ERROR: you must include a subject or a message at least",
// "You need to change chmod 'whelp' manually to 777" => "You need to change chmod 'whelp' manually to 777",
// "This feature has been disabled" => "This feature has been disabled",
// "Tiki RSS feed for directory sites" => "Tiki RSS feed for directory sites",
// "Last sites." => "Last sites.",
// "You have mistyped the anti-bot verification code; please try again. " => "You have mistyped the anti-bot verification code; please try again. ",
// "Must enter a name to add a site. " => "Must enter a name to add a site. ",
// "Must enter a url to add a site. " => "Must enter a url to add a site. ",
// "URL already added to the directory. Duplicate site? " => "URL already added to the directory. Duplicate site? ",
// "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. ",
// "Must select a category. " => "Must select a category. ",
// "Must enter a name to add a site" => "Must enter a name to add a site",
// "Must enter a url to add a site" => "Must enter a url to add a site",
// "URL already added to the directory. Duplicate site?" => "URL already added to the directory. Duplicate site?",
// "URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory",
// "Must select a category" => "Must select a category",
// "No site indicated" => "No site indicated",
// "No parent specified" => "No parent specified",
// "Last sites of directory \".\$rc[\"name\"].\" ." => "Last sites of directory \".\$rc[\"name\"].\" .",
// "You can not download files" => "You can not download files",
// "You cannot download this file right now. Your score is low or file limit was reached." => "You cannot download this file right now. Your score is low or file limit was reached.",
// "Error : The file %s doesn't exist." => "Error : The file %s doesn't exist.",
// "Invalid email:" => "Invalid email:",
// "Article not found" => "Article not found",
// "Permission denied you cannot edit this article" => "Permission denied you cannot edit this article",
// "The language can't be changed as its set of translations has already this language" => "The language can't be changed as its set of translations has already this language",
// "You do not have permissions to edit banners" => "You do not have permissions to edit banners",
// "Banner not found" => "Banner not found",
// "You do not have permission to edit this banner" => "You do not have permission to edit this banner",
// "Permission denied you cannot create or edit blogs" => "Permission denied you cannot create or edit blogs",
// "Permission denied you cannot edit this blog" => "Permission denied you cannot edit this blog",
// "You do not have permission to write the style sheet" => "You do not have permission to write the style sheet",
// "Invalid request to edit an image" => "Invalid request to edit an image",
// "Permission denied you cannot edit images" => "Permission denied you cannot edit images",
// "Permission denied you can edit images but not in this gallery" => "Permission denied you can edit images but not in this gallery",
// "Failed to edit the image" => "Failed to edit the image",
// "Permission denied to use this feature" => "Permission denied to use this feature",
// "Shortname must be 2 Characters" => "Shortname must be 2 Characters",
// "You must provide a longname" => "You must provide a longname",
// "Language created" => "Language created",
// "No content id indicated" => "No content id indicated",
// "No question indicated" => "No question indicated",
// "No quiz indicated" => "No quiz indicated",
// "No structure indicated" => "No structure indicated",
// "Invalid structure_id or page_ref_id" => "Invalid structure_id or page_ref_id",
// "Permission denied you cannot send submissions" => "Permission denied you cannot send submissions",
// "Permission denied you cannot edit submissions" => "Permission denied you cannot edit submissions",
// "You have to create a topic first" => "You have to create a topic first",
// "You do not have permission to do that" => "You do not have permission to do that",
// "You do not have permission to write the template:" => "You do not have permission to write the template:",
// "You do not have permission to read the template" => "You do not have permission to read the template",
// "No topic id specified" => "No topic id specified",
// "Invalid topic id specified" => "Invalid topic id specified",
// "Translation in progress." => "Translation in progress.",
// "No object indicated" => "No object indicated",
// "Page is a staging copy. Translation must begin from the approved copy." => "Page is a staging copy. Translation must begin from the approved copy.",
// "No type indicated" => "No type indicated",
// "Not enable for this type of object" => "Not enable for this type of object",
// "Override lock and carry on with edit" => "Override lock and carry on with edit",
// "Page is currently being edited" => "Page is currently being edited",
// "page imported" => "page imported",
// "created from import" => "created from import",
// "This page is being edited by " => "This page is being edited by ",
// "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. " => "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. ",
// "Can't import remote HTML page" => "Can't import remote HTML page",
// "Can't parse remote HTML page" => "Can't parse remote HTML page",
// "The SandBox is disabled" => "The SandBox is disabled",
// "Cannot edit page because it is locked" => "Cannot edit page because it is locked",
// "Page already exists. Go back and choose a different name." => "Page already exists. Go back and choose a different name.",
// "The translation set already contains a page in this language." => "The translation set already contains a page in this language.",
// "No questions group indicated" => "No questions group indicated",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
// "Permission denied you cannot edit this file" => "Permission denied you cannot edit this file",
// "Permission denied you cannot remove files from this gallery" => "Permission denied you cannot remove files from this gallery",
// "Top visited file galleries" => "Top visited file galleries",
// "Most downloaded files" => "Most downloaded files",
// "Last files" => "Last files",
// "Tiki RSS feed for file galleries" => "Tiki RSS feed for file galleries",
// "Last files uploaded to the file galleries." => "Last files uploaded to the file galleries.",
// "No galleryId specified" => "No galleryId specified",
// "Tiki RSS feed for the file gallery: " => "Tiki RSS feed for the file gallery: ",
// "Form error - no import method selected for some reason." => "Form error - no import method selected for some reason.",
// "Form error - no server-side filename entered for selected import method." => "Form error - no server-side filename entered for selected import method.",
// "No forum indicated" => "No forum indicated",
// "Last replied forum topics" => "Last replied forum topics",
// "Forum posts" => "Forum posts",
// "No forumId specified" => "No forumId specified",
// "Tiki RSS feed for forum: " => "Tiki RSS feed for forum: ",
// "Tiki RSS feed for forums" => "Tiki RSS feed for forums",
// "Last topics in forums." => "Last topics in forums.",
// "Not supported yet." => "Not supported yet.",
// "Accepted friendship request from %s" => "Accepted friendship request from %s",
// "Refused friendship request from %s" => "Refused friendship request from %s",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "Broke friendship with %s" => "Broke friendship with %s",
// "I have broken our friendship!" => "I have broken our friendship!",
// "You must be logged in to use this feature" => "You must be logged in to use this feature",
// "Friendship request sent to %s" => "Friendship request sent to %s",
// "You're already friend of %s" => "You're already friend of %s",
// "I have accepted your friendship request!" => "I have accepted your friendship request!",
// "I have refused your friendship request." => "I have refused your friendship request.",
// "I have canceled my friendship request." => "I have canceled my friendship request.",
// "No process indicated" => "No process indicated",
// "Role name cannot be empty" => "Role name cannot be empty",
// "Activity name cannot be empty" => "Activity name cannot be empty",
// "Activity name already exists" => "Activity name already exists",
// "indicates if the process is active. Invalid processes cant be active" => "indicates if the process is active. Invalid processes cant be active",
// "No instance indicated" => "No instance indicated",
// "No activity indicated" => "No activity indicated",
// "The process name already exists" => "The process name already exists",
// "Process already exists" => "Process already exists",
// "Invalid source path" => "Invalid source path",
// "A start activity requires a name for the instance" => "A start activity requires a name for the instance",
// "You cant execute this activity" => "You cant execute this activity",
// "You couldn't abort a instance" => "You couldn't abort a instance",
// "You couldn't exception a instance" => "You couldn't exception a instance",
// "No user indicated" => "No user indicated",
// "No title indicated" => "No title indicated",
// "No comment indicated" => "No comment indicated",
// "No date indicated" => "No date indicated",
// "No item indicated" => "No item indicated",
// "first uploaded image" => "first uploaded image",
// "last uploaded image" => "last uploaded image",
// "first image" => "first image",
// "last image" => "last image",
// "random image" => "random image",
// "Permission denied you cannot create galleries and so you cant edit them" => "Permission denied you cannot create galleries and so you cant edit them",
// "Permission denied you cannot edit this gallery" => "Permission denied you cannot edit this gallery",
// "Permission denied you cannot remove this gallery" => "Permission denied you cannot remove this gallery",
// "Permission denied you cannot make the map of this gallery" => "Permission denied you cannot make the map of this gallery",
// "Top images" => "Top images",
// "Last images" => "Last images",
// "Back to preferences" => "Back to preferences",
// "Back to item" => "Back to item",
// "No valid renderer found. GD or PDFLib required." => "No valid renderer found. GD or PDFLib required.",
// "No sheet specified." => "No sheet specified.",
// "You must select a renderer." => "You must select a renderer.",
// "Invalid Series for current graphic." => "Invalid Series for current graphic.",
// "Tiki RSS feed for image galleries" => "Tiki RSS feed for image galleries",
// "Last images uploaded to the image galleries." => "Last images uploaded to the image galleries.",
// "Tiki RSS feed for the image gallery: " => "Tiki RSS feed for the image gallery: ",
// "Only the administrator can upload language files." => "Only the administrator can upload language files.",
// "overwriting old page" => "overwriting old page",
// "updated from structured text import" => "updated from structured text import",
// "page created" => "page created",
// "created from structured text import" => "created from structured text import",
// "No name indicated for wiki page" => "No name indicated for wiki page",
// "%s - Version %d of this page has been saved by %s." => "%s - Version %d of this page has been saved by %s.",
// "No repository given" => "No repository given",
// "Error writing in the databse: \$query" => "Error writing in the databse: \$query",
// "Permission denied you cannot view pages like this page" => "Permission denied you cannot view pages like this page",
// "Permission denied you cannot remove articles" => "Permission denied you cannot remove articles",
// "Permission denied you cannot remove banners" => "Permission denied you cannot remove banners",
// "Permission denied you cannot remove this blog" => "Permission denied you cannot remove this blog",
// "Non-existent gallery" => "Non-existent gallery",
// "The file is already locked by %s" => "The file is already locked by %s",
// "Remove file: " => "Remove file: ",
// "Permission denied you can upload files but not to this file gallery" => "Permission denied you can upload files but not to this file gallery",
// "Warning: Empty file:" => "Warning: Empty file:",
// "Please re-upload your file" => "Please re-upload your file",
// "Could not upload the file" => "Could not upload the file",
// "Invalid filename (using filters for filenames)" => "Invalid filename (using filters for filenames)",
// "Could not find the file requested" => "Could not find the file requested",
// "Permission denied you can edit this file" => "Permission denied you can edit this file",
// "Cannot read file:" => "Cannot read file:",
// "Cannot read the file:" => "Cannot read the file:",
// "Upload was not successful. Duplicate file content" => "Upload was not successful. Duplicate file content",
// "File update was successful" => "File update was successful",
// "Permission denied you can't upload files so you can't edit them" => "Permission denied you can't upload files so you can't edit them",
// "This gallery does not exist" => "This gallery does not exist",
// "The game file must have .swf or .dcr extension" => "The game file must have .swf or .dcr extension",
// "The thumbnail name must be" => "The thumbnail name must be",
// "Please supply both files" => "Please supply both files",
// "You cannot admin blogs" => "You cannot admin blogs",
// "Permission denied you cannot remove submissions" => "Permission denied you cannot remove submissions",
// "Permission denied you cannot approve submissions" => "Permission denied you cannot approve submissions",
// "Permission denied you cannot remove pages" => "Permission denied you cannot remove pages",
// "Delete those pages:" => "Delete those pages:",
// "You have to enable cookies to be able to login to this site" => "You have to enable cookies to be able to login to this site",
// "Unable to contact remote server." => "Unable to contact remote server.",
// "XMLRPC Error: " => "XMLRPC Error: ",
// "Unable to create login" => "Unable to create login",
// "More than %d unsuccessful login attempts have been made." => "More than %d unsuccessful login attempts have been made.",
// "An email has been sent to you with the instructions to follow." => "An email has been sent to you with the instructions to follow.",
// "Invalid password" => "Invalid password",
// "Account disabled" => "Account disabled",
// "You must use the right case for your user name" => "You must use the right case for your user name",
// "You are not yet validated" => "You are not yet validated",
// "Your default nickname is already in use. A new one has to be selected." => "Your default nickname is already in use. A new one has to be selected.",
// "The selected account is not associated with your identity." => "The selected account is not associated with your identity.",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "Account validated successfully." => "Account validated successfully.",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
// "Sorry, you can't use this feature." => "Sorry, you can't use this feature.",
// "Feature Ajax Disabled. Please ask your site administrator to enable" => "Feature Ajax Disabled. Please ask your site administrator to enable",
// "You must first setup MapServer" => "You must first setup MapServer",
// "invalid mapfile name" => "invalid mapfile name",
// "An error as occured with the mapfile: " => "An error as occured with the mapfile: ",
// "Please create a directory named '.\$prefs['map_path'].' to hold your map files." => "Please create a directory named '.\$prefs['map_path'].' to hold your map files.",
// "You do not have permissions to view the maps" => "You do not have permissions to view the maps",
// "Maps feature is not correctly setup : Maps path is missing." => "Maps feature is not correctly setup : Maps path is missing.",
// "mapfile name incorrect" => "mapfile name incorrect",
// "This mapfile already exists" => "This mapfile already exists",
// "You do not have permission to write to the mapfile" => "You do not have permission to write to the mapfile",
// "You do not have permission to delete the mapfile" => "You do not have permission to delete the mapfile",
// "I could not make a copy" => "I could not make a copy",
// "You do not have permission to read the mapfile" => "You do not have permission to read the mapfile",
// "map edit" => "map edit",
// "You dont have permission to do that" => "You dont have permission to do that",
// "Tiki RSS feed for maps" => "Tiki RSS feed for maps",
// "List of maps available." => "List of maps available.",
// "You do not have permissions to view the layers" => "You do not have permissions to view the layers",
// "You do not have permissions to delete a file" => "You do not have permissions to delete a file",
// "File not found" => "File not found",
// "You do not have permissions to create a directory" => "You do not have permissions to create a directory",
// "The Directory is not empty" => "The Directory is not empty",
// "You do not have permissions to delete a directory" => "You do not have permissions to delete a directory",
// "You do not have permissions to create an index file" => "You do not have permissions to create an index file",
// "Invalid file name" => "Invalid file name",
// "Invalid files to index" => "Invalid files to index",
// "I do not know where is gdaltindex. Set correctly the Map feature" => "I do not know where is gdaltindex. Set correctly the Map feature",
// "I could not create the index file" => "I could not create the index file",
// "Must be logged to use this feature" => "Must be logged to use this feature",
// "Welcome at Hawiki" => "Welcome at Hawiki",
// "This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more." => "This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more.",
// "You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site:" => "You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site:",
// "tiki-mobile.php" => "tiki-mobile.php",
// "About" => "About",
// "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody",
// "Your PHP installation does not have zlib enabled." => "Your PHP installation does not have zlib enabled.",
// "You must log in to use this feature" => "You must log in to use this feature",
// "You do not have permission to view other users data" => "You do not have permission to view other users data",
// "You must be logged in to subscribe to newsletters" => "You must be logged in to subscribe to newsletters",
// "No server indicated" => "No server indicated",
// "Cannot connect to" => "Cannot connect to",
// "Missing information to read news (server,port,username,password,group) required" => "Missing information to read news (server,port,username,password,group) required",
// "Cannot get messages" => "Cannot get messages",
// "No note indicated" => "No note indicated",
// "merged note:" => "merged note:",
// "File is too big" => "File is too big",
// "created from notepad" => "created from notepad",
// "Page already exists" => "Page already exists",
// "Not enough information to display this page" => "Not enough information to display this page",
// "Permission denied you cannot assign permissions for this object" => "Permission denied you cannot assign permissions for this object",
// "Permission denied you cannot browse this page history" => "Permission denied you cannot browse this page history",
// "Permission denied you cannot view the source of this page" => "Permission denied you cannot view the source of this page",
// "No article indicated" => "No article indicated",
// "Article is not published yet" => "Article is not published yet",
// "No post indicated" => "No post indicated",
// "Blog not found" => "Blog not found",
// "No pages indicated" => "No pages indicated",
// "Pageviews" => "Pageviews",
// "You don't have permission to edit quizzes." => "You don't have permission to edit quizzes.",
// "No result indicated" => "No result indicated",
// "Registered" => "Registered",
// "You must choose a group" => "You must choose a group",
// "The passwords don't match" => "The passwords don't match",
// "Username cannot contain uppercase letters" => "Username cannot contain uppercase letters",
// "Username must be at least" => "Username must be at least",
// "Username cannot contain more than" => "Username cannot contain more than",
// "characters" => "characters",
// "Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Please enter a valid %s.  No spaces, more than %d characters and contain %s",
// "This is not a valid mail adress" => "This is not a valid mail adress",
// "mail adress" => "mail adress",
// "empty" => "empty",
// "Invalid or unknown username" => "Invalid or unknown username",
// "Unable to send mail. User has not configured email" => "Unable to send mail. User has not configured email",
// "Invalid or unknown email" => "Invalid or unknown email",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password." => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password.",
// "The mail can't be sent. Contact the administrator" => "The mail can't be sent. Contact the administrator",
// "A password and your IP address reminder email has been sent " => "A password and your IP address reminder email has been sent ",
// "An email with a link to reset your password has been sent " => "An email with a link to reset your password has been sent ",
// "to the email " => "to the email ",
// "to the registered email address for" => "to the registered email address for",
// "last version" => "last version",
// "Permission denied you cannot remove versions from this page" => "Permission denied you cannot remove versions from this page",
// "You cannot rename staging pages. Please rename the approved page instead." => "You cannot rename staging pages. Please rename the approved page instead.",
// "Permission denied you cannot rename this page" => "Permission denied you cannot rename this page",
// "Cannot rename page because the new name begins with reserved prefix" => "Cannot rename page because the new name begins with reserved prefix",
// "Cannot rename page maybe new page already exists" => "Cannot rename page maybe new page already exists",
// "Cannot rename page because maybe new staging page name already exists" => "Cannot rename page because maybe new staging page name already exists",
// "changed '%s' from '%s' to '%s'" => "changed '%s' from '%s' to '%s'",
// "Non-existent version" => "Non-existent version",
// "Permission denied you cannot rollback this page" => "Permission denied you cannot rollback this page",
// "Error Message" => "Error Message",
// "Tiki RSS Feed Error Message: \$errmsg" => "Tiki RSS Feed Error Message: \$errmsg",
// "Post recommendation at" => "Post recommendation at",
// "No newsletters available." => "No newsletters available.",
// " successfully sent" => " successfully sent",
// " not sent" => " not sent",
// "Error: " => "Error: ",
// "Notice: this variable may not be empty:" => "Notice: this variable may not be empty:",
// "Notice: invalid variable value:" => "Notice: invalid variable value:",
// "Permission denied you cannot remove this sheet" => "Permission denied you cannot remove this sheet",
// "You do not have permission to edit messages \$owner" => "You do not have permission to edit messages \$owner",
// "Page must be defined inside a structure to use this feature" => "Page must be defined inside a structure to use this feature",
// "You cannot take this quiz twice" => "You cannot take this quiz twice",
// "Quiz time limit exceeded quiz cannot be computed" => "Quiz time limit exceeded quiz cannot be computed",
// "You cannot take this survey twice" => "You cannot take this survey twice",
// "Report to the webmaster" => "Report to the webmaster",
// "Please create a category first" => "Please create a category first",
// "Tracker item:" => "Tracker item:",
// "No trackerId specified" => "No trackerId specified",
// "Tiki RSS feed for individual trackers: " => "Tiki RSS feed for individual trackers: ",
// "You must lock the file before editing it" => "You must lock the file before editing it",
// "No permission to upload zipped file packages" => "No permission to upload zipped file packages",
// "Error processing zipped image package" => "Error processing zipped image package",
// "No permission to upload zipped image packages" => "No permission to upload zipped image packages",
// "The uploaded file ist not recognized as a image" => "The uploaded file ist not recognized as a image",
// "Permission denied you cannot upload images" => "Permission denied you cannot upload images",
// "Permission denied you can upload images but not to this gallery" => "Permission denied you can upload images but not to this gallery",
// "Cannot get image from URL" => "Cannot get image from URL",
// "That is not an image (or you have php < 4.0.5)" => "That is not an image (or you have php < 4.0.5)",
// "Usage" => "Usage",
// "No url indicated" => "No url indicated",
// "Unknown user" => "Unknown user",
// "You are not logged in and no user indicated" => "You are not logged in and no user indicated",
// "The user has chosen to make his information private" => "The user has chosen to make his information private",
// "Password has been changed" => "Password has been changed",
// "Invalid password.  Your current password is required to change administrative information" => "Invalid password.  Your current password is required to change administrative information",
// "Email is set to %s" => "Email is set to %s",
// "The passwords did not match" => "The passwords did not match",
// "no" => "no",
// "unicode" => "unicode",
// "was moved into trash" => "was moved into trash",
// "trashed by" => "trashed by",
// "open / in process" => "open / in process",
// "Rights by creator" => "Rights by creator",
// "END" => "END",
// "Percentage" => "Percentage",
// "Task accepted by creator" => "Task accepted by creator",
// "Task accepted by task user" => "Task accepted by task user",
// "Task NOT accepted by creator" => "Task NOT accepted by creator",
// "Task NOT accepted by task user" => "Task NOT accepted by task user",
// "Sorry this task does not exist or you have no rights to view this task" => "Sorry this task does not exist or you have no rights to view this task",
// "Task entries:" => "Task entries:",
// "Changes:" => "Changes:",
// "Info message" => "Info message",
// "NEW Task" => "NEW Task",
// "Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks!" => "Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks!",
// "Changes on Task" => "Changes on Task",
// "You received a new task" => "You received a new task",
// "The priority is" => "The priority is",
// "very low" => "very low",
// "low" => "low",
// "high" => "high",
// "very high" => "very high",
// "You've to start your work at least on" => "You've to start your work at least on",
// "You've to finish your work on" => "You've to finish your work on",
// "Login and click the link below" => "Login and click the link below",
// "Please read the task and work on it!" => "Please read the task and work on it!",
// "Sorry, there was an error while trying to write data into the database" => "Sorry, there was an error while trying to write data into the database",
// "Language watch" => "Language watch",
// "Cannot upload this file not enough quota" => "Cannot upload this file not enough quota",
// "Non-existent user" => "Non-existent user",
// "No banner indicated" => "No banner indicated",
// "No blog indicated" => "No blog indicated",
// "Permission denied you cannot remove the post" => "Permission denied you cannot remove the post",
// "Permission denied: you cannot view this blog post while it is marked private" => "Permission denied: you cannot view this blog post while it is marked private",
// "No cache information available" => "No cache information available",
// "You must suggest a question; please try again." => "You must suggest a question; please try again.",
// "No faq indicated" => "No faq indicated",
// "You are not permitted to remove someone else\\'s post!" => "You are not permitted to remove someone else\\'s post!",
// "Wrong password. Cannot post comment" => "Wrong password. Cannot post comment",
// "Please wait 2 minutes between posts" => "Please wait 2 minutes between posts",
// "No thread indicated" => "No thread indicated",
// "Incorrect thread" => "Incorrect thread",
// "A SheetId is required." => "A SheetId is required.",
// "That tracker don't use extras." => "That tracker don't use extras.",
// "No subject" => "No subject",
// "Top pages" => "Top pages",
// "Last pages" => "Last pages",
// "Tiki RSS feed for the wiki pages" => "Tiki RSS feed for the wiki pages",
// "Last modifications to the Wiki." => "Last modifications to the Wiki.",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "TikiTests Edit" => "TikiTests Edit",
// "You are about to delete a TikiTest file, do you want to continue ?" => "You are about to delete a TikiTest file, do you want to continue ?",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// "The page is empty" => "The page is empty",
// ### end of untranslated words
// ###

// ###
// ### start of possibly untranslated words
// ###

// ###
// ### end of possibly untranslated words
// ###

"Display Tiki objects that have not been categorized" => "Display Tiki objects that have not been categorised",
"Categorize" => "Categorise",
"categorize this object" => "categorise this object",
"Your account request have been stored and will be activated by the admin as soon as possible." => "Your account request has been stored and will be activated by the admin as soon as possible.",
"Colored text" => "Coloured text",
"%m/%d/%Y [%H:%M]" => "%d/%m/%Y [%H:%M]",
"%m/%d" => "%d/%m",
"###end###"=>"###end###");
?>
